#include <stdio.h>
#include <d3dx9.h>
#include <time.h>
#include "include\\dx9wrapper.h"

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_Boid"
#define MYWNDCLASS		"CLASS_DX9_Boid"
#define WIDTH			640 			// ʂ̉TCY
#define HEIGHT			480 			// ʂ̏cTCY
#define FISH_NUM		10				// 

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
CBoid					g_boid;
CFileECT				g_meshEct;
ANIMSET 				g_as;
int 					g_idx_motion = 0;

HRESULT InitD3D(HWND hWnd);
void	InitGeometry();
void	SetupMatrices();
void	Set_Light();
void	Draw_Main();
void	Motion_Count();
void	Set_FullPath(char *path, char *filename);
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		{
			if(FAILED(InitD3D(hWnd))){
				MessageBox(hWnd,"D3D9̏Ɏs܂",MYWNDTITLE,0);
				SendMessage(hWnd,WM_CLOSE,0,0);
				return 0;
			}
			// ^C}[ݒ
			SetTimer(hWnd, 1, 100, NULL);
		}
		break;
		
	case WM_TIMER:
		Draw_Main();	// IuWFNg`
		break;
		
	case WM_KEYDOWN:
		switch (wParam)
		{
		case VK_ESCAPE: // [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);		// ^C}[
		DestroyWindow(hWnd);
		Cleanup();				// Direct3D IuWFNg
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory(&g_d3dpp, sizeof(g_d3dpp));
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	
	// D3D9Device 쐬
	if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_HARDWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev))){
		if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
			if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
				return E_FAIL;
			}
		}
	}
	
	// ݒ
	InitGeometry();
	
	return S_OK;
}//InitD3D

// ݒ菉
void InitGeometry()
{
	// JOݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// eNX` tB^ݒ
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	// {Ch
	BOIDINIT inf;
	inf.iBoidNum	= FISH_NUM; // {Ch
	inf.fkSight 	= 0.20f;	// ̃{Ch鋗
	inf.fkFrontCos	= - 0.9f;	// ̃{Chpx
	inf.fkDt		= 0.02f;	// Pʎԓ̈ړ
	inf.fkGain1 	= 0.5f; 	// EWi傫قǗj
	inf.fkGain2 	= 2.0f; 	// Wi傫قǓɌj
	inf.fkGain3 	= 6.0f; 	// WWi傫قǋ߂Âj
	inf.fkGainFv	= 1.0f; 	// SCWi傫قǕ]xj
	inf.fkM 		= 1.0f; 	// 
	g_boid.Init(inf);
	// {Ch̍WƑx̏
	int i;
	srand((unsigned)time(NULL));
	for(i=0; i<inf.iBoidNum; i++){
		BOID inf;
		inf.pos.x = (float)rand() / RAND_MAX * 0.4f - 0.2f;
		inf.pos.y = (float)rand() / RAND_MAX * 0.4f - 0.2f;
		inf.pos.z = (float)rand() / RAND_MAX * 0.4f - 0.2f;
		inf.v.x   = (float)rand() / RAND_MAX * 0.2f - 0.1f;
		inf.v.y   = (float)rand() / RAND_MAX * 0.2f - 0.1f;
		inf.v.z   = (float)rand() / RAND_MAX * 0.2f - 0.1f;
		inf.radian_x = inf.radian_y = 0;
		g_boid.SetBoidData(i, inf);
	}
	// ECTt@Cǂݍ
	char path[MAX_PATH];
	Set_FullPath(path, "fish.ect");
	g_meshEct.Load(g_pD3DDev, path, FVF_VERTEX_BNT);
	// ECTt@C̃[Vԓǂݍ
	g_as = g_meshEct.GetAnimSet(0);
	// ϊsݒ
	SetupMatrices();
	// Ɩݒ
	Set_Light();
}// InitGeometry

// ϊsݒ
void SetupMatrices()
{
	// r[s
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView, &D3DXVECTOR3(0,0,-1.0f), &D3DXVECTOR3(0,0,0), &D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW, &matView);
	// vWFNVs
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj, 60.0f * D3DX_PI / 180.0f, (float)WIDTH/HEIGHT, 0.01f, 10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION, &matProj);
}// SetupMatrices

// Ɩݒ
void Set_Light()
{
	D3DLIGHT9	light;
	
	ZeroMemory(&light, sizeof(D3DLIGHT9));
	light.Type		 = D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r  = 1.0f;
	light.Diffuse.g  = 1.0f;
	light.Diffuse.b  = 1.0f;
	light.Specular.r = 1.0f;
	light.Specular.g = 1.0f;
	light.Specular.b = 1.0f;
	light.Direction = D3DXVECTOR3(0.577350f,-0.577350f,0.577350f);
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x00000000);
}// Set_Light

// `
void Draw_Main()
{
	// obNobt@NA
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	// `Jn
	if(SUCCEEDED(g_pD3DDev->BeginScene()))
	{
		int 		i;
		BOID		inf;
		D3DXMATRIX	matWorld,matT,matRX,matRY;
		static float kRoomW 	= 1.0f; 		// ړ\͈́ij
		static float kRoomH 	= 0.5f; 		// ړ\͈́ij
		static float kRoomD 	= 1.0f; 		// ړ\͈́isj
		static	D3DXVECTOR3 pos_pre[FISH_NUM];	// Öʒu
		// {Ch̍WƕZo
		g_boid.CalcBoids();
		// {Ch̕`
		for(i=0; i<FISH_NUM; i++){
			// {Ch擾
			inf = g_boid.GetBoidData(i);
			// {Ch̍Wƕݒ
			D3DXMatrixRotationX(&matRX, inf.radian_x);
			D3DXMatrixRotationY(&matRY, inf.radian_y);
			D3DXMatrixTranslation(&matT, inf.pos.x, inf.pos.y, inf.pos.z);
			matWorld = matRX * matRY * matT;
			g_pD3DDev->SetTransform(D3DTS_WORLD, &matWorld);
			// {Ch`
			g_meshEct.Render(g_pD3DDev);
			Motion_Count();
			// {Chړ\͈͔
			if(fabs(inf.pos.x) > kRoomW / 2){
				inf.v.x = - inf.v.x;
				inf.pos.x = pos_pre[i].x;
			}
			if(fabs(inf.pos.y) > kRoomH / 2){
				inf.v.y = - inf.v.y;
				inf.pos.y = pos_pre[i].y;
			}
			if(fabs(inf.pos.z) > kRoomD / 2){
				inf.v.z = - inf.v.z;
				inf.pos.z = pos_pre[i].z;
			}
			g_boid.SetBoidData(i, inf);
			pos_pre[i] = inf.pos;
		}
		// `I
		g_pD3DDev->EndScene();
		g_pD3DDev->SetTexture(0, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);

	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// \郂[V̔ԍvZ
void Motion_Count()
{
	g_idx_motion ++;
	
	if(g_idx_motion > g_as.iEnd){
		g_idx_motion = g_as.iStart;
	}
	g_meshEct.SetMotionIndex(g_idx_motion);
}// Motion_Count

// t@CɎst@C̃pXt
// path 	: [OUT] tpX
// filename : [IN]	t@C
void Set_FullPath(char path[MAX_PATH], char *filename)
{
	GetModuleFileName(NULL, path, MAX_PATH);
	char *p = strrchr(path, '\\');
	if(p+1)
		strcpy(p+1, filename);
}// Set_FullPath

// IuWFNg
void Cleanup()
{
	// Direct3D IuWFNg
	SAFE_RELEASE(g_pD3DDev);
	SAFE_RELEASE(g_pD3D);
}// Cleanup
