#include <stdio.h>
#include <d3dx9.h>
#include "include\\dx9wrapper.h"

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_BumpLens"
#define MYWNDCLASS		"CLASS_DX9_BumpLens"
#define WIDTH			640 			// ʂ̉TCY
#define HEIGHT			480 			// ʂ̏cTCY

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPD3DXSPRITE			g_pSpr = NULL;		// XvCg
LPDIRECT3DTEXTURE9		g_pTexSpr = NULL;	// eNX`(XvCgp)
CBumpLens	g_BumpLens;
bool		g_flagFile = false; // \[X摜tOifalse:쐬Atrue:t@Cj

HRESULT InitD3D(HWND hWnd);
void	InitGeometry();
void	SetupMatrices();
void	Draw_Main();
void	Set_FullPath(char *path, char *filename);
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		{
			if(FAILED(InitD3D(hWnd))){
				MessageBox(hWnd,"D3D9̏Ɏs܂",MYWNDTITLE,0);
				SendMessage(hWnd,WM_CLOSE,0,0);
				return 0;
			}
			// ^C}[ݒ
			SetTimer(hWnd, 1, 100, NULL);
		}
		break;
		
	case WM_TIMER:
		Draw_Main();	// IuWFNg`
		break;
		
	case WM_KEYDOWN:
		switch (wParam)
		{
		case VK_SPACE:			// [Xy[X] L[ƃ\[X摜؂ւ
			switch(g_flagFile)
			{
			case 0: 	// 쐬ꍇ
				{
				g_flagFile = 1;
				char path[MAX_PATH];
				Set_FullPath(path, "bump1.png");
				g_BumpLens.InitFromFile(g_pD3DDev, path, 4, g_pTexSpr);
				}
				break;
			case 1: 	// t@Cꍇ
				{
				g_flagFile = 0;
				g_BumpLens.Init(g_pD3DDev, 256, 256, g_pTexSpr);
				}
				break;
			}
			break;
		case VK_ESCAPE: // [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);		// ^C}[
		DestroyWindow(hWnd);
		Cleanup();				// Direct3D IuWFNg
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory(&g_d3dpp, sizeof(g_d3dpp));
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	
	// D3D9Device 쐬
	if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_HARDWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev))){
		if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
			if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
				return E_FAIL;
			}
		}
	}
	
	// ݒ
	InitGeometry();
	
	return S_OK;
}//InitD3D

// ݒ菉
void InitGeometry()
{
	// JOݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// eNX` tB^ݒ
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	char path[MAX_PATH];
	// XvCgpeNX`ݒ
	Set_FullPath(path, "tex1.jpg");
	D3DXCreateTextureFromFile(g_pD3DDev, path, &g_pTexSpr);
	// XvCg쐬
	D3DXCreateSprite(g_pD3DDev, &g_pSpr);
	// ovY
	g_BumpLens.Init(g_pD3DDev, 256, 256, g_pTexSpr);
	// foCX̃XvCg
	if(g_pSpr){
		g_pSpr->OnLostDevice();
		g_pSpr->OnResetDevice();
	}
	// ϊsݒ
	SetupMatrices();
}// InitGeometry

// ϊsݒ
void SetupMatrices()
{
	// r[s
	D3DXMATRIX	matView;
	D3DXVECTOR3 look(0,0,-2001.0f);
	D3DXVECTOR3 lookat(0,0,0);
	D3DXVECTOR3 lookup(0,1,0);
	D3DXMatrixLookAtLH(&matView, &look, &lookat, &lookup);
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	// vWFNVs
	D3DXMATRIX	matProj;
	float		view_rad = D3DX_PI / 4;
	float		aspect	 = (float) WIDTH / HEIGHT;
	float		nearest  = 1.0f;
	float		farthest = 3000.0f;
	D3DXMatrixPerspectiveFovLH(&matProj, view_rad, aspect, nearest, farthest);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
}// SetupMatrices

// `
void Draw_Main()
{
	// obNobt@ɕ`
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	if(SUCCEEDED(g_pD3DDev->BeginScene()))
	{
		D3DXVECTOR2 	scale;
		D3DSURFACE_DESC desc;
		g_pTexSpr->GetLevelDesc(0, &desc);
		scale.x = (float) WIDTH  / desc.Width;
		scale.y = (float) HEIGHT / desc.Height;
		g_pSpr->Draw(g_pTexSpr, NULL, &scale, NULL, 0.0f, NULL, 0xffffffff);

		static float	x = 0,y = 0,dx = 50,dy = 50;
		g_BumpLens.Render(g_pD3DDev, x, y);
		x += dx;
		y += dy;
		if(x < -800 || x > 800)
			dx = -dx;
		if(y < -500 || y > 500)
			dy = -dy;

		g_pD3DDev->EndScene();
		g_pD3DDev->SetTexture(0, NULL);
		g_pD3DDev->SetTexture(1, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// t@CɎst@C̃pXt
// path 	: [OUT] tpX
// filename : [IN]	t@C
void Set_FullPath(char *path, char *filename)
{
	GetModuleFileName(NULL, path, MAX_PATH);
	char *p = strrchr(path, '\\');
	if(p+1)
		strcpy(p+1, filename);
}// Set_FullPath

// IuWFNg
void Cleanup()
{
	// Direct3D IuWFNg
	SAFE_RELEASE(g_pTexSpr);
	SAFE_RELEASE(g_pSpr);
	SAFE_RELEASE(g_pD3DDev);
	SAFE_RELEASE(g_pD3D);
}// Cleanup
