#include <stdio.h>
#include <d3dx9.h>
#include "include\\dx9wrapper.h"

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_CubeMap"
#define MYWNDCLASS		"CLASS_DX9_CubeMap"
#define WIDTH			640 			// ʂ̉TCY
#define HEIGHT			480 			// ʂ̏cTCY

class CCubeMap2 : public CCubeMap
{
public:
	~CCubeMap2() {};
	HRESULT RenderScene(LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX matWorld,
						D3DXMATRIX matT, D3DXMATRIX matRY);
};

LPDIRECT3D9				g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
CCubeMap2				g_cubemap;				// L[u}bv IuWFNg
CFileX					g_meshSkyBox;			// XJC{bNX bV
LPD3DXMESH				g_pMeshTeaPot = NULL;	// eB[|bg bV
float					g_roll = 0;				// _Y]px (x)
D3DXVECTOR3				g_v3Roll;				// _Y]px (xNg)
D3DXVECTOR3				g_v3Step;				// 
D3DXVECTOR3				g_v3Look;				// _
D3DXVECTOR3				g_v3LookAt(0,0,0);		// eB[|bgW
const float				g_fMoveSpeed   = 1.0f;	// ړx
const float				g_fEyeDistant  = 3.0f;	// _ƒ_̋

HRESULT InitD3D(HWND hWnd);
void	InitGeometry();
void	Draw_Main();
HRESULT RenderScene2(BOOL bRenderTeapot, D3DXMATRIX matWorld,
					 D3DXMATRIX matT, D3DXMATRIX matRY);
void	Get_Key();
void	Set_FullPath(char *path, char *filename);
void	Cleanup();

HRESULT CCubeMap2::RenderScene(LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX matWorld,
							   D3DXMATRIX matT, D3DXMATRIX matRY)
{
	return RenderScene2( FALSE, matWorld, matT, matRY );
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		{
			if(FAILED(InitD3D(hWnd))){
				MessageBox(hWnd,"D3D9̏Ɏs܂",MYWNDTITLE,0);
				SendMessage(hWnd,WM_CLOSE,0,0);
				return 0;
			}
			// ^C}[ݒ
			SetTimer(hWnd, 1, 100, NULL);
		}
		break;
		
	case WM_TIMER:
		Get_Key();		// L[͎擾
		Draw_Main();	// IuWFNg`
		break;
		
	case WM_KEYDOWN:
		switch (wParam)
		{
		case VK_ESCAPE: // [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);		// ^C}[
		DestroyWindow(hWnd);
		Cleanup();				// Direct3D IuWFNg
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory(&g_d3dpp, sizeof(g_d3dpp));
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	
	// D3D9Device 쐬
	if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_HARDWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev))){
		if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
			if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
				return E_FAIL;
			}
		}
	}
	
	// ݒ
	InitGeometry();
	
	return S_OK;
}//InitD3D

// ݒ菉
void InitGeometry()
{
	// JOݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// eNX` tB^ݒ
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	char path[MAX_PATH];
	// L[u}bv
	g_cubemap.Init(g_pD3DDev);
	// Xt@Cǂݍ݁iXJC{bNXj
	Set_FullPath(path, "cubemap_data\\lobby_skybox.x");
	g_meshSkyBox.Load(g_pD3DDev, path);
	// eB[|bg쐬
	D3DXCreateTeapot(g_pD3DDev, &g_pMeshTeaPot, NULL);
}// InitGeometry

// vWFNVsݒ
void Set_ProjectionMatrix()
{
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj, D3DX_PI * 0.4f, (float)WIDTH/HEIGHT, 0.5f, 100.0f);
	g_pD3DDev->SetTransform( D3DTS_PROJECTION, &matProj );
}// Set_ProjectionMatrix

// r[sݒ
void Set_ViewMatrix()
{
	D3DXMATRIX	matView;
	g_v3Look.x = - g_v3Roll.x * g_fEyeDistant + g_v3LookAt.x;
	g_v3Look.y = g_v3LookAt.y;
	g_v3Look.z = - g_v3Roll.z * g_fEyeDistant + g_v3LookAt.z;
	D3DXMatrixLookAtLH(&matView, &g_v3Look, &g_v3LookAt, &D3DXVECTOR3(0, 1, 0));
	g_pD3DDev->SetTransform(D3DTS_VIEW, &matView);
}// Set_ViewMatrix

// `
void Draw_Main()
{
	// L[u}bvpϊsݒ
	Set_ProjectionMatrix();
	Set_ViewMatrix();
	// eB[|bgsݒ
	D3DXMATRIX matWorld,matT,matRY;
	D3DXMatrixRotationY(&matRY, g_roll * D3DX_PI / 180);
	D3DXMatrixTranslation(&matT, g_v3LookAt.x, g_v3LookAt.y, g_v3LookAt.z);
	matWorld = matRY * matT;
	// L[u}bvɕ`
	g_cubemap.RenderSceneIntoCubeMap(g_pD3DDev, g_v3LookAt, matWorld, matT, matRY);
	// obNobt@ɕ`
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	if(SUCCEEDED(g_pD3DDev->BeginScene()))
	{
		RenderScene2( TRUE, matWorld, matT, matRY );

		g_pD3DDev->EndScene();
		g_pD3DDev->SetTexture(0, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// `
HRESULT RenderScene2(BOOL bRenderTeapot, D3DXMATRIX matWorld,
					 D3DXMATRIX matT, D3DXMATRIX matRY)
{
	BOOL	dwEnableLightPre;
	g_pD3DDev->GetLightEnable(0, &dwEnableLightPre);
	g_pD3DDev->LightEnable(0, FALSE);
	// Render the Skybox
	{
		D3DXMATRIX matS;
		D3DXMatrixScaling( &matS, 10.0f, 10.0f, 10.0f );
		g_pD3DDev->SetTransform( D3DTS_WORLD, &matS );

		g_pD3DDev->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
		g_pD3DDev->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );
		g_pD3DDev->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
		g_pD3DDev->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
		g_pD3DDev->SetSamplerState( 0, D3DSAMP_ADDRESSU,  D3DTADDRESS_MIRROR );
		g_pD3DDev->SetSamplerState( 0, D3DSAMP_ADDRESSV,  D3DTADDRESS_MIRROR );

		// Always pass Z-test, so we can avoid clearing color and depth buffers
		g_pD3DDev->SetRenderState( D3DRS_ZFUNC, D3DCMP_ALWAYS );
		g_meshSkyBox.Render(g_pD3DDev);
		g_pD3DDev->SetRenderState( D3DRS_ZFUNC, D3DCMP_LESSEQUAL );
	}

	// Render the environment-mapped ShinyTeapot
	if( bRenderTeapot ){
		g_pD3DDev->SetTransform( D3DTS_WORLD, &matWorld );

		// Turn on texture-coord generation for cubemapping
		g_pD3DDev->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR );
		g_pD3DDev->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT3 );

		// Render the object with the environment-mapped body
		g_pD3DDev->SetTexture( 0, g_cubemap.GetTexture() );
		g_pMeshTeaPot->DrawSubset(0);

		// Restore the render states
		g_pD3DDev->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_PASSTHRU );
		g_pD3DDev->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE );
	}
	g_pD3DDev->LightEnable(0, dwEnableLightPre);

	return S_OK;
}

// L[
void Get_Key()
{
	if(GetAsyncKeyState(VK_LEFT) & 0x8000){ 		// []L[ꂽƂ
		g_roll -= 5;
		if(g_roll <= 0)
			g_roll += 360;
	}
	else if(GetAsyncKeyState(VK_RIGHT) & 0x8000){	// []L[ꂽƂ
		g_roll += 5;
		if(g_roll >= 360)
			g_roll -= 360;
	}
	
	// xNg
	g_v3Roll.x = (float) sin(g_roll * D3DX_PI / 180);
	g_v3Roll.z = (float) cos(g_roll * D3DX_PI / 180);
	// 
	g_v3Step.x = g_fMoveSpeed * g_v3Roll.x;
	g_v3Step.z = g_fMoveSpeed * g_v3Roll.z;
	
	if(GetAsyncKeyState(VK_UP) & 0x8000){			// []L[ꂽƂ
		g_v3LookAt.x += g_v3Step.x;
		g_v3LookAt.z += g_v3Step.z;
	}
	else if(GetAsyncKeyState(VK_DOWN) & 0x8000){	// []L[ꂽƂ
		g_v3LookAt.x -= g_v3Step.x;
		g_v3LookAt.z -= g_v3Step.z;
	}
}// Get_Key

// t@CɎst@C̃pXt
// path 	: [OUT] tpX
// filename : [IN]	t@C
void Set_FullPath(char *path, char *filename)
{
	GetModuleFileName(NULL, path, MAX_PATH);
	char *p = strrchr(path, '\\');
	if(p+1)
		strcpy(p+1, filename);
}// Set_FullPath

// IuWFNg
void Cleanup()
{
	// Direct3D IuWFNg
	SAFE_RELEASE(g_pMeshTeaPot);
	SAFE_RELEASE(g_pD3DDev);
	SAFE_RELEASE(g_pD3D);
}// Cleanup
