#include <stdio.h>
#include <d3dx9.h>
#include "include\\dx9wrapper.h"

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE	"DX9_Wrapper"
#define MYWNDCLASS	"CLASS_DX9_Wrapper"
#define WIDTH		640 	// ʂ̉TCY
#define HEIGHT		480 	// ʂ̏cTCY

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPDIRECT3DTEXTURE9		g_pTex[2] = {0,0};
CLabyrinth				g_labyrinth;
COrder					g_order;

D3DXVECTOR3 g_v3Look;		// _W
D3DXVECTOR3 g_v3LookAt; 	// _W
int 		g_map_w = 0;	// }bv
int 		g_map_h = 0;	// }bv
D3DXVECTOR3 g_v3Step;		// 
float		g_roll	= 180;	// _̉]px (x)
D3DXVECTOR3 g_v3Roll;		// _̉]px (xNg)

const float 		g_fLightRange = 8.0f;	// Cg̓͂
const float 		g_fMoveSpeed  = 0.1f; 	// ړx
const float 		g_fEyeDistant = 0.04f; 	// _ƒ_̋
const POINT 		g_ptCellInit  = {0, 0};	// ZWix:0`g_map_w-1, y:0`g_map_h-1j
const BYTE			g_fog_red   = 16;		// tHOFiԁj
const BYTE			g_fog_green = 16;		// tHOFi΁j
const BYTE			g_fog_blue  = 16;		// tHOFij

HRESULT InitD3D(HWND hWnd);
void	InitGeometry();
void	Set_Light();
void	Set_Material();
void	Set_ViewMatrix();
void	Render();
void	Draw_Passage();
void	Get_Key();
void	Left();
void	Top();
void	Right();
void	Down();
bool	Load_Texture(int index, char *filename);
void	Set_FullPath(char *path, char *filename);
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		{
			if(FAILED(InitD3D(hWnd))){
				MessageBox(hWnd,"D3D9̏Ɏs܂",MYWNDTITLE,0);
				SendMessage(hWnd,WM_CLOSE,0,0);
				return 0;
			}
			SetTimer(hWnd, 1, 100, NULL);
		}
		break;
		
	case WM_TIMER:
		Get_Key();		// L[͎擾
		Render();
		break;
		
	case WM_KEYDOWN:
		switch (wParam)
		{
		case VK_ESCAPE: // [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);
		DestroyWindow(hWnd);
		Cleanup();
		PostQuitMessage(0);
		break;
		
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	if(hWnd == NULL)
		return 0;
	
	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory(&g_d3dpp, sizeof(g_d3dpp));
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	
	// D3D9Device 쐬
	if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_HARDWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev))){
		if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
			if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
				return E_FAIL;
			}
		}
	}
	
	// ݒ
	InitGeometry();
	
	return S_OK;
}//InitD3D

// 
void InitGeometry()
{
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE,  TRUE);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);
	g_pD3DDev->SetFVF(FVF_VERTEX_NT);
	
	// vWFNVs
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj, 60.0f * D3DX_PI / 180.0f, (float)WIDTH/HEIGHT, 0.01f, 10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION, &matProj);
	
	// {NX
	LABYRINTH inf;
	inf.fLightRange = g_fLightRange;
	inf.fMoveSpeed	= g_fMoveSpeed;
	Set_FullPath(inf.strMapFilename, "sample.map");
	Set_FullPath(inf.strPassEctFilename, "passage.ect");
	g_labyrinth.Init(g_pD3DDev, &inf);
	float fPassageSize   = g_labyrinth.GetPassageSize();	// PʘHTCY
	float fPassageHeight = g_labyrinth.GetPassageHeight();	// PʘH
	D3DXVECTOR3	v3PosInit;	// ZWix,z:0.0f`fPassageSize, y:0.0f`fPassageHeightj
	v3PosInit.x = v3PosInit.z = fPassageSize / 2;
	v3PosInit.y = fPassageHeight / 2;
	
	// ёւNX
	g_map_w = g_labyrinth.GetMapWidth();
	g_map_h = g_labyrinth.GetMapHeight();
	g_order.Init(g_map_w * g_map_h);
	
	// _̏ʒu
	g_v3LookAt.x = g_ptCellInit.x * fPassageSize + v3PosInit.x;
	g_v3LookAt.y = v3PosInit.y;
	g_v3LookAt.z = (-g_ptCellInit.y + g_map_h) * fPassageSize - v3PosInit.z;
	
	// eNX`ǂݍ
	char filename[MAX_PATH];
	Set_FullPath(filename, "env2.jpg");
	Load_Texture(0, filename);
	Set_FullPath(filename, "ground2.jpg");
	Load_Texture(1, filename);
	
	// tHOݒ
	CFog fog;
	fog.SetPixelFog(g_pD3DDev, D3DCOLOR_XRGB(g_fog_red,g_fog_green,g_fog_blue), 0.1f, g_fLightRange - fPassageSize);
}// InitGeometry

// Ɩݒ
void Set_Light()
{
	D3DLIGHT9	light;
	
	ZeroMemory(&light, sizeof(D3DLIGHT9));
	light.Type			= D3DLIGHT_SPOT;	// Cg̎ށiX|bgCgj
	light.Position		= g_v3Look; 		// Cg̈ʒu
	light.Direction 	= g_v3Roll; 		// Cǧ
	light.Range 		= g_fLightRange;	// Cg̓͂
	light.Theta 		= 10.0f; 			// R[px
	light.Phi			= 30.0f; 			// OR[px
	light.Falloff		= 1.0f; 			// OR[Ԃ̌W
	light.Attenuation2	= 0.1f; 			// ɂ錸W
	light.Diffuse.r = light.Specular.r = 1.0f;
	light.Diffuse.g = light.Specular.g = 1.0f;
	light.Diffuse.b = light.Specular.b = 1.0f;
	
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x00202020);
	g_pD3DDev->SetRenderState(D3DRS_SPECULARENABLE, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL);
}// Set_Light

// }eAݒ
void Set_Material()
{
	D3DMATERIAL9 mtrl;

	ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
	mtrl.Diffuse.a = mtrl.Ambient.a = 1.0f;
	mtrl.Diffuse.r = mtrl.Ambient.r = 1.0f;
	mtrl.Diffuse.g = mtrl.Ambient.g = 1.0f;
	mtrl.Diffuse.b = mtrl.Ambient.b = 1.0f;
	
	// }eAKp
	g_pD3DDev->SetMaterial(&mtrl);
	
}// Set_Material

// r[sݒ
void Set_ViewMatrix()
{
	D3DXMATRIX	matView;
	g_v3Look.x = - g_v3Roll.x * g_fEyeDistant + g_v3LookAt.x;
	g_v3Look.y = g_v3LookAt.y;
	g_v3Look.z = - g_v3Roll.z * g_fEyeDistant + g_v3LookAt.z;
	D3DXMatrixLookAtLH(&matView, &g_v3Look, &g_v3LookAt, &D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW, &matView);
}// Set_ViewMatrix

// `
void Render()
{
	// obNobt@ɕ`
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(g_fog_red,g_fog_green,g_fog_blue),1.0f,0);
	if(SUCCEEDED(g_pD3DDev->BeginScene()))
	{
		Set_ViewMatrix();	// r[sݒ
		
		Set_Light();		// Cgݒ
		
		Set_Material(); 	// }eAݒ
		
		Draw_Passage(); 	// ʘH`
		
		g_pD3DDev->EndScene();
		g_pD3DDev->SetTexture(0, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Render();
	}
}// Render

// ʘH`
void Draw_Passage()
{
	// ʘH
	g_labyrinth.VisiblePassage(&g_order, g_v3LookAt, g_roll);
	// `揇ݒ
	g_labyrinth.SetOrder(&g_order);
	g_order.Sort();
	// ǂƓV̕`
	int order;
	g_pD3DDev->SetTexture(0, g_pTex[0]);
	for(order=0; order<g_order.GetCount(); order++){
		D3DXVECTOR3 pos = g_order.GetPos(order);
		g_labyrinth.DrawWall(g_pD3DDev, (int) pos.x, (int) pos.z);
		g_labyrinth.DrawCeiling(g_pD3DDev, (int) pos.x, (int) pos.z);
	}
	// ̕`
	g_pD3DDev->SetTexture(0, g_pTex[1]);
	for(order=0; order<g_order.GetCount(); order++){
		D3DXVECTOR3 pos = g_order.GetPos(order);
		g_labyrinth.DrawFloor(g_pD3DDev, (int) pos.x, (int) pos.z);
	}
}// Draw_Passage

// L[
void Get_Key()
{
	if(GetAsyncKeyState(VK_LEFT) & 0x8000){ 		// []L[ꂽƂ
		Left();
	}
	else if(GetAsyncKeyState(VK_RIGHT) & 0x8000){	// []L[ꂽƂ
		Right();
	}
	
	// xNg
	float roll = g_roll * D3DX_PI / 180;
	g_v3Roll.x = (float) sin(roll);
	g_v3Roll.z = (float) cos(roll);
	// 
	g_v3Step.x = g_fMoveSpeed * g_v3Roll.x;
	g_v3Step.z = g_fMoveSpeed * g_v3Roll.z;
	
	if(GetAsyncKeyState(VK_UP) & 0x8000){			// []L[ꂽƂ
		Top();
	}
	else if(GetAsyncKeyState(VK_DOWN) & 0x8000){	// []L[ꂽƂ
		Down();
	}
}// Get_Key

// ɐ
void Left()
{
	g_roll -= 5;
	if(g_roll <= 0)
		g_roll += 360;
}// Left

// Eɐ
void Right()
{
	g_roll += 5;
	if(g_roll >= 360)
		g_roll -= 360;
}// Right

// Oi
void Top()
{
	g_v3LookAt.x += g_v3Step.x;
	g_v3LookAt.z += g_v3Step.z;
	if(g_labyrinth.HitTest(g_v3LookAt.x, g_v3LookAt.z)){
		g_v3LookAt.x -= g_v3Step.x;
		g_v3LookAt.z -= g_v3Step.z;
	}
}// Top

// 
void Down()
{
	g_v3LookAt.x -= g_v3Step.x;
	g_v3LookAt.z -= g_v3Step.z;
	if(g_labyrinth.HitTest(g_v3LookAt.x, g_v3LookAt.z)){
		g_v3LookAt.x += g_v3Step.x;
		g_v3LookAt.z += g_v3Step.z;
	}
}// Down

// eNX`ǂݍ
bool Load_Texture(int index, char *filename)
{
	if(FAILED(D3DXCreateTextureFromFile(g_pD3DDev, filename, &g_pTex[index])))
	{
		g_pTex[index] = NULL;
		return false;
	}
	return true;
}// Load_Texture

// t@CɎst@C̃pXt
// path 	: [OUT] tpX
// filename : [IN]	t@C
void Set_FullPath(char *path, char *filename)
{
	GetModuleFileName(NULL, path, MAX_PATH);
	char *p = strrchr(path, '\\');
	if(p+1)
		strcpy(p+1, filename);
}// Set_FullPath

// IuWFNg
void Cleanup()
{
	int i;
	for(i=0; i<2; i++){
		SAFE_RELEASE(g_pTex[i]);
	}
	SAFE_RELEASE(g_pD3DDev);
	SAFE_RELEASE(g_pD3D);
}// Cleanup
