#include <stdio.h>
#include <d3dx9.h>
#include "include\\dx9wrapper.h"

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE	"DX9_Text"
#define MYWNDCLASS	"CLASS_DX9_Text"
#define WIDTH		640 	// ʂ̉TCY
#define HEIGHT		480 	// ʂ̏cTCY

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
CText					g_text;
LPD3DXSPRITE			g_pSpr = NULL;		// XvCg
LPDIRECT3DTEXTURE9		g_pTexSpr = NULL;	// eNX`(XvCgp)

HRESULT InitD3D(HWND hWnd);
void	InitGeometry();
void	Render();
void	Set_FullPath(char *path, char *filename);
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		{
			if(FAILED(InitD3D(hWnd))){
				MessageBox(hWnd,"D3D9̏Ɏs܂",MYWNDTITLE,0);
				SendMessage(hWnd,WM_CLOSE,0,0);
				return 0;
			}
			SetTimer(hWnd, 1, 100, NULL);
		}
		break;
		
	case WM_TIMER:
		Render();
		break;
		
	case WM_KEYDOWN:
		switch (wParam)
		{
		case VK_ESCAPE: // [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);
		DestroyWindow(hWnd);
		Cleanup();
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory(&g_d3dpp, sizeof(g_d3dpp));
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	
	// D3D9Device 쐬
	if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_HARDWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev))){
		if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
			if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
										  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										  &g_d3dpp, &g_pD3DDev))){
				return E_FAIL;
			}
		}
	}
	
	// ݒ
	InitGeometry();
	
	return S_OK;
}//InitD3D

// 
void InitGeometry()
{
	// JOݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// eNX` tB^ݒ
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	// xݒ
	g_pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA);
	g_pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
	char path[MAX_PATH];
	// eLXg NX
	LOGFONT lFont;
	ZeroMemory(&lFont, sizeof(lFont));
	lstrcpy(lFont.lfFaceName, "lr oSVbN");
	lFont.lfWeight			= FW_BOLD;
	lFont.lfCharSet 		= SHIFTJIS_CHARSET;
	lFont.lfPitchAndFamily	= FIXED_PITCH;
	g_text.Init(g_pD3DDev, 640, 240, lFont, D3DCOLOR_ARGB(180,0,0,0));
	// wipeNX`ݒ
	Set_FullPath(path, "tex1.jpg");
	D3DXCreateTextureFromFile(g_pD3DDev, path, &g_pTexSpr);
	// XvCg쐬
	D3DXCreateSprite(g_pD3DDev, &g_pSpr);
	// foCX̃XvCg
	if(g_pSpr){
		g_pSpr->OnLostDevice();
		g_pSpr->OnResetDevice();
	}
}// InitGeometry

// `
void Render()
{
	// eNX`Ƀ_O
	// ́AobNobt@`撆ɂ͎sȂ悤ɂ
	static char str[1024] = "ABCDEFG\n";
	RECT rc = {10, 10, g_text.GetWidth() - 10, g_text.GetHeight() - 10};
	g_text.RenderToTexture(g_pD3DDev, str, &rc, 32, D3DCOLOR_ARGB(255,255,255,255));
	// obNobt@ɕ`
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	if(SUCCEEDED(g_pD3DDev->BeginScene()))
	{
		// XvCg`Jn
		if(SUCCEEDED(g_pSpr->Begin())){
			// wi`
			D3DXVECTOR2 	scale;
			D3DSURFACE_DESC desc;
			g_pTexSpr->GetLevelDesc(0, &desc);
			scale.x = (float) WIDTH  / desc.Width;
			scale.y = (float) HEIGHT / desc.Height;
			g_pSpr->Draw(g_pTexSpr, NULL, &scale, NULL, 0.0f, NULL, 0xffffffff);
			// `
			g_pSpr->Draw(g_text.GetTexture(), NULL, NULL, NULL, 0.0f, &D3DXVECTOR2(0,240), 0xffffffff);
			// XvCg`I
			g_pSpr->End();
		}
		
		g_pD3DDev->EndScene();
		g_pD3DDev->SetTexture(0, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Render();
	}
}// Render

// t@CɎst@C̃pXt
// path 	: [OUT] tpX
// filename : [IN]	t@C
void Set_FullPath(char *path, char *filename)
{
	GetModuleFileName(NULL, path, MAX_PATH);
	char *p = strrchr(path, '\\');
	if(p+1)
		strcpy(p+1, filename);
}// Set_FullPath

// IuWFNg
void Cleanup()
{
	// Direct3D IuWFNg
	SAFE_RELEASE(g_pTexSpr);
	SAFE_RELEASE(g_pSpr);
	SAFE_RELEASE(g_pD3DDev);
	SAFE_RELEASE(g_pD3D);
}// Cleanup
