// {Ch
// l^Fu} OpenGLɂ 3CGAj[Vv I[
#ifndef _BOID_H_
#define _BOID_H_

#include <d3dx9.h>
#include "macro.h"

typedef struct{
	D3DXVECTOR3 pos;			// ʒu
	D3DXVECTOR3 v;				// isƑxxNg
	float		radian_x;		// X]px
	float		radian_y;		// Y]px
}BOID,*LPBOID;

typedef struct{
	int 	iBoidNum;	// {Ch
	float	fkSight;	// ̃{Ch鋗
	float	fkFrontCos; // ̃{Chpx
	float	fkDt;		// Pʎԓ̈ړ
	float	fkGain1;	// EWi傫قǗj
	float	fkGain2;	// Wi傫قǕԁj
	float	fkGain3;	// WWi傫قǋ߂Âj
	float	fkGainFv;	// SCWi傫قǕ]xj
	float	fkM;		// 
}BOIDINIT,*LPBOIDINIT;

class CBoid
{
public:
	CBoid();
	~CBoid();
	HRESULT Init(BOIDINIT inf);
	void	Free();
	void	CalcBoids();
	int 	GetBoidCount()			{ return m_inf.iBoidNum; }
	BOID	GetBoidData(int index)	{	BOID boid;
										ZeroMemory(&boid, sizeof(boid));
										if(m_boid && index >= 0 && index < m_inf.iBoidNum)
											boid = m_boid[index];
										return boid;
									}
	void	SetBoidData(int index, BOID inf)
									{
										if(m_boid && index >= 0 && index < m_inf.iBoidNum)
											m_boid[index] = inf;
									}
	
private:
	BOIDINIT	m_inf;
	LPBOID		m_boid;

private:
	float	GetDist(int index1, int index2);
	float	GetSight(int index1, int index2);
};

CBoid::CBoid()
{
	m_boid = NULL;
}

CBoid::~CBoid()
{
	Free();
}

// 
// inf	F [IN] {Ch
HRESULT CBoid::Init(BOIDINIT inf)
{
	Free();
	m_inf = inf;
	m_boid = new BOID [m_inf.iBoidNum];
	if(!m_boid || !m_inf.iBoidNum){
		return E_OUTOFMEMORY;
	}
	return S_OK;
}

// I
void CBoid::Free()
{
	SAFE_DELETE_ARRAY(m_boid);
}

// {Ch f[^Zo
void CBoid::CalcBoids()
{
	if(!m_boid || !m_inf.iBoidNum){
		return;
	}
	
	int 	i,j;
	float	dist;
	
	for(i=0;i<m_inf.iBoidNum;i++){
		float	fx = 0,fy = 0,fz = 0;
		float	gx = 0,gy = 0,gz = 0;
		int 	num_boids = 0;		// 鑼̃{Ch
		for(j=0;j<m_inf.iBoidNum;j++){
			if(i != j){
				float d = GetDist(i, j);
				float c = GetSight(i, j);
				if(d > m_inf.fkSight)		continue;	// ̃{Chꍇ
				if(c < m_inf.fkFrontCos)	continue;	// ̃{ChȌꍇ
				// Eĩ{Ch痣j
				fx -= m_inf.fkGain1 * ((m_boid[j].pos.x - m_boid[i].pos.x) / d / d);
				fy -= m_inf.fkGain1 * ((m_boid[j].pos.y - m_boid[i].pos.y) / d / d);
				fz -= m_inf.fkGain1 * ((m_boid[j].pos.z - m_boid[i].pos.z) / d / d);
				// 񑥁ĩ{ChƓpj
				fx += m_inf.fkGain2 * (m_boid[j].v.x - m_boid[i].v.x);
				fy += m_inf.fkGain2 * (m_boid[j].v.y - m_boid[i].v.y);
				fz += m_inf.fkGain2 * (m_boid[j].v.z - m_boid[i].v.z);
				// W̏
				gx += m_boid[j].pos.x;
				gy += m_boid[j].pos.y;
				gz += m_boid[j].pos.z;
				num_boids ++;
			}
		}
		if(num_boids){
			// WiW܂j
			float dgx = gx / num_boids - m_boid[i].pos.x;
			float dgy = gy / num_boids - m_boid[i].pos.y;
			float dgz = gz / num_boids - m_boid[i].pos.z;
			float dg = (float) sqrt(dgx * dgx + dgy * dgy + dgz * dgz);
			fx += m_inf.fkGain3 * dgx / dg;
			fy += m_inf.fkGain3 * dgy / dg;
			fz += m_inf.fkGain3 * dgz / dg;
		}
		// SC
		fx -= m_inf.fkGainFv * m_boid[i].v.x;
		fy -= m_inf.fkGainFv * m_boid[i].v.y;
		fz -= m_inf.fkGainFv * m_boid[i].v.z;
		// xꍇ́Ax
		dist = m_boid[i].v.x * m_boid[i].v.x + m_boid[i].v.y * m_boid[i].v.y + m_boid[i].v.z * m_boid[i].v.z;
		if(dist < 0.1){
			fx += m_boid[i].v.x;
			fy += m_boid[i].v.y;
			fz += m_boid[i].v.z;
		}
		// ʒu
		m_boid[i].pos.x += m_boid[i].v.x * m_inf.fkDt;
		m_boid[i].pos.y += m_boid[i].v.y * m_inf.fkDt;
		m_boid[i].pos.z += m_boid[i].v.z * m_inf.fkDt;
		// x
		m_boid[i].v.x += fx / m_inf.fkM * m_inf.fkDt;
		m_boid[i].v.y += fy / m_inf.fkM * m_inf.fkDt;
		m_boid[i].v.z += fz / m_inf.fkM * m_inf.fkDt;
		// ]px
		m_boid[i].radian_x = -(float)atan2(m_boid[i].v.y, sqrt(m_boid[i].v.x * m_boid[i].v.x + m_boid[i].v.z * m_boid[i].v.z));
		m_boid[i].radian_y =  (float)atan2(m_boid[i].v.x, m_boid[i].v.z);
	}
}// CalcBoids

// ̃{ChƂ̋
// index1, index2: {Chԍ
float CBoid::GetDist(int index1, int index2)
{
	float dx,dy,dz;
	
	dx = m_boid[index1].pos.x - m_boid[index2].pos.x;
	dy = m_boid[index1].pos.y - m_boid[index2].pos.y;
	dz = m_boid[index1].pos.z - m_boid[index2].pos.z;
	
	return ((float) sqrt(dx * dx + dy * dy + dz * dz));
}// GetDist

// ̃{ChƂ̊px
// index1, index2: {Chԍ
float CBoid::GetSight(int index1, int index2)
{
	float v,vx,vy,vz;
	float d,dx,dy,dz;
	
	vx = m_boid[index1].v.x;
	vy = m_boid[index1].v.y;
	vz = m_boid[index1].v.z;
	v = (float) sqrt(vx * vx + vy * vy + vz * vz);
	d = GetDist(index1, index2);
	dx = m_boid[index1].pos.x - m_boid[index2].pos.x;
	dy = m_boid[index1].pos.y - m_boid[index2].pos.y;
	dz = m_boid[index1].pos.z - m_boid[index2].pos.z;
	
	return (dx * vx + dy * vy + dz * vz) / v / d;
}// GetSight

#endif