///////////////////////////////////////////////////////////////////////////
//	DIB_BUFFER	CLASS		
//									Programmed by m.minami				
///////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include "dib_buf.h"

//
//
//					   @chaobt@ǗNX	  
//
//
////////////////////////////////////////////////////////////////////////////
//	֐	F	CDib::CDib
//	TvF	RXgN^iwBMPt@CDIBobt@𐶐j
//		F	*file_name	BMPt@Cl[
//			F	 color		J[L[
//	o	F	
////////////////////////////////////////////////////////////////////////////
CDib::CDib(char *file_name, WORD color)
{
	m_hbmp		= NULL;  
	m_hdc		= NULL;  
	m_pitch_tbl = NULL;
	m_colkey	= color;

	// BMPt@C[h
	LoadFile(file_name);
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	CDib::CDib
//	TvF	RXgN^iwTCYDIBobt@𐶐j
//		F	width		obt@TCY
//			F	height		obt@cTCY
//	o	F	
////////////////////////////////////////////////////////////////////////////
CDib::CDib(int width, int height)
{
	m_hbmp		= NULL;  
	m_hdc		= NULL;  
	m_pitch_tbl = NULL;
	m_colkey	= COLOKEY_NONE;
	
	// DIB
	CreateDib(width, height);
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	CDib::LoadFile
//	TvF	rbg}bv[h֐
//			F	wBMPt@CDIBobt@𐶐
//		F	*file_name	BMPt@Cl[
//	o	F	
////////////////////////////////////////////////////////////////////////////
bool CDib::LoadFile(char *file_name)
{
	//rbg}bv[h
	HBITMAP hBitmap;
	BITMAP	BitMap;

	hBitmap = (HBITMAP)LoadImage(NULL, file_name, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (hBitmap == NULL) return false;

	// rbg}bṽTCY擾
	GetObject(hBitmap, sizeof(BitMap), &BitMap);
			
	// Dib쐬
	CreateDib(BitMap.bmWidth, BitMap.bmHeight);
	
	// rbg}bvDibɃRs[
	HDC 	hdcBitmap;
	HBITMAP hbmOld;

	hdcBitmap = CreateCompatibleDC(NULL);
	hbmOld = (HBITMAP)SelectObject(hdcBitmap, hBitmap);

	BitBlt(m_hdc, 0, 0, BitMap.bmWidth, BitMap.bmHeight, hdcBitmap, 0, 0, SRCCOPY);

	SelectObject(hdcBitmap, hbmOld);
	DeleteDC(hdcBitmap);
	DeleteObject(hBitmap);

	return true;
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	CDib::CreateDib
//	TvF	DIBobt@𐶐
//		F	width		obt@TCY
//			F	height		obt@cTCY
//	o	F	wTCYDIBobt@𐶐
////////////////////////////////////////////////////////////////////////////
void CDib::CreateDib(int width, int height)
{
	BITMAPINFO	bi;
	
	m_width  = width;
	m_height = height;

	memset(&bi,0,sizeof(bi));
	bi.bmiHeader.biSize 		= sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth		= width;
	bi.bmiHeader.biHeight		= -(long)height;
	bi.bmiHeader.biPlanes		= 1;
	bi.bmiHeader.biBitCount 	= 16;
	bi.bmiHeader.biCompression	= BI_RGB;//0L
	bi.bmiHeader.biSizeImage	= 0;
	bi.bmiHeader.biXPelsPerMeter= 0;
	bi.bmiHeader.biYPelsPerMeter= 0;
	bi.bmiHeader.biClrImportant = 0;
	bi.bmiHeader.biClrUsed		= 0;
	
	// 16BIT DIB 
	m_hbmp		= (HBITMAP)CreateDIBSection(NULL, &bi, DIB_PAL_COLORS, (VOID **)&m_buf, NULL, 0);
	m_pitch 	= width*2 + ((width & 1) ? 2: 0);	// 32 BITEɂ낦܂					
	memset(m_buf, 0, width * height);				// WORD ͂QoCg

	// DIB ̃foCXReLXg擾
	HDC hDC = GetDC(NULL);
	m_hdc = CreateCompatibleDC(hDC);
	SelectObject(m_hdc, m_hbmp);
	ReleaseDC(NULL, hDC);

	// 炩ߏcC̊Jnʒu߂ĂvZ
	m_pitch_tbl = new int[height];	
	for (int i = 0; i < height; i++) {
		m_pitch_tbl[i] = m_pitch * i;
	}
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	CDib::~CDib
//	TvF	fXgN^imۂobt@Jj
//		F	
//	o	F	
////////////////////////////////////////////////////////////////////////////
CDib::~CDib()
{
	if (m_pitch_tbl) delete [] m_pitch_tbl;
	if (m_hdc)		 DeleteDC(m_hdc);
	if (m_hbmp) 	 DeleteObject(m_hbmp);
}

//
//
//					   @@cha`n֐ 	
//
//
////////////////////////////////////////////////////////////////////////////
//							O[oϐ
////////////////////////////////////////////////////////////////////////////
// At@uhvZɃe[ugpꍇ̓ft@C܂
// Ȃ荂ɌvZslɂȂ܂Ae[uTCYQlق
// ̂Ńɂx̗]TKvłB
#define ALPHA_TBL_USE	1

#if ALPHA_TBL_USE
WORD AlphaRateTBL[32+1][0x8000];					 // At@uhpe[u
#endif


////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_INIT
//	TvF	cha֐iobNobt@̍쐬sj
//		F	
//	o	F	
////////////////////////////////////////////////////////////////////////////			
void DIB_INIT(void)
{
#if ALPHA_TBL_USE
	// 炩߃At@uhvZse[u쐬
	int i, j;

	WORD bb, bg, br;
	for (j = 0; j <= 32; j++) {
		// O`RQiK̃e[u쐬
		for (i = 0; i < 0x8000; i++) {
			// PUrbgchagpĂ̂łUTTRTʂ̐Fp^[ɑΉ
			// At@uhe[u쐬
			bb = (i & 0x001F) >> 0; 	// 0000 0000 000b bbbb
			bg = (i & 0x03E0) >> 5; 	// 0000 00gg ggg0 0000
			br = (i & 0x7C00) >> 10;	// 0rrr rr00 0000 0000

			br = (WORD)(br * j) >> 5;
			bg = (WORD)(bg * j) >> 5;
			bb = (WORD)(bb * j) >> 5; 

			AlphaRateTBL[j][i] = (br << 10) | (bg << 5) | (bb << 0);
		}
	}
#endif
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawBackCls
//	TvF	obNobt@wFœhׂ
//		F	*dst	]obt@
//			F	bg_col	hׂJ[
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawBackCls(CDib* dst, WORD bg_col)
{
	// DWORDANZXɂ鍂̂߃obNobt@|C^ DWORD * ɃLXg
	DWORD *pb = (DWORD *)dst->GetBuffer();			// obNobt@|C^擾
	DWORD pack_col = (bg_col << 16) | bg_col;		// F DWORD ɃpbN
	
	// DWORDANZX̂ߕKv[v͔
	int lp_max = dst->GetWidth() * dst->GetHeight() / 2;

	// hׂ
	for (int i = 0; i < lp_max; i++) {
		*pb = pack_col;
		pb++;
	}
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	Clip
//	TvF	]̈XN[Ɏ܂lɃNbv
//		F	*dst	]obt@ 
//			F	*src	]obt@
//			F	x		\w
//			F	y		\x
//			F	x1		]wW
//			F	y1		]xW
//			F	x2		]EwW
//			F	y2		]ExW
//	o	F	ture   Nbv 
//			F	false  NbvȑO̖
////////////////////////////////////////////////////////////////////////////
bool Clip(CDib* dst, CDib* src, int &x,int &y, int &x1, int &y1, int &x2, int &y2)
{
	// sȒlƈȉ̕`揈sȂ
	if (x2 < x1 || y2 < y1) 	return false;

	int width		= src->GetWidth();
	int height		= src->GetHeight();
	int dst_width	= dst->GetWidth();
	int dst_height	= dst->GetHeight();
	
	if (x2 > width)  x2 = width;
	if (y2 > height) y2 = height;
	
	// NbsO
	  // `悪ʉE[͂ݏoĂ鎞̏
	if (x + (x2 - x1) > dst_width)	x2 -= (x + (x2 - x1) - dst_width);
	  // `悪ʉ[͂ݏoĂ鎞̏
	if (y + (y2 - y1) > dst_height) y2 -= (y + (y2 - y1) - dst_height);
	  // `悪ʍ[͂ݏoĂ鎞̏
	if (x < 0)	{
		x1 -= x;
		x  = 0;
	}
	  // `悪ʏ[͂ݏoĂ鎞̏
	if (y < 0) {
		y1 -= y;
		y  = 0;
	}

	return true;
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawRect
//	TvF	͈͎w`֐
//		F	*dst	]obt@ 
//			F	x		\w
//			F	y		\x
//			F	*src	]obt@
//			F	left	]wW
//			F	top 	]xW
//			F	right	]EwW
//			F	bottom	]ExW
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawRect(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom)
{
	// G[`FbN
	if (dst->GetHDC() == NULL || src->GetHDC() == NULL ) return;
	
	// `͈̓Nbv
	Clip(dst, src, x, y, left, top, right, bottom);
	
	// J[L[擾
	WORD colkey = src->GetColKey();
	
	for (int i = top;  i < bottom; i++) {
		// ̂ߕ`JnC̃|C^炩ߎ擾
		WORD* ps = src->GetLine(i) + left;
		WORD* pb = dst->GetLine(y + i - top) + x;
		for (int j = left; j < right; j++) {
			if(*ps != colkey) { // J[L[
				*pb = *ps;
			}
			ps++;
			pb++;
		}
	}
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawRectFast
//	TvF	͈͎w`֐iJ[L[j
//		F	*dst	]obt@ 
//			F	x		\w
//			F	y		\x
//			F	*src	]obt@
//			F	left	]wW
//			F	top 	]xW
//			F	right	]EwW
//			F	bottom	]ExW
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawRectFast(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom)
{
	// G[`FbN
	if (dst->GetHDC() == NULL || src->GetHDC() == NULL ) return;
	
	BitBlt(dst->GetHDC(), x, y, right - left, bottom - top, src->GetHDC(), left, top, SRCCOPY);
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawHalfAlpha
//	TvF	`֐
//		F	*dst	]obt@ 
//			F	x		\w
//			F	y		\x
//			F	*src	]obt@
//			F	left	]wW
//			F	top 	]xW
//			F	right	]EwW
//			F	bottom	]ExW
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawHalfAlpha(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom)
{
	// G[`FbN
	if (dst->GetHDC() == NULL || src->GetHDC() == NULL ) return;
	
	// `͈̓Nbv
	Clip(dst, src, x, y, left, top, right, bottom);

	// J[L[擾
	WORD colkey = src->GetColKey();
	
	for (int i = top; i < bottom; i++) {
		WORD* ps = src->GetLine(i) + left;
		WORD* pb = dst->GetLine(y + i - top) + x;
		for (int j = left; j < right; j++) {
			if(*ps != colkey) {
				*pb = ((*ps >> 1) & 0x3DEF) + ((*pb >> 1) & 0x3DEF);
			}
			ps++;
			pb++;
		}
	}
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawRateAlpha
//	TvF	[gw蔼`֐
//		F	*dst	]obt@ 
//			F	x		\w
//			F	y		\x
//			F	*src	]obt@
//			F	left	]wW
//			F	top 	]xW
//			F	right	]EwW
//			F	bottom	]ExW
//			F	rate	[g O`QTT
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawRateAlpha(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom, int rate)
{
	// G[`FbN
	if (dst->GetHDC() == NULL || src->GetHDC() == NULL ) return;
	
	// `͈̓Nbv
	Clip(dst, src, x, y, left, top, right, bottom);

	// [g 0 - 32 ŃNbv
	if (rate > 32) rate = 32;
	if (rate <	0) rate = 0;
	int srate = rate;
	int brate = 32 - rate;

	// J[L[擾
	WORD colkey = src->GetColKey();
	
#if ALPHA_TBL_USE
	WORD* ps_alpha = AlphaRateTBL[srate];
	WORD* pb_alpha = AlphaRateTBL[brate];

	for (int i = top; i < bottom; i++) {
		WORD* ps = src->GetLine(i) + left;
		WORD* pb = dst->GetLine(y + i - top) + x;
		for (int j = left; j < right; j++) {
			if(*ps != colkey) {
				*pb = ps_alpha[*ps & 0x7FFF] + pb_alpha[*pb & 0x7FFF];
			}
			ps++;
			pb++;
		}
	}
#else
	WORD br, bg, bb, sr, sg, sb;

	for (int i = top; i < bottom; i++) {
		WORD* ps = src->GetLine(i) + left;
		WORD* pb = dst->GetLine(y + i - top) + x;
		for (int j = left; j < right; j++) {
			if(*ps != colkey) {
				// qfavfo
				br = (*pb & BG_RED)   >> 10;
				bg = (*pb & BG_GREEN) >> 5;
				bb = (*pb & BG_BLUE)  >> 0;

				sr = (*ps & BG_RED)   >> 10;
				sg = (*ps & BG_GREEN) >> 5;
				sb = (*ps & BG_BLUE)  >> 0;

				br = (WORD)((br * brate + sr * srate) >> 5);
				bg = (WORD)((bg * brate + sg * srate) >> 5);
				bb = (WORD)((bb * brate + sb * srate) >> 5);

				*pb = (br << 10) | (bg << 5) | bb;
			}
			ps++;
			pb++;
		}
	}
#endif
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawAddAlpha
//	TvF	Z`֐
//		F	*dst	]obt@ 
//			F	x		\w
//			F	y		\x
//			F	*src	]obt@
//			F	left	]wW
//			F	top 	]xW
//			F	right	]EwW
//			F	bottom	]ExW
//			F	rate	[g O`QTT
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawAddAlpha(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom, int rate)
{
	// G[`FbN
	if (dst->GetHDC() == NULL || src->GetHDC() == NULL ) return;
	
	// `͈̓Nbv
	Clip(dst, src, x, y, left, top, right, bottom);

	// [g 0 - 32 ŃNbv
	if (rate > 32) rate = 32;
	if (rate <	0) rate = 0;

	// J[L[擾
	WORD colkey = src->GetColKey();

	DWORD br, bg, bb, sr, sg, sb;
	
	for (int i = top; i < bottom; i++) {
		WORD* ps = src->GetLine(i) + left;
		WORD* pb = dst->GetLine(y + i - top) + x;
		for (int j = left; j < right; j++) {
			if(*ps != colkey) {
				// qfavfo
				br = *pb & BG_RED;
				bg = *pb & BG_GREEN;
				bb = *pb & BG_BLUE;
				
				sr = *ps & BG_RED;
				sg = *ps & BG_GREEN;
				sb = *ps & BG_BLUE;

				sr = ((sr * rate) >> 5) & BG_RED;
				sg = ((sg * rate) >> 5) & BG_GREEN;
				sb = ((sb * rate) >> 5) & BG_BLUE;

				// Z
				br = br + sr;
				bg = bg + sg;
				bb = bb + sb;

				// Oa
				br = br > BG_RED   ? BG_RED:   br;
				bg = bg > BG_GREEN ? BG_GREEN: bg;
				bb = bb > BG_BLUE  ? BG_BLUE:  bb;
				*pb = (WORD)(br | bg | bb);
			}
			ps++;
			pb++;
		}
	}
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawBlackFade
//	TvF	obNobt@tF[h֐ 
//		F	*dst	]obt@
//			F	width	ʂ̕
//			F	height	ʂ̍
//			F	rate	[g O`RQ
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawBlackFade(CDib* dst, int rate, int width, int height)
{
	// G[`FbN
	if (dst->GetHDC() == NULL) return;
	
	if (rate > 32) rate = 32;
	if (rate <	0) rate = 0;
	
	WORD* pb = dst->GetBuffer();

#if ALPHA_TBL_USE
	WORD* pb_alpha = AlphaRateTBL[rate];
	for (int i = 0; i < width * height; i++) {
		*pb = pb_alpha[*pb & 0x7FFF];
		pb++;
	}
#else
	WORD br, bg, bb;
	
	for (int i = 0; i < width * height; i++) {
		br = (*pb & BG_RED)   >> 10;
		bg = (*pb & BG_GREEN) >> 5;
		bb = (*pb & BG_BLUE)  >> 0;

		br = (WORD)((br * rate) >> 5);
		bg = (WORD)((bg * rate) >> 5);
		bb = (WORD)((bb * rate) >> 5);

		*pb = (br << 10) | (bg << 5) | bb;
		pb++;
	}
#endif
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawRectFade
//	TvF	͈͎wtF[h
//		F	*dst	]obt@ 
//			F	left	\wW
//			F	top 	\xW
//			F	right	\EwW
//			F	bottom	\ExW
//			F	rate	[g
//			F	bg_col	hԂF
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawRectFade(CDib* dst, int left, int top, int right, int bottom, int rate, WORD bg_col)
{
	// G[`FbN
	if (dst->GetHDC() == NULL) return;
	
	// [g 0 - 32 ŃNbv
	if (rate > 32) rate = 32;
	if (rate <	0) rate = 0;
	int srate = rate;
	int brate = 32 - rate;
	
	// `͈̓Nbv
	if (left   < 0) left = 0;
	if (top    < 0) top  = 0;
	if (right  > dst->GetWidth())  right  = dst->GetWidth();
	if (bottom > dst->GetHeight()) bottom = dst->GetHeight();
	
#if ALPHA_TBL_USE
	WORD* ps_alpha = AlphaRateTBL[srate];
	WORD* pb_alpha = AlphaRateTBL[brate];

	for (int i = top; i < bottom; i++) {
		WORD* pb = dst->GetLine(i) + left;
		for (int j = left; j < right; j++) {
			*pb = ps_alpha[bg_col & 0x7FFF] + pb_alpha[*pb & 0x7FFF];
			pb++;
		}
	}
#else
	WORD br, bg, bb, sr, sg, sb;

	for (int i = top; i < bottom; i++) {
		WORD* pb = dst->GetLine(i) + left;
		for (int j = left; j < right; j++) {
			// qfavfo
			br = (*pb & BG_RED)   >> 10;
			bg = (*pb & BG_GREEN) >> 5;
			bb = (*pb & BG_BLUE)  >> 0;

			sr = (bg_col & BG_RED)	 >> 10;
			sg = (bg_col & BG_GREEN) >> 5;
			sb = (bg_col & BG_BLUE)  >> 0;

			br = (WORD)((br * brate + sr * srate) >> 5);
			bg = (WORD)((bg * brate + sg * srate) >> 5);
			bb = (WORD)((bb * brate + sb * srate) >> 5);

			*pb = (br << 10) | (bg << 5) | bb;
			pb++;
		}
	}
#endif
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawFont
//	TvF	tHg\֐
//		F	*dst	]obt@ 
//			F	*str	\
//			F	size	\TCY
//			F	X		\wW
//			F	Y		\xW
//			F	R		q
//			F	G		f
//			F	B		a
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawFont(CDib* dst, char *str, int size, int X, int Y, int R, int G, int B)
{
	// G[`FbN
	if (dst->GetHDC() == NULL) return;
	
	//tHgϐ
	static HFONT	NewFont,OldFont;
	static HDC		FontDC;
	static PLOGFONT FontInfo;
	
	// obNobt@̃foCXReLXg擾
	FontDC = dst->GetHDC();

	//tHgCtH
	FontInfo  = (PLOGFONT)GlobalAlloc(GPTR, sizeof(LOGFONT));
	//tHg^Cvݒ
	BOOL Bold = TRUE;
	lstrcpy(FontInfo->lfFaceName, "W");
	FontInfo->lfWeight	   = (Bold == FALSE)*FW_NORMAL + (Bold == TRUE)*FW_BOLD;
	FontInfo->lfEscapement = 0;
	FontInfo->lfWidth	   = 0;
	FontInfo->lfHeight	   = size;
	FontInfo->lfItalic	   = false;
	FontInfo->lfUnderline  = FALSE;
	FontInfo->lfCharSet    = SHIFTJIS_CHARSET;
	//foCXReLXg擾
	NewFont = CreateFontIndirect(FontInfo);
	OldFont = (HFONT)SelectObject(FontDC, NewFont);

	//`揈
	SetBkMode(FontDC, TRANSPARENT);
	SetTextColor(FontDC, RGB(R, G, B));
	TextOut(FontDC, X, Y, str, strlen(str));
	//foCXReLXgJ
	SelectObject(FontDC, OldFont);
	DeleteObject(NewFont);
	//tHgCtHJ
	GlobalFree((LOCALHANDLE)FontInfo);
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawLine
//	TvF	C`֐
//		F	*dst	]obt@ 
//			F	X1		Jn_w
//			F	Y1		Jn_x
//			F	X2		I_w
//			F	Y2		I_x
//			F	size	C̑
//			F	R		q
//			F	G		f
//			F	B		a
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawLine(CDib* dst, int X1,int Y1,int X2,int Y2, int size, int R, int G, int B)
{
	// G[`FbN
	if (dst->GetHDC() == NULL) return;
	
	HDC  hdc = dst->GetHDC();						// obNobt@̂gcb擾
	HPEN NewPen;									// Vyۑϐ
	HPEN OldPen;									// ftHg̃yۑϐ
 
	NewPen = CreatePen(PS_SOLID,size,RGB(R,G,B));	// `py̍쐬
	OldPen = (HPEN)SelectObject(hdc, NewPen);		// y̑IƃftHg̃ỹZ[u

	//C`揈
	MoveToEx(hdc, X1, Y1, NULL);
	LineTo(hdc, X2, Y2);

	//IuWFNg̃[X
	SelectObject(hdc, OldPen);
	DeleteObject(NewPen);
}
