///////////////////////////////////////////////////////////////////////////
//	DIB_BUFFER	CLASS		
//									Programmed by m.minami				
///////////////////////////////////////////////////////////////////////////
#ifndef __DIBBUF_CLASS_H__
#define __DIBBUF_CLASS_H__

///////////////////////////////////////////////////////////////////////////
//								}N
///////////////////////////////////////////////////////////////////////////
// 16BIT DIB RGBf[^쐬p}N
#define DIB_RGB_MAKE(r, g, b)	( ((r >> 3) << 10) | ((g >> 3) << 5) | (b >> 3) )
#define DIB_R_GET(p)			( (p & 0x001F) << 3 )
#define DIB_G_GET(p)			( (p & 0x03E0) >> 2 )
#define DIB_B_GET(p)			( (p & 0x7C00) >> 7 )

// J[L[hc
#define COLOKEY_NONE			0xFFFF

// J[`
#define BG_BLACK	0x0000				// 0000 0000 0000 0000
#define BG_WHITE	0x7fff				// 0rrr rrgg gggb bbbb
#define BG_RED		0x7C00				// 0rrr rr00 0000 0000
#define BG_GREEN	0x03E0				// 0000 00gg ggg0 0000
#define BG_BLUE 	0x001F				// 0000 0000 000b bbbb

///////////////////////////////////////////////////////////////////////////
//						DIB BUFFER ǗNX
///////////////////////////////////////////////////////////////////////////
class CDib {
private:
	HBITMAP m_hbmp; 									// rbg}bvnh 
	HDC 	m_hdc;										// foCXReLXg

	WORD*	m_buf;										// DIB BUFFER |C^
	int 	m_width;									// obt@
	int 	m_height;									// obt@
	int 	m_pitch;									// PiIɑibytej
	int*	m_pitch_tbl;								// ̂߂̃e[u
	WORD	m_colkey;									// J[L[
	
public:
	CDib(char *file_name, WORD color = COLOKEY_NONE);	// BMPDIB𐶐 
	CDib(int width, int height);						// wTCYDIB𐶐

	WORD*	GetBuffer() { return m_buf; 	 }			// obt@|C^擾֐
	int 	GetWidth()	{ return m_width;	 }			// obt@擾֐
	int 	GetHeight() { return m_height;	 }			// obt@擾֐
	HDC 	GetHDC()	{ return m_hdc; 	 }			// foCXReLXg擾֐
	WORD	GetColKey() { return m_colkey;	 }			// J[L[擾
	
	void	SetColKey(WORD color) { m_colkey = color; } // J[L[ݒ
	
	// w胉C̃obt@|C^擾֐
	WORD*	GetLine(int y) { 
		return	(WORD *)((BYTE *)m_buf + m_pitch_tbl[y]);
	}

	~CDib();

private:
	// BMP[h
	bool CDib::LoadFile(char *file_name);
	// DIB
	void CreateDib(int width, int height);
};

///////////////////////////////////////////////////////////////////////////
//							cha`n֐
///////////////////////////////////////////////////////////////////////////
// cha֐
extern void DIB_INIT(void);

// obNobt@wFœhׂ
extern void DIB_DrawBackCls(CDib* dst, WORD bg_col);

// ]̈XN[Ɏ܂lɃNbv
extern bool Clip(CDib* dst, CDib* src, int &x,int &y, int &x1, int &y1, int &x2, int &y2);

// ͈͎w`֐
extern void DIB_DrawRect(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom);

// ͈͎w`֐iJ[L[j
extern void DIB_DrawRectFast(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom);

// `֐
extern void DIB_DrawHalfAlpha(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom);

// [gw蔼`֐
extern void DIB_DrawRateAlpha(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom, int rate);

// Z`֐
extern void DIB_DrawAddAlpha(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom, int rate);

// obNobt@tF[h֐
extern void DIB_DrawBlackFade(CDib* dst, int rate);

// ͈͎wtF[h
void DIB_DrawRectFade(CDib* dst, int left, int top, int right, int bottom, int rate, WORD bg_col);

// tHg\֐
extern void DIB_DrawFont(CDib* dst, char *str, int size, int X, int Y, int R, int G, int B);

// C`֐
extern void DIB_DrawLine(CDib* dst, int X1,int Y1,int X2,int Y2, int size, int R, int G, int B);

#endif
