#include "dib_buf2.h"

LOGFONT glFont = {0};

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_LoadFile2
//	TvF	rbg}bvǂݍ݊֐2inWidth ~ nHeight ̃rbg}bv쐬Aɓǂݍށj
//		F	*dib		obt@ 
//			F	nWidth		摜̕
//			F	nHeight 	摜̍
//			F	*file_name	BMPt@Cl[
//			F	nXSrc		wWit@Cj
//			F	nYSrc		xWit@Cj
//	o	F	
////////////////////////////////////////////////////////////////////////////
CDib* DIB_LoadFile2(int nWidth, int nHeight, char *file_name, int nXSrc, int nYSrc)
{
	CDib *dib = new CDib(nWidth, nHeight);
	
	DIB_ReLoadFile(dib, 0, 0, file_name, nXSrc, nYSrc, nXSrc + nWidth, nYSrc + nHeight);
	
	return dib;
}// DIB_LoadFile2

// I[o[[hiJ[L[j
CDib* DIB_LoadFile2(int nWidth, int nHeight, char *file_name, int nXSrc, int nYSrc, WORD colorkey)
{
	CDib *dib = new CDib(nWidth, nHeight);
	
	DIB_ReLoadFile(dib, 0, 0, file_name, nXSrc, nYSrc, nXSrc + nWidth, nYSrc + nHeight);
	
	dib->SetColKey(colorkey);
	return dib;
}// DIB_LoadFile2

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_ReLoadFile
//	TvF	rbg}bvēǂݍ݊֐
//		F	*dib		obt@ 
//			F	x			\w
//			F	y			\x
//			F	*file_name	BMPt@Cl[
//			F	left		wW
//			F	top 		xW
//			F	right		EwW
//			F	bottom		ExW
//	o	F	
////////////////////////////////////////////////////////////////////////////
bool DIB_ReLoadFile(CDib* dib, int x, int y, char *file_name, int left, int top, int right, int bottom)
{
	if ( !dib || dib->GetHDC() == NULL ) return false;
	
	HBITMAP hBitmap;
	BITMAP	BitMap;
	
	hBitmap = (HBITMAP)LoadImage(NULL, file_name, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (hBitmap == NULL) return false;
	
	GetObject(hBitmap, sizeof(BitMap), &BitMap);
	
	HDC 	hdcBitmap;
	HBITMAP hbmOld;
	
	hdcBitmap = CreateCompatibleDC(NULL);
	hbmOld = (HBITMAP)SelectObject(hdcBitmap, hBitmap);
	
	BitBlt(dib->GetHDC(), x, y, right - left, bottom - top, hdcBitmap, left, top, SRCCOPY);
	
	SelectObject(hdcBitmap, hbmOld);
	DeleteDC(hdcBitmap);
	DeleteObject(hBitmap);
	
	return true;
}// DIB_ReLoadFile

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_AlterMonotone
//	TvF	OCXP[ϊ֐
//			F	*dib	obt@
//			F	left	wW
//			F	top 	xW
//			F	right	EwW
//			F	bottom	ExW
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_AlterMonotone(CDib* dib, int left, int top, int right, int bottom)
{
	if ( !dib ) return;
	
	int width	= dib->GetWidth();
	int height	= dib->GetHeight();
	if(left < 0)		left = 0;
	if(top < 0) 		top = 0;
	if(right > width)	right = width;
	if(bottom > height) bottom = height;
	if(right <= left)	right = width;
	if(bottom <= top)	bottom = height;
	
	WORD colkey = dib->GetColKey();
	
	WORD br, bg, bb;
	
	for (int i = top; i < bottom; i++) {
		WORD* ps = dib->GetLine(i) + left;
		for (int j = left; j < right; j++) {
			if(*ps != colkey) {
				br = (*ps & BG_RED)   >> 10 << 3;
				bg = (*ps & BG_GREEN) >> 5 << 3;
				bb = (*ps & BG_BLUE)  >> 0 << 3;
				
				double	luminance = (br * 0.299) +
									(bg * 0.587) +
									(bb * 0.114) + 0.5;
				
				br = bg = bb = (BYTE)luminance >> 3;
				
				*ps = (br << 10) | (bg << 5) | bb;
			}
			ps++;
		}
	}
}// DIB_AlterMonotone

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_AlterHue
//	TvF	Fϊ֐
//			F	*dib	obt@
//			F	left	wW
//			F	top 	xW
//			F	right	EwW
//			F	bottom	ExW
//			F	hue 	F[g 0`192i32F, 96F, 144Fj
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_AlterHue(CDib* dib, int left, int top, int right, int bottom, int hue)
{
	if ( !dib ) return;
	
	if (hue > 192) hue = 192;
	else if (hue <	0) hue = 0;
	int hue2 = 64 - hue;
	int hue3 = hue - 64;
	int hue4 = 128 - hue;
	int hue5 = hue - 128;
	int hue6 = 192 - hue;
	
	int width	= dib->GetWidth();
	int height	= dib->GetHeight();
	if(left < 0)		left = 0;
	if(top < 0) 		top = 0;
	if(right > width)	right = width;
	if(bottom > height) bottom = height;
	if(right <= left)	right = width;
	if(bottom <= top)	bottom = height;
	
	WORD colkey = dib->GetColKey();
	
	WORD	br, bg, bb;
	WORD	fr1,fr2,fg1,fg2,fb1,fb2;
	
	for (int i = top; i < bottom; i++) {
		WORD* ps = dib->GetLine(i) + left;
		for (int j = left; j < right; j++) {
			if(*ps != colkey) {
				br = (*ps & BG_RED)   >> 10 << 3;
				bg = (*ps & BG_GREEN) >> 5 << 3;
				bb = (*ps & BG_BLUE)  >> 0 << 3;
				
				if(hue >= 0 && hue <= 64){
					fr1 = (WORD)(br * hue) >> 6;	// >> 6  / 64 ̂
					fr2 = (WORD)(br * hue2) >> 6;
					fg1 = (WORD)(bg * hue) >> 6;
					fg2 = (WORD)(bg * hue2) >> 6;
					fb1 = (WORD)(bb * hue) >> 6;
					fb2 = (WORD)(bb * hue2) >> 6;
				}
				else if(hue > 64 && hue <= 128){
					fr1 = (WORD)(bb * hue3) >> 6;
					fr2 = (WORD)(bb * hue4) >> 6;
					fg1 = (WORD)(br * hue3) >> 6;
					fg2 = (WORD)(br * hue4) >> 6;
					fb1 = (WORD)(bg * hue3) >> 6;
					fb2 = (WORD)(bg * hue4) >> 6;
				}
				else if(hue > 128 && hue <= 192){
					fr1 = (WORD)(bg * hue5) >> 6;
					fr2 = (WORD)(bg * hue6) >> 6;
					fg1 = (WORD)(bb * hue5) >> 6;
					fg2 = (WORD)(bb * hue6) >> 6;
					fb1 = (WORD)(br * hue5) >> 6;
					fb2 = (WORD)(br * hue6) >> 6;
				}
				br = (BYTE)(fr2 + fb1) >> 3;
				bg = (BYTE)(fg2 + fr1) >> 3;
				bb = (BYTE)(fb2 + fg1) >> 3;
				
				*ps = (br << 10) | (bg << 5) | bb;
			}
			ps++;
		}
	}
}// DIB_AlterHue

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawMonotone
//	TvF	OCXP[`֐
//		F	*dst	]obt@ 
//			F	x		\w
//			F	y		\x
//			F	*src	]obt@
//			F	left	]wW
//			F	top 	]xW
//			F	right	]EwW
//			F	bottom	]ExW
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawMonotone(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom)
{
	if ( dst == NULL || src == NULL ) return;
	
	Clip(dst, src, x, y, left, top, right, bottom);

	WORD colkey = src->GetColKey();
	
	WORD br, bg, bb;

	for (int i = top; i < bottom; i++) {
		WORD* ps = src->GetLine(i) + left;
		WORD* pb = dst->GetLine(y + i - top) + x;
		for (int j = left; j < right; j++) {
			if(*ps != colkey) {
				br = (*ps & BG_RED)   >> 10 << 3;
				bg = (*ps & BG_GREEN) >> 5 << 3;
				bb = (*ps & BG_BLUE)  >> 0 << 3;

				double	luminance = (br * 0.299) +
									(bg * 0.587) +
									(bb * 0.114) + 0.5;

				br = bg = bb = (BYTE)luminance >> 3;

				*pb = (br << 10) | (bg << 5) | bb;
			}
			ps++;
			pb++;
		}
	}
}// DIB_DrawMonotone

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawHue
//	TvF	FύX`֐
//		F	*dst	]obt@ 
//			F	x		\w
//			F	y		\x
//			F	*src	]obt@
//			F	left	]wW
//			F	top 	]xW
//			F	right	]EwW
//			F	bottom	]ExW
//			F	hue 	F[g 0`192i32F, 96F, 144Fj
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawHue(CDib* dst, int x, int y, CDib* src, int left, int top, int right, int bottom, int hue)
{
	if ( dst == NULL || src == NULL ) return;
	
	if (hue > 192)		hue = 192;
	else if (hue <	0) hue = 0;
	int hue2 = 64 - hue;
	int hue3 = hue - 64;
	int hue4 = 128 - hue;
	int hue5 = hue - 128;
	int hue6 = 192 - hue;
	
	Clip(dst, src, x, y, left, top, right, bottom);
	
	WORD	colkey = src->GetColKey();
	
	WORD	br, bg, bb;
	WORD	fr1,fr2,fg1,fg2,fb1,fb2;
	
	for (int i = top; i < bottom; i++) {
		WORD* ps = src->GetLine(i) + left;
		WORD* pb = dst->GetLine(y + i - top) + x;
		for (int j = left; j < right; j++) {
			if(*ps != colkey) {
				br = (*ps & BG_RED)   >> 10 << 3;
				bg = (*ps & BG_GREEN) >> 5 << 3;
				bb = (*ps & BG_BLUE)  >> 0 << 3;
				
				if(hue >= 0 && hue <= 64){
					fr1 = (WORD)(br * hue) >> 6;	//	>> 6  / 64 ̂
					fr2 = (WORD)(br * hue2) >> 6;
					fg1 = (WORD)(bg * hue) >> 6;
					fg2 = (WORD)(bg * hue2) >> 6;
					fb1 = (WORD)(bb * hue) >> 6;
					fb2 = (WORD)(bb * hue2) >> 6;
				}
				else if(hue > 64 && hue <= 128){
					fr1 = (WORD)(bb * hue3) >> 6;
					fr2 = (WORD)(bb * hue4) >> 6;
					fg1 = (WORD)(br * hue3) >> 6;
					fg2 = (WORD)(br * hue4) >> 6;
					fb1 = (WORD)(bg * hue3) >> 6;
					fb2 = (WORD)(bg * hue4) >> 6;
				}
				else if(hue > 128 && hue <= 192){
					fr1 = (WORD)(bg * hue5) >> 6;
					fr2 = (WORD)(bg * hue6) >> 6;
					fg1 = (WORD)(bb * hue5) >> 6;
					fg2 = (WORD)(bb * hue6) >> 6;
					fb1 = (WORD)(br * hue5) >> 6;
					fb2 = (WORD)(br * hue6) >> 6;
				}
				br = (BYTE)(fr2 + fb1) >> 3;
				bg = (BYTE)(fg2 + fr1) >> 3;
				bb = (BYTE)(fb2 + fg1) >> 3;
				
				*pb = (br << 10) | (bg << 5) | bb;
			}
			ps++;
			pb++;
		}
	}
}// DIB_DrawHue

// DIB_DrawRect ̃I[o[[h
void DIB_DrawRect(CDib* dst, int x, int y, CDib* src, RECT rcSrc)
{
	DIB_DrawRect(dst, x, y, src, rcSrc.left, rcSrc.top, rcSrc.right, rcSrc.bottom);
}// DIB_DrawRect

// DIB_DrawRectFast ̃I[o[[h
void DIB_DrawRectFast(CDib* dst, int x, int y, CDib* src, RECT rcSrc)
{
	DIB_DrawRectFast(dst, x, y, src, rcSrc.left, rcSrc.top, rcSrc.right, rcSrc.bottom);
}// DIB_DrawRectFast

// DIB_DrawHalfAlpha ̃I[o[[h
void DIB_DrawHalfAlpha(CDib* dst, int x, int y, CDib* src, RECT rcSrc)
{
	DIB_DrawHalfAlpha(dst, x, y, src, rcSrc.left, rcSrc.top, rcSrc.right, rcSrc.bottom);
}// DIB_DrawHalfAlpha

// DIB_DrawRateAlpha ̃I[o[[h
// paint_alpha : [IN] xm0 ` 32n
void DIB_DrawRateAlpha(CDib *dst, int x, int y, CDib* src, RECT rcSrc, int paint_alpha)
{
	DIB_DrawRateAlpha(dst, x, y, src, rcSrc.left, rcSrc.top, rcSrc.right, rcSrc.bottom, paint_alpha);
}// DIB_DrawRateAlpha

// DIB_DrawAddAlpha ̃I[o[[h
// paint_alpha : [IN] xm0 ` 32n
void DIB_DrawAddAlpha(CDib* dst, int x, int y, CDib* src, RECT rcSrc, int paint_alpha)
{
	DIB_DrawAddAlpha(dst, x, y, src, rcSrc.left, rcSrc.top, rcSrc.right, rcSrc.bottom, paint_alpha);
}// DIB_DrawAddAlpha

// DIB_DrawRectFade ̃I[o[[h
// paint_color : [IN] hFmDIB_RGB_MAKE(r, g, b)n
// paint_alpha : [IN] xm0 - 32n
void DIB_DrawRectFade(CDib *dst, RECT rc, WORD paint_color, int paint_alpha)
{
	DIB_DrawRectFade(dst, rc.left, rc.top, rc.right, rc.bottom, paint_alpha, paint_color);
}// DIB_DrawRectFade

// DIB_DrawRateAlpha ŁAx 32 ̏ꍇ́ADIB_DrawRect gp
// paint_alpha : [IN] xm0 ` 32n
void DIB_DrawRateAlpha2(CDib *dst, int x, int y, CDib* src, RECT rcSrc, int paint_alpha)
{
	if(paint_alpha >= 32)
		DIB_DrawRect(dst, x, y, src, rcSrc.left, rcSrc.top, rcSrc.right, rcSrc.bottom);
	else
		DIB_DrawRateAlpha(dst, x, y, src, rcSrc.left, rcSrc.top, rcSrc.right, rcSrc.bottom, paint_alpha);
}// DIB_DrawRateAlpha2

// DIB_DrawRectFade ŁAx 32 ̏ꍇ́ADIB_DrawBackCls gp
// paint_color : [IN] hFmDIB_RGB_MAKE(r, g, b)n
// paint_alpha : [IN] xm0 - 32n
void DIB_DrawRectFade2(CDib *dst, RECT rc, WORD paint_color, int paint_alpha)
{
	if(paint_alpha >= 32)
		DIB_DrawBackCls(dst, paint_color, rc);
	else
		DIB_DrawRectFade(dst, rc.left, rc.top, rc.right, rc.bottom, paint_alpha, paint_color);
}// DIB_DrawRectFade2

////////////////////////////////////////////////////////////////////////////
//	֐	F	DIB_DrawRateAlpha2
//	TvF	[gw蔼`֐iwF̂ݕʂ̓xKpBDIB_DrawRateAlpha2 ̃I[o[[hj
//		F	*dst	]obt@ 
//			F	x		\w
//			F	y		\x
//			F	*src	]obt@
//			F	rc		]`
//			F	rate1	[g O`RQ icolor ȊOj
//			F	color	rate2 ̓[gKpFmDIB_RGB_MAKE(r, g, b)n
//			F	rate2	[g O`RQ icolorj
//	o	F	
////////////////////////////////////////////////////////////////////////////
void DIB_DrawRateAlpha2(CDib* dst, int x, int y, CDib* src, RECT rc, int rate1, WORD color, int rate2)
{
	if ( dst == NULL || src == NULL ) return;
	
	Clip(dst, src, x, y, (int &)rc.left, (int &)rc.top, (int &)rc.right, (int &)rc.bottom);

	if (rate1 > 32) rate1 = 32;
	if (rate1 <  0) rate1 = 0;
	int srate1 = rate1;
	int brate1 = 32 - rate1;

	if (rate2 > 32) rate2 = 32;
	if (rate2 <  0) rate2 = 0;
	int srate2 = rate2;
	int brate2 = 32 - rate2;

	WORD colkey = src->GetColKey();
	
#if ALPHA_TBL_USE
	WORD* ps_alpha1 = AlphaRateTBL[srate1];
	WORD* pb_alpha1 = AlphaRateTBL[brate1];
	WORD* ps_alpha2 = AlphaRateTBL[srate2];
	WORD* pb_alpha2 = AlphaRateTBL[brate2];

	for (int i = rc.top; i < rc.bottom; i++) {
		WORD* ps = src->GetLine(i) + rc.left;
		WORD* pb = dst->GetLine(y + i - rc.top) + x;
		for (int j = rc.left; j < rc.right; j++) {
			if(*ps != colkey) {
				if(*ps != color){
					*pb = ps_alpha1[*ps & 0x7FFF] + pb_alpha1[*pb & 0x7FFF];
				}
				else{
					*pb = ps_alpha2[*ps & 0x7FFF] + pb_alpha2[*pb & 0x7FFF];
				}
			}
			ps++;
			pb++;
		}
	}
#else
	WORD br, bg, bb, sr, sg, sb;
	int  srate, brate;

	for (int i = rc.top; i < rc.bottom; i++) {
		WORD* ps = src->GetLine(i) + rc.left;
		WORD* pb = dst->GetLine(y + i - rc.top) + x;
		for (int j = rc.left; j < rc.right; j++) {
			if(*ps != colkey) {
				br = (*pb & BG_RED)   >> 10;
				bg = (*pb & BG_GREEN) >> 5;
				bb = (*pb & BG_BLUE)  >> 0;

				sr = (*ps & BG_RED)   >> 10;
				sg = (*ps & BG_GREEN) >> 5;
				sb = (*ps & BG_BLUE)  >> 0;

				if(*ps != color){
					srate = srate1;
					brate = brate1;
				}
				else{
					srate = srate2;
					brate = brate2;
				}

				br = (WORD)((br * brate + sr * srate) >> 5);
				bg = (WORD)((bg * brate + sg * srate) >> 5);
				bb = (WORD)((bb * brate + sb * srate) >> 5);

				*pb = (br << 10) | (bg << 5) | bb;
			}
			ps++;
			pb++;
		}
	}
#endif
}// DIB_DrawRateAlpha2

// ͈͎wPFhԂiI[o[[hj
// dst			: [IN][OUT] o͐BMPiobNobt@Ȃǁj
// paint_color	: [IN]		hFmDIB_RGB_MAKE(r, g, b)n
// rc			: [IN]		h`
void DIB_DrawBackCls(CDib* dst, WORD paint_color, RECT rc)
{
	if (rc.left   < 0) rc.left = 0;
	if (rc.top	  < 0) rc.top  = 0;
	if (rc.right  > dst->GetWidth())  rc.right	= dst->GetWidth();
	if (rc.bottom > dst->GetHeight()) rc.bottom = dst->GetHeight();
	
	for (int i = rc.top; i < rc.bottom; i++) {
		WORD *pb = dst->GetLine(i) + rc.left;
		for (int j = rc.left; j < rc.right; j++) {
			*pb = paint_color;
			pb++;
		}
	}
}// DIB_DrawBackCls

// g̕`iĝ݁j
// dst			: [IN][OUT] o͐BMPiobNobt@Ȃǁj
// rc			: [IN]		g̎l̍W
// thick		: [IN]		g̐
// pen_color	: [IN]		gFmRGB(r, g, b)n
void DIB_DrawFrame(CDib *dst, RECT rc, int thick, DWORD pen_color)
{
	if(!dst || !(dst->GetHDC()))	return;
	
	rc.left 	+= thick / 2;
	rc.top		+= thick / 2;
	rc.right	-= ((thick + 1) / 2 - 1);
	rc.bottom	-= ((thick + 1) / 2 - 1);
	
	HDC  hdc = dst->GetHDC();
	if(hdc){
		HPEN Pen,PenPre;
		HBRUSH Brush,BrushPre;
		Pen = CreatePen(PS_SOLID, thick, pen_color);
		Brush = (HBRUSH)GetStockObject(NULL_BRUSH);
		PenPre = (HPEN)SelectObject(hdc, Pen);
		BrushPre = (HBRUSH)SelectObject(hdc, Brush);
		Rectangle(hdc, rc.left, rc.top, rc.right, rc.bottom);
		SelectObject(hdc, PenPre);
		SelectObject(hdc, BrushPre);
		DeleteObject(Pen);
	}
}// DIB_DrawFrame

// g̕`iPFhԂj
// dst			: [IN][OUT] o͐BMPiobNobt@Ȃǁj
// rc			: [IN]		g̎l̍W
// thick		: [IN]		g̐
// pen_color	: [IN]		gFmRGB(r, g, b)n
// paint_color	: [IN]		hFmDIB_RGB_MAKE(r, g, b)n
void DIB_DrawFrameCls(CDib *dst, RECT rc, int thick, DWORD pen_color, WORD paint_color)
{
	DIB_DrawBackCls(dst, paint_color, rc);
	DIB_DrawFrame(dst, rc, thick, pen_color);
}// DIB_DrawFrameCls

// g̕`ixwhԂj
// dst			: [IN][OUT] o͐BMPiobNobt@Ȃǁj
// rc			: [IN]		g̎l̍W
// thick		: [IN]		g̐
// pen_color	: [IN]		gFmRGB(r, g, b)n
// paint_color	: [IN]		hFmDIB_RGB_MAKE(r, g, b)n
// paint_alpha	: [IN]		xm0 - 32n
// flag_draw	: [IN]		0  Og, 1  hׂ, 2  OgƓhׂ
void DIB_DrawFrameFade(CDib *dst, RECT rc, int thick, DWORD pen_color, WORD paint_color, int paint_alpha)
{
	DIB_DrawRectFade2(dst, rc, paint_color, paint_alpha);
	DIB_DrawFrame(dst, rc, thick, pen_color);
}// DIB_DrawFrameFade

// ̕`2
void DIB_DrawFont2(CDib* dst, char *str, int size, int x, int y, COLORREF rgb)
{
	if (!dst || dst->GetHDC() == NULL) return;
	
	static HFONT	NewFont,OldFont;
	static HDC		FontDC;
	
	FontDC = dst->GetHDC();
	
	glFont.lfHeight = size;
	
	NewFont = CreateFontIndirect(&glFont);
	OldFont = (HFONT)SelectObject(FontDC, NewFont);
	
	SetBkMode(FontDC, TRANSPARENT);
	SetTextColor(FontDC, rgb);
	TextOut(FontDC, x, y, str, strlen(str));
	
	SelectObject(FontDC, OldFont);
	DeleteObject(NewFont);
}// DIB_DrawFont2

// DIB_DrawFont2 ̃I[o[[h
// ߂l	:	`悵̍
int DIB_DrawFont2(CDib* dst, char *str, int size, RECT rc, COLORREF rgb)
{
	if (!dst || dst->GetHDC() == NULL) return 0;
	
	static HFONT	NewFont,OldFont;
	static HDC		FontDC;
	
	FontDC = dst->GetHDC();
	
	glFont.lfHeight = size;
	
	NewFont = CreateFontIndirect(&glFont);
	OldFont = (HFONT)SelectObject(FontDC, NewFont);
	
	SetBkMode(FontDC, TRANSPARENT);
	SetTextColor(FontDC, rgb);
	UINT uFormat = DT_WORDBREAK | DT_EXPANDTABS | DT_LEFT | DT_NOPREFIX | DT_EDITCONTROL;
	int hgt = DrawText(FontDC, str, strlen(str), &rc, uFormat);
	
	SelectObject(FontDC, OldFont);
	DeleteObject(NewFont);
	
	return hgt;
}// DIB_DrawFont2

// ̕\TCY擾
// size 	: [IN]	tHgTCY
// ߂l	:		̃TCY
SIZE Get_TextSize(CDib* dst, char *str, int size)
{
	SIZE sizeText = {0, 0};
	
	if(!str){
		return sizeText;
	}
	
	if (dst->GetHDC() == NULL) return sizeText;
	
	static HFONT	NewFont,OldFont;
	static HDC		FontDC;
	
	FontDC = dst->GetHDC();
	
	glFont.lfHeight = size;
	
	NewFont = CreateFontIndirect(&glFont);
	OldFont = (HFONT)SelectObject(FontDC, NewFont);
	
	GetTextExtentPoint32(FontDC, str, strlen(str), &sizeText);
	
	SelectObject(FontDC, OldFont);
	DeleteObject(NewFont);
	
	return sizeText;
}// Get_TextSize

// tHgP̍ő啝擾
// size 	: [IN]	tHgTCY
// ߂l	:		tHgP̍ő啝
int Get_FontWidthMax(HDC hDC, int size)
{
	int width = 0;
	
	if(!hDC){
		return width;
	}
	
	static HFONT	NewFont,OldFont;
	
	glFont.lfHeight = size;
	
	NewFont = CreateFontIndirect(&glFont);
	OldFont = (HFONT)SelectObject(hDC, NewFont);
	
	TEXTMETRIC tm = {0};
	GetTextMetrics(hDC, &tm);
	width = tm.tmMaxCharWidth;
	
	SelectObject(hDC, OldFont);
	DeleteObject(NewFont);
	
	return width;
}// Get_FontWidthMax

/*
// tHg̐ݒ
// FontInfo : [OUT] ݒ肷LOGFONT\
// size :	: [IN]	̃TCY
void Set_FontInfo(LOGFONT *FontInfo, int size)
{
	ZeroMemory(FontInfo, sizeof(LOGFONT));
	BOOL Bold = TRUE;
	lstrcpy(FontInfo->lfFaceName, "W");
	FontInfo->lfWeight		= (Bold == FALSE)*FW_NORMAL + (Bold == TRUE)*FW_BOLD;
	FontInfo->lfEscapement	= 0;
	FontInfo->lfWidth		= 0;
	FontInfo->lfHeight		= size;
	FontInfo->lfItalic		= FALSE;
	FontInfo->lfUnderline	= FALSE;
	FontInfo->lfCharSet 	= SHIFTJIS_CHARSET;
}// Set_FontInfo
*/
// DIB_DrawLine ̃I[o[[hiRGB }Nj
// color	: [IN]	FmRGB(r, g, b)n
void DIB_DrawLine(CDib* dst, int X1,int Y1,int X2,int Y2, int size, DWORD color)
{
	if (!dst || !(dst->GetHDC())) return;

	HDC 		hdc = dst->GetHDC();
	HPEN		NewPen;
	HPEN		OldPen;
	LOGBRUSH	logBrush;

	logBrush.lbStyle = BS_SOLID;
	logBrush.lbColor = color;
	logBrush.lbHatch = 0;
	NewPen = ExtCreatePen(PS_SOLID | PS_GEOMETRIC | PS_ENDCAP_FLAT | PS_JOIN_BEVEL, size, &logBrush, 0, NULL) ;
	OldPen = (HPEN)SelectObject(hdc, NewPen);

	MoveToEx(hdc, X1, Y1, NULL);
	LineTo(hdc, X2, Y2);

	SelectObject(hdc, OldPen);
	DeleteObject(NewPen);
}