// 
#ifndef _FLAME_H_
#define _FLAME_H_

#include <d3dx9.h>
#include "fvf.h"
#include "rand.h"

typedef struct	// 
{
	char		*strTextureFilename;	// eNX`t@C
	float		fParticleSize;			// p[eBNTCY
	int 		iParticleNum1;			// p[eBN1
	int 		iParticleNum2;			// p[eBN2
	D3DXCOLOR	color;					// p[eBNF
	D3DXVECTOR3 pos;					// ʒu
}FLAME,*LPFLAME;

class CFlame
{
public:
	CFlame();
	~CFlame();
	void	Free();
	void	Load(LPDIRECT3DDEVICE9 pD3DDev, FLAME *inf);
	HRESULT Render(LPDIRECT3DDEVICE9 pD3DDev);
	
private:
	float				m_fParticleSize;	// p[eBNTCY
	float				m_fParticleSizeSub; // TCYk̍
	float				m_fRatePos1;		// p[eBNW䗦1
	float				m_fRatePos2;		// p[eBNW䗦2
	float				m_fRange;			// p[eBNW͈
	int 				m_iParticleNum1;	// p[eBN1
	int 				m_iParticleNum2;	// p[eBN2
	D3DXVECTOR3 		m_pos;				// ʒu
	D3DXCOLOR			m_color;			// p[eBNF
	VERTEX_C*			m_pPtcl;			// p[eBN`
	int*				m_pbFlameColor;
	int*				m_piFlameCount2;
	float*				m_pfFlameSize;
	D3DXVECTOR2**		m_pv2Pos;
	LPDIRECT3DTEXTURE9	m_pTex; 			// p[eBNeNX`
	
private:
	HRESULT Draw_Flame(LPDIRECT3DDEVICE9 pD3DDev);
};

CFlame::CFlame()
{
	m_pPtcl 		= NULL;
	m_pbFlameColor	= NULL;
	m_piFlameCount2 = NULL;
	m_pfFlameSize	= NULL;
	m_pv2Pos		= NULL;
	m_pTex			= NULL;
}

CFlame::~CFlame()
{
	Free();
}

void CFlame::Free()
{
	int i;
	for(i=0; i<m_iParticleNum1; i++){
		SAFE_DELETE_ARRAY(m_pv2Pos[i]);
	}
	SAFE_DELETE_ARRAY(m_pv2Pos);
	SAFE_DELETE_ARRAY(m_pbFlameColor);
	SAFE_DELETE_ARRAY(m_piFlameCount2);
	SAFE_DELETE_ARRAY(m_pfFlameSize);
	SAFE_DELETE_ARRAY(m_pPtcl);
	SAFE_RELEASE(m_pTex);
}

// 
// pD3DDev : [IN] IDirect3DDevice9 IuWFNg
// inf	   : [IN] 
void CFlame::Load(LPDIRECT3DDEVICE9 pD3DDev, FLAME *inf)
{
	if(!inf->iParticleNum1 || !inf->iParticleNum2){
		return;
	}
	
	Free();
	
	if(FAILED(D3DXCreateTextureFromFile(pD3DDev, inf->strTextureFilename, &m_pTex))){
		m_pTex = NULL;
	}
	
	int i;
	
	m_fParticleSize 	= inf->fParticleSize;
	m_fParticleSizeSub	= m_fParticleSize * 0.035f;
	m_fRatePos1 		= m_fParticleSize;
	m_fRatePos2 		= m_fParticleSize * 0.5f;
	m_fRange			= m_fParticleSize * 2.0f;
	m_iParticleNum1 	= inf->iParticleNum1;
	m_iParticleNum2 	= inf->iParticleNum2;
	m_pos				= inf->pos;
	m_color 			= inf->color;
	m_pPtcl 			= new VERTEX_C	   [m_iParticleNum2];
	m_pbFlameColor		= new int		   [m_iParticleNum1];
	m_piFlameCount2 	= new int		   [m_iParticleNum1];
	m_pfFlameSize		= new float 	   [m_iParticleNum1];
	m_pv2Pos			= new D3DXVECTOR2* [m_iParticleNum1];
	if(m_pv2Pos){
		for(i=0; i<m_iParticleNum1; i++){
			m_pv2Pos[i] = new D3DXVECTOR2 [m_iParticleNum2];
			ZeroMemory(m_pv2Pos[i], sizeof(D3DXVECTOR2) * m_iParticleNum2);
		}
	}
	ZeroMemory(m_pPtcl, 		sizeof(VERTEX_C) * m_iParticleNum2);
	ZeroMemory(m_pbFlameColor,	sizeof(int) 	 * m_iParticleNum1);
	ZeroMemory(m_piFlameCount2, sizeof(int) 	 * m_iParticleNum1);
	ZeroMemory(m_pfFlameSize,	sizeof(float)	 * m_iParticleNum1);
}

// _O
// pD3DDev : [IN] IDirect3DDevice9 IuWFNg
HRESULT CFlame::Render(LPDIRECT3DDEVICE9 pD3DDev)
{
	HRESULT hr;
	DWORD	dwLighting_pre,dwShadeMode_pre;
	DWORD	dwEnableAlpha_pre,dwSrcAlpha_pre,dwDestAlpha_pre;
	DWORD	dwPtEnable_pre,dwPtScaleEnable_pre,dwPtSize_pre;
	DWORD	dwPtScaleA_pre,dwPtScaleB_pre,dwPtScaleC_pre;
	
	// ȑȌԂێ
	hr = pD3DDev->GetRenderState(D3DRS_LIGHTING,		  &dwLighting_pre);
	hr = pD3DDev->GetRenderState(D3DRS_SHADEMODE,		  &dwShadeMode_pre);
	hr = pD3DDev->GetRenderState(D3DRS_ALPHABLENDENABLE,  &dwEnableAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_SRCBLEND,		  &dwSrcAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_DESTBLEND,		  &dwDestAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSPRITEENABLE, &dwPtEnable_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSCALEENABLE,  &dwPtScaleEnable_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSIZE,		  &dwPtSize_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSCALE_A,	  &dwPtScaleA_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSCALE_B,	  &dwPtScaleB_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSCALE_C,	  &dwPtScaleC_pre);
	
	hr = pD3DDev->SetRenderState(D3DRS_LIGHTING,		 FALSE);
	hr = pD3DDev->SetRenderState(D3DRS_SHADEMODE,		 D3DSHADE_FLAT);
	hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	hr = pD3DDev->SetRenderState(D3DRS_SRCBLEND,		 D3DBLEND_ONE);
	hr = pD3DDev->SetRenderState(D3DRS_DESTBLEND,		 D3DBLEND_ONE);
	
	hr = Draw_Flame(pD3DDev);
	
	// ɖ߂
	hr = pD3DDev->SetRenderState(D3DRS_LIGHTING,		  dwLighting_pre);
	hr = pD3DDev->SetRenderState(D3DRS_SHADEMODE,		  dwShadeMode_pre);
	hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE,  dwEnableAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_SRCBLEND,		  dwSrcAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_DESTBLEND,		  dwDestAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSPRITEENABLE, dwPtEnable_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALEENABLE,  dwPtScaleEnable_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSIZE,		  dwPtSize_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_A,	  dwPtScaleA_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_B,	  dwPtScaleB_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_C,	  dwPtScaleC_pre);
	
	return hr;
}

// ̕`
// pD3DDev : [IN] IDirect3DDevice9 IuWFNg
HRESULT CFlame::Draw_Flame(LPDIRECT3DDEVICE9 pD3DDev)
{
	if(!m_pPtcl || !m_pbFlameColor || !m_piFlameCount2 || !m_pfFlameSize || !m_pv2Pos){
		return E_OUTOFMEMORY;
	}
	
	HRESULT 	hr;
	int 		i,j;
	static int	iFlameCount1 = 0;
	
	// |CgXvCg̐ݒ
	hr = pD3DDev->SetRenderState(D3DRS_POINTSPRITEENABLE, TRUE);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALEENABLE,  TRUE);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_A,	  F2DW(0.00f));
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_B,	  F2DW(0.00f));
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_C,	  F2DW(1.00f));
	
	// _̌^Zbg
	hr = pD3DDev->SetFVF(FVF_VERTEX_C);
	// eNX`ݒ
	hr = pD3DDev->SetTexture(0, m_pTex);
	for(i=0; i<m_iParticleNum1; i++){
		if(iFlameCount1 == i || m_piFlameCount2[i] > 0){
			// F
			m_pbFlameColor[i] = 210-(int)((float)255/(m_iParticleNum1*m_iParticleNum1)*m_piFlameCount2[i]*m_piFlameCount2[i]);
			if(m_pbFlameColor[i] < 0)	m_pbFlameColor[i] = 0;
			// 傫
			if(m_piFlameCount2[i] == 0){
				m_pfFlameSize[i] = m_fParticleSize;
			}
			m_pfFlameSize[i] -= m_fParticleSizeSub;
			hr = pD3DDev->SetRenderState(D3DRS_POINTSIZE, F2DW(m_pfFlameSize[i]));
			// ʒu
			for(j=0; j<m_iParticleNum2; j++){
				if(m_piFlameCount2[i] == 0){
					m_pv2Pos[i][j].x = (float)GetRandGaussian() * m_fRatePos1;
					m_pv2Pos[i][j].y = (float)GetRandGaussian() * m_fRatePos1;
					if(D3DXVec2Length(&m_pv2Pos[i][j]) > m_fRange){
						m_pv2Pos[i][j].x = (float)GetRandGaussian() * m_fRatePos2;
						m_pv2Pos[i][j].y = (float)GetRandGaussian() * m_fRatePos2;
					}
					m_pv2Pos[i][j].x += m_pos.x;
					m_pv2Pos[i][j].y += m_pos.y;
				}
				m_pv2Pos[i][j].y += m_fRatePos2;
				m_pPtcl[j].v.x = m_pv2Pos[i][j].x;
				m_pPtcl[j].v.y = m_pv2Pos[i][j].y;
				m_pPtcl[j].v.z = m_pos.z;
				m_pPtcl[j].c   = D3DCOLOR_XRGB((BYTE)(m_pbFlameColor[i] * m_color.r), (BYTE)(m_pbFlameColor[i] * m_color.g), (BYTE)(m_pbFlameColor[i] * m_color.b));
			}
			// _O
			hr = pD3DDev->DrawPrimitiveUP(D3DPT_POINTLIST, m_iParticleNum2, m_pPtcl, sizeof(VERTEX_C));
			m_piFlameCount2[i] ++;
			if(m_piFlameCount2[i] >= m_iParticleNum1){
				m_piFlameCount2[i] = 0;
			}
		}
	}
	iFlameCount1 ++;
	if(iFlameCount1 >= m_iParticleNum1){
		iFlameCount1 = 0;
	}
	
	return hr;
}// Draw_Flame

#endif