// {
#ifndef _LABYRINTH_H_
#define _LABYRINTH_H_

#include <d3dx9.h>
#include <malloc.h>
#include "fvf.h"
#include "order.h"
#include "file_ect.h"

#define P_NUM		44		// ʘH̎ސ

typedef struct{ 	// 
	char	strPassEctFilename[MAX_PATH];	// ʘHECTt@C
	char	strMapFilename[MAX_PATH];		// n}t@C
	float	fLightRange;					// Cg̓͂
	float	fMoveSpeed; 					// ړx
}LABYRINTH,*LPLABYRINTH;

class CLabyrinth
{
public:
	CLabyrinth();
	~CLabyrinth();
	void	Free();
	bool	Init(LPDIRECT3DDEVICE9 pD3DDev, LABYRINTH *inf);
	int 	GetMapWidth()  { return m_map_w; }
	int 	GetMapHeight() { return m_map_h; }
	float 	GetPassageSize()  { return m_fPassageSize; }
	float 	GetPassageHeight() { return m_fPassageHeight; }
	void	SetHitTestRange(float fWall, float fPillar)
							{	m_ptHitTestRangeWall = fWall;
								m_ptHitTestRangePillar = fPillar; };
	void	SetOrder(COrder *order);
	void	DrawPassage(LPDIRECT3DDEVICE9 pD3DDev, int x, int z);
	void	DrawWall(LPDIRECT3DDEVICE9 pD3DDev, int x, int z);
	void	DrawCeiling(LPDIRECT3DDEVICE9 pD3DDev, int x, int z);
	void	DrawFloor(LPDIRECT3DDEVICE9 pD3DDev, int x, int z);
	void	VisiblePassage(COrder *order, D3DXVECTOR3 v3LookAt, float fRoll);
	int		HitTest(float x, float z);
	bool	GetVisible(float x, float z);
	bool	LoadMap(char *filename);
	
private:
	CFileECT			m_ect;				// ʘHbVf[^
	float				m_fLightRange;		// Cg̓͂
	float				m_fMoveSpeed;		// ړx
	int 				m_map_w,m_map_h;	// n}\ʘHiCcj
	int 				m_map2_w,m_map2_h;	// m_map2 ̕ƍ
	BYTE**				m_map1; 			// n}f[^i[
	BYTE*				m_map2; 			// `tOi`悷:1, `悵Ȃ:0j
	bool				m_wall[P_NUM][4];	// eʘH̕ǃtO
	int 				m_thick[P_NUM]; 	// eʘH̕ǌtO
	POINT*				m_ptStack;			// ێX^bN
	int 				m_numStack; 		// m_ptStack ̗vf
	float				m_ptHitTestRangeWall;	// 蔻͈̔́iXj
	float				m_ptHitTestRangePillar;	// 蔻͈̔́iZj
	float				m_fPassageSize;		// ʘH^Cӂ̒
	float				m_fPassageHeight;	// ʘH^C̍
	
private:
	void	Bucket(LPBYTE data, int x, int y, int wdh, int hgt, BYTE val_dst, int direction);
	bool	BucketSub  (LPBYTE data, int wdh, int hgt, BYTE val_src, BYTE val_dst, int direction);
	POINT	BucketSubX(LPBYTE data, int wdh, int hgt, int xPos, int yPos, BYTE val_src, BYTE val_dst);
	POINT	BucketSubY(LPBYTE data, int wdh, int hgt, int xPos, int yPos, BYTE val_src, BYTE val_dst);
	bool	CheckStackSize();
};

CLabyrinth::CLabyrinth()
{
	bool wall[P_NUM][4] =  {{0,0,0,1},{0,0,1,0},{0,1,0,0},{1,0,0,0},
							{1,0,0,1},{0,0,1,1},{0,1,1,0},{1,1,0,0},
							{1,0,1,1},{0,1,1,1},{1,1,1,0},{1,1,0,1},
							{1,0,1,0},{0,1,0,1},
							{0,0,0,1},{0,0,1,0},{0,1,0,0},{1,0,0,0},
							{1,0,0,1},{0,0,1,1},{0,1,1,0},{1,1,0,0},
							{0,0,0,1},{0,0,0,1},{0,0,1,0},{0,0,1,0},
							{0,1,0,0},{0,1,0,0},{1,0,0,0},{1,0,0,0},
							{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
							{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
							{0,0,0,0},{0,0,0,0}};	// ǃtO
	int thick[P_NUM] = { 1, 1, 1, 1, 2, 2, 2, 2,
						-1,-1,-1,-1,-1,-1,-1,-1,
						-1,-1,-1,-1,-1,-1, 1, 1,
						 1, 1, 1, 1, 1, 1, 0, 0,
						 0, 0, 0, 0, 0, 0, 0, 0,
						 0, 0, 0,-1};	// ǌtO
	m_map_w  = 0;
	m_map_h  = 0;
	m_map2_w = 0;
	m_map2_h = 0;
	m_map1	 = NULL;
	m_map2	 = NULL;
	memcpy(m_wall, wall, sizeof(m_wall));
	memcpy(m_thick, thick, sizeof(m_thick));
	m_ptStack = NULL;
	m_numStack = 0;
	m_ptHitTestRangeWall = 0.05f;
	m_ptHitTestRangePillar = 0.07f;
}

CLabyrinth::~CLabyrinth()
{
	Free();
}

void CLabyrinth::Free()
{
	int i;
	for(i=0; i<m_map_h; i++){
		SAFE_DELETE_ARRAY(m_map1[i]);
	}
	SAFE_DELETE_ARRAY(m_map1);
	SAFE_DELETE_ARRAY(m_map2);
}

// 
// pD3DDev : [IN] IDirect3DDevice9 IuWFNg
// inf	   : [IN] 
bool CLabyrinth::Init(LPDIRECT3DDEVICE9 pD3DDev, LABYRINTH *inf)
{
	bool flag;
	
	// ʘHbVǂݍ
	flag = m_ect.Load(pD3DDev, inf->strPassEctFilename, FVF_VERTEX_NT);
	if(!flag){
		MessageBox(GetFocus(), "ʘHbVǂݍ݃G[", "Labyrinth", MB_OK);
		return false;
	}
	D3DXVECTOR3 max = m_ect.GetMax();
	m_fPassageSize   = max.x;
	m_fPassageHeight = max.y;
	// n}f[^ǂݍ
	flag = LoadMap(inf->strMapFilename);
	if(!flag){
		MessageBox(GetFocus(), "}bvǂݍ݃G[", "Labyrinth", MB_OK);
		return false;
	}
	// Cg̓͂
	m_fLightRange = inf->fLightRange;
	// ړx
	m_fMoveSpeed = inf->fMoveSpeed;
	
	return true;
}// Init

// `揇ݒ
void CLabyrinth::SetOrder(COrder *order)
{
	if(!m_map2 || !order){
		return;
	}
	
	int m,n,n2;
	
	for(n=0; n<m_map_h; n++){
		n2 = n * 2 + 1;
		for(m=0; m<m_map_w; m++){
			if(m_map2[n2 * m_map2_w + (m * 2 + 1)] == 2){
				order->SetData(-1, D3DXVECTOR3((float) m, 0, (float) n), false);
			}
		}
	}
}// SetOrder

// ʘH`
void CLabyrinth::DrawPassage(LPDIRECT3DDEVICE9 pD3DDev, int x, int z)
{
	if(!m_map1 || m_map1[z][x] < 1){
		return;
	}
	
	D3DXMATRIX mt;
	D3DXMatrixTranslation(&mt, x * m_fPassageSize, 0, (m_map_h - 1 - z) * m_fPassageSize);
	pD3DDev->SetTransform(D3DTS_WORLD, &mt);
	LPD3DXMESH	pMesh = m_ect.GetMesh();
	if(pMesh){
		pMesh->DrawSubset(m_map1[z][x] - 1);
		pMesh->DrawSubset(P_NUM);
		pMesh->DrawSubset(P_NUM + 1);
	}
}// DrawPassage

// ʘHǕ`
void CLabyrinth::DrawWall(LPDIRECT3DDEVICE9 pD3DDev, int x, int z)
{
	if(!m_map1 || m_map1[z][x] < 1){
		return;
	}
	
	D3DXMATRIX mt;
	D3DXMatrixTranslation(&mt, x * m_fPassageSize, 0, (m_map_h - 1 - z) * m_fPassageSize);
	pD3DDev->SetTransform(D3DTS_WORLD, &mt);
	LPD3DXMESH	pMesh = m_ect.GetMesh();
	if(pMesh){
		pMesh->DrawSubset(m_map1[z][x] - 1);
	}
}// DrawWall

// ʘHV`
void CLabyrinth::DrawCeiling(LPDIRECT3DDEVICE9 pD3DDev, int x, int z)
{
	if(!m_map1 || m_map1[z][x] < 1){
		return;
	}
	
	D3DXMATRIX mt;
	D3DXMatrixTranslation(&mt, x * m_fPassageSize, 0, (m_map_h - 1 - z) * m_fPassageSize);
	pD3DDev->SetTransform(D3DTS_WORLD, &mt);
	LPD3DXMESH	pMesh = m_ect.GetMesh();
	if(pMesh){
		pMesh->DrawSubset(P_NUM);
	}
}// DrawCeiling

// ʘH`
void CLabyrinth::DrawFloor(LPDIRECT3DDEVICE9 pD3DDev, int x, int z)
{
	if(!m_map1 || m_map1[z][x] < 1){
		return;
	}
	
	D3DXMATRIX mt;
	D3DXMatrixTranslation(&mt, x * m_fPassageSize, 0, (m_map_h - 1 - z) * m_fPassageSize);
	pD3DDev->SetTransform(D3DTS_WORLD, &mt);
	LPD3DXMESH	pMesh = m_ect.GetMesh();
	if(pMesh){
		pMesh->DrawSubset(P_NUM + 1);
	}
}// DrawFloor

// ʘH
// order	F [OUT] `揇NX
// v3LookAt F [IN]  _
// fRoll	F [IN]  _̉]pxixj
void CLabyrinth::VisiblePassage(COrder *order, D3DXVECTOR3 v3LookAt, float fRoll)
{
	if(!m_map1 || !m_map2 || !order){
		return;
	}
	
	int 		nx,nz;					// ݂n}̈ʒu
	static int	nx_pre = 0,nz_pre = 0;	// O񂢂n}̈ʒu
	
	int 		flagDir;				// ݂̉]i:0, :1, :2, k:3j
	static int	flagDir_pre = -1;		// Ỏ]
	int 		dx[4] = {-1, 0, 1, 0};	// eis̈ړl
	int 		dz[4] = { 0, 1, 0,-1};	// eis̈ړl
	
	nx = (int)(v3LookAt.x / m_fPassageSize);
	nz = m_map_h - (int)(v3LookAt.z / m_fPassageSize) - 1;
	if(fRoll >= 225 && fRoll < 315){
		flagDir = 0;
	}
	else if(fRoll >= 135 && fRoll < 225){
		flagDir = 1;
	}
	else if(fRoll >= 45 && fRoll < 135){
		flagDir = 2;
	}
	else{
		flagDir = 3;
	}
	
	if(nx == nx_pre && nz == nz_pre && flagDir == flagDir_pre){
		return;
	}
	
	// tO
	ZeroMemory(m_map2, sizeof(BYTE) * m_map2_w * m_map2_h);
	int i,j,j2,index,index2,index3;
	// tOݒi鋗j
	int range = (int)(m_fLightRange / m_fPassageSize + 0.5f);
	POINT ptStart = {nx - range, nz - range};
	POINT ptEnd   = {nx + range, nz + range};
	ptStart.x = ptStart.x * 2 + 1;
	ptStart.y = ptStart.y * 2 + 1;
	ptEnd.x   = ptEnd.x   * 2 + 1;
	ptEnd.y   = ptEnd.y   * 2 + 1;
	for(j=0; j<m_map2_h; j++){
		for(i=0; i<m_map2_w; i++){
			if(i <= ptStart.x || i >= ptEnd.x || j <= ptStart.y || j >= ptEnd.y){
				m_map2[j * m_map2_w + i] = 1;
			}
		}
	}
	// tOݒij
	for(j=0; j<m_map_h; j++){
		j2 = j * 2 + 1;
		for(i=0; i<m_map_w; i++){
			index  = j2 * m_map2_w + i * 2 + 1;
			index3 = m_map1[j][i] - 1;
			if(m_wall[index3][0]){
				index2 = index - 1;
				m_map2[index2 - m_map2_w] = 1;
				m_map2[index2			] = 1;
				m_map2[index2 + m_map2_w] = 1;
			}
			if(m_wall[index3][1]){
				index2 = index + m_map2_w;
				m_map2[index2 - 1] = 1;
				m_map2[index2	 ] = 1;
				m_map2[index2 + 1] = 1;
			}
			if(m_wall[index3][2]){
				index2 = index + 1;
				m_map2[index2 - m_map2_w] = 1;
				m_map2[index2			] = 1;
				m_map2[index2 + m_map2_w] = 1;
			}
			if(m_wall[index3][3]){
				index2 = index - m_map2_w;
				m_map2[index2 - 1] = 1;
				m_map2[index2	 ] = 1;
				m_map2[index2 + 1] = 1;
			}
		}
	}
	// ݒnO̒ʘHtO𑍂ĂQɂ
	int nx2,nz2;
	nx2 = nx * 2 + 1;
	nz2 = nz * 2 + 1;
	switch(flagDir)
	{
	case 0:
		Bucket(m_map2, nx2, nz2, m_map2_w, m_map2_h, 2, 2);
		break;
	case 1:
		Bucket(m_map2, nx2, nz2, m_map2_w, m_map2_h, 2, 1);
		break;
	case 2:
		Bucket(m_map2, nx2, nz2, m_map2_w, m_map2_h, 2, 3);
		break;
	case 3:
		Bucket(m_map2, nx2, nz2, m_map2_w, m_map2_h, 2, 0);
		break;
	}
	// ͂̒ʘHtO𑍂ĂQɂi_ƒ_̋ꍇɕKvj
	POINT ptStart2 = {nx - 1, nz - 1};
	POINT ptEnd2   = {nx + 1, nz + 1};
	ptStart2.x = ptStart2.x * 2 + 1;
	ptStart2.y = ptStart2.y * 2 + 1;
	ptEnd2.x   = ptEnd2.x   * 2 + 1;
	ptEnd2.y   = ptEnd2.y   * 2 + 1;
	if(ptStart2.x < 0)
		ptStart2.x = 0;
	if(ptStart2.y < 0)
		ptStart2.y = 0;
	if(ptEnd2.x >= m_map2_w)
		ptEnd2.x = m_map2_w - 1;
	if(ptEnd2.y >= m_map2_h)
		ptEnd2.y = m_map2_h - 1;
	for(j=ptStart2.y; j<=ptEnd2.y; j++){
		for(i=ptStart2.x; i<=ptEnd2.x; i++){
			m_map2[j * m_map2_w + i] = 2;
		}
	}
	// ёւNXɎ_Wݒ
	order->SetEyePos(D3DXVECTOR3((float) nx, 0, (float) nz));
	// ȑÕf[^L
	nx_pre		= nx;
	nz_pre		= nz;
	flagDir_pre = flagDir;
}// VisiblePassage

// ǂɂԂPȏ̒lԂ
// x,y		F[IN] ݒn
// ߂l	FǂɂԂiG[:-1, Ȃ:0, :1, :2, :3, k:4, k:5, 쐼:6, 쓌:7, k:8j
int CLabyrinth::HitTest(float x, float z)
{
	if(!m_map1){
		return -1;
	}
	
	// eʘHbV̒iǌj̃tO
	const bool	pillar[P_NUM][4] = {{0,1,1,0},{1,1,0,0},{1,0,0,1},{0,0,1,1},
									{0,0,1,0},{0,1,0,0},{1,0,0,0},{0,0,0,1},
									{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
									{0,0,0,0},{0,0,0,0},
									{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
									{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
									{0,1,0,0},{0,0,1,0},{1,0,0,0},{0,1,0,0},
									{0,0,0,1},{1,0,0,0},{0,0,1,0},{0,0,0,1},
									{0,1,0,0},{1,0,0,0},{0,0,0,1},{0,0,1,0},
									{0,1,1,0},{1,1,0,0},{1,0,0,1},{0,0,1,1},
									{0,1,1,1},{1,1,1,0},{1,1,0,1},{1,0,1,1},
									{1,1,1,1},{0,0,0,0}};
	int 	nx,nz;
	float	mx,mz;
	mx = (float)fmod(x, m_fPassageSize);
	mz = (float)fmod(m_map_h * m_fPassageSize - z, m_fPassageSize);
	nx = (int)(x / m_fPassageSize);
	nz = (int)((m_map_h * m_fPassageSize - z) / m_fPassageSize);
	
	if(m_wall[m_map1[nz][nx] - 1][0] && (mx - m_ptHitTestRangeWall) <= m_fMoveSpeed){
		return 1;
	}
	if(m_wall[m_map1[nz][nx] - 1][1] && (mz + m_ptHitTestRangeWall) >= (m_fPassageSize - m_fMoveSpeed)){
		return 2;
	}
	if(m_wall[m_map1[nz][nx] - 1][2] && (mx + m_ptHitTestRangeWall) >= (m_fPassageSize - m_fMoveSpeed)){
		return 3;
	}
	if(m_wall[m_map1[nz][nx] - 1][3] && (mz - m_ptHitTestRangeWall) <= m_fMoveSpeed){
		return 4;
	}
	if(pillar[m_map1[nz][nx] - 1][0] && (mx - m_ptHitTestRangePillar) <= m_fMoveSpeed && (mz - m_ptHitTestRangePillar) <= m_fMoveSpeed){
		return 5;
	}
	if(pillar[m_map1[nz][nx] - 1][1] && (mx - m_ptHitTestRangePillar) <= m_fMoveSpeed && (mz + m_ptHitTestRangePillar) >= (m_fPassageSize - m_fMoveSpeed)){
		return 6;
	}
	if(pillar[m_map1[nz][nx] - 1][2] && (mx + m_ptHitTestRangePillar) >= (m_fPassageSize - m_fMoveSpeed) && (mz + m_ptHitTestRangePillar) >= (m_fPassageSize - m_fMoveSpeed)){
		return 7;
	}
	if(pillar[m_map1[nz][nx] - 1][3] && (mx + m_ptHitTestRangePillar) >= (m_fPassageSize - m_fMoveSpeed) && (mz - m_ptHitTestRangePillar) <= m_fMoveSpeed){
		return 8;
	}
	return 0;
}// HitTest

// wW̒ʘH̉
bool CLabyrinth::GetVisible(float x, float z)
{
	int nx,nz;					// ݂n}̈ʒu
	int nx2,nz2;
	nx = (int)(x / m_fPassageSize);
	nz = m_map_h - (int)(z / m_fPassageSize) - 1;
	nx2 = nx * 2 + 1;
	nz2 = nz * 2 + 1;
	return (m_map2[nz2 * m_map2_w + nx2] >= 2 ? true : false);
}// GetVisible

// n}f[^ǂݍ
bool CLabyrinth::LoadMap(char *filename)
{
	HANDLE	hFile;
	DWORD	dwRead;
	int 	i;
	// 
	for(i=0; i<m_map_h; i++){
		SAFE_DELETE_ARRAY(m_map1[i]);
	}
	SAFE_DELETE_ARRAY(m_map1);
	SAFE_DELETE_ARRAY(m_map2);
	// t@CJ
	hFile = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, 
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		m_map2_w = 0;
		return 0;
	}
	// t@CmF
	char name[6] = "MAPY2";
	char name2[6];
	ReadFile(hFile, name2, sizeof(name2), &dwRead, NULL);
	if(strcmp(name, name2)){
		CloseHandle(hFile);
		return 0;
	}
	// n}̕ƍǂݍ
	ReadFile(hFile, &m_map_w, sizeof(m_map_w), &dwRead, NULL);
	ReadFile(hFile, &m_map_h, sizeof(m_map_h), &dwRead, NULL);
	// m
	m_map1 = new BYTE* [m_map_h];
	for(i=0; i<m_map_h; i++){
		m_map1[i] = new BYTE [m_map_w];
	}
	// n}̃Zf[^ǂݍ
	for(i=0; i<m_map_h; i++){
		ReadFile(hFile, m_map1[i], sizeof(BYTE) * m_map_w, &dwRead, NULL);
	}
	// t@C
	CloseHandle(hFile);
	
	m_map2_w = m_map_w * 2 + 1;
	m_map2_h = m_map_h * 2 + 1;
	// m
	m_map2 = new BYTE [m_map2_w * m_map2_h];
	return 1;
}// LoadMap

// hԂ
// data 	  : hԂΏۂ̃f[^
// x,y		  : NbNꂽsNZʒu
// val_dst	  : hԂl
// direction  : hԂi0:A1:A2:A3;Ej
void CLabyrinth::Bucket(LPBYTE data, int x, int y, int wdh, int hgt, BYTE val_dst, int direction)
{
	BYTE	val_src = data[y * wdh + x];
	
	if(val_src == val_dst){
		return;
	}
	
	SAFE_FREE(m_ptStack);
	m_ptStack = (LPPOINT) malloc(1024*sizeof(POINT));
	
	m_numStack = 0;
	m_ptStack[m_numStack].x = x;
	m_ptStack[m_numStack].y = y;
	
	BucketSub(data, wdh, hgt, val_src, val_dst, direction);
	
	SAFE_FREE(m_ptStack);
	m_numStack = 0;
}// Bucket

// hԂ͈͂߂
bool CLabyrinth::BucketSub(LPBYTE data, int wdh, int hgt, BYTE val_src, BYTE val_dst, int direction)
{
	bool	flag1,flag2,flag3;
	int 	i;
	int 	xPos,yPos;
	POINT	pt;
	BYTE	val;
	
	while(m_numStack >= 0){ // X^bNɂȂI
		flag3 = 1;
		while(flag3){
			xPos = m_ptStack[m_numStack].x;
			yPos = m_ptStack[m_numStack].y;
			if(direction <= 1)
				pt = BucketSubX(data, wdh, hgt, xPos, yPos, val_src, val_dst);
			else
				pt = BucketSubY(data, wdh, hgt, xPos, yPos, val_src, val_dst);
			flag1 = 0;
			flag2 = 0;
			flag3 = 0;
			for(i=pt.x; i<=pt.y; i++){
				switch(direction)
				{
				case 0: // 
					if(yPos > 0){
						val = data[(yPos - 1) * wdh + i];
						if(val_src != val){
							flag1 = 0;
						}
						else if(!flag1 && val_src == val){
							m_ptStack[m_numStack].x = i;
							m_ptStack[m_numStack].y = yPos - 1;
							m_numStack ++;
							if(!CheckStackSize())
								return 0;
							flag1 = 1;
							flag3 = 1;
						}
					}
					break;
				case 1: // 
					if(yPos < hgt - 1){
						val = data[(yPos + 1) * wdh + i];
						if(val_src != val){
							flag2 = 0;
						}
						else if(!flag2 && val_src == val){
							m_ptStack[m_numStack].x = i;
							m_ptStack[m_numStack].y = yPos + 1;
							m_numStack ++;
							if(!CheckStackSize())
								return 0;
							flag2 = 1;
							flag3 = 1;
						}
					}
					break;
				case 2: // 
					if(xPos > 0){
						val = data[i * wdh + (xPos - 1)];
						if(val_src != val){
							flag1 = 0;
						}
						else if(!flag1 && val_src == val){
							m_ptStack[m_numStack].x = xPos - 1;
							m_ptStack[m_numStack].y = i;
							m_numStack ++;
							if(!CheckStackSize())
								return 0;
							flag1 = 1;
							flag3 = 1;
						}
					}
					break;
				case 3: // E
					if(xPos < wdh - 1){
						val = data[i * wdh + (xPos + 1)];
						if(val_src != val){
							flag2 = 0;
						}
						else if(!flag2 && val_src == val){
							m_ptStack[m_numStack].x = xPos + 1;
							m_ptStack[m_numStack].y = i;
							m_numStack ++;
							if(!CheckStackSize())
								return 0;
							flag2 = 1;
							flag3 = 1;
						}
					}
					break;
				}
			}
			m_numStack --;
			if(m_numStack < 0) break;
		}
	}
	return 1;
}// BucketSub

// _(xPos, yPos)̉̓lŘAsNZʒu߂
POINT CLabyrinth::BucketSubX(LPBYTE data, int wdh, int hgt, int xPos, int yPos, BYTE val_src, BYTE val_dst)
{
	int 	x;
	POINT	pt;
	BYTE	val;
	
	// _(xPos, yPos)̍𒲂ׂ
	x = 0;
	while (xPos >= x){
		int index = yPos * wdh + (xPos - x);
		val = data[index];
		if(val_src == val)
			data[index] = val_dst;
		else
			break;
		x ++;
	}
	pt.x = xPos - (x - 1);
	
	// _(xPos, yPos)̉E𒲂ׂ
	x = 1;
	while (x < (wdh - xPos)){
		int index = yPos * wdh + (xPos + x);
		val = data[index];
		if(val_src == val)
			data[index] = val_dst;
		else
			break;
		x ++;
	}
	pt.y = xPos + (x - 1);
	
	return pt;
}// BucketSubX

// _(xPos, yPos)̏c̓lŘAsNZʒu߂
POINT CLabyrinth::BucketSubY(LPBYTE data, int wdh, int hgt, int xPos, int yPos, BYTE val_src, BYTE val_dst)
{
	int 	y;
	POINT	pt;
	BYTE	val;
	
	// _(xPos, yPos)̏㑤𒲂ׂ
	y = 0;
	while (yPos >= y){
		int index = (yPos - y) * wdh + xPos;
		val = data[index];
		if(val_src == val)
			data[index] = val_dst;
		else
			break;
		y ++;
	}
	pt.x = yPos - (y - 1);
	
	// _(xPos, yPos)̉𒲂ׂ
	y = 1;
	while (y < (hgt - yPos)){
		int index = (yPos + y) * wdh + xPos;
		val = data[index];
		if(val_src == val)
			data[index] = val_dst;
		else
			break;
		y ++;
	}
	pt.y = yPos + (y - 1);
	
	return pt;
}// BucketSubY

// X^bNg؂AX^bNTCY𑝂₷
bool CLabyrinth::CheckStackSize()
{
	size_t size = _msize(m_ptStack);
	if(m_numStack * sizeof(POINT) >= size){
		m_ptStack = (POINT*)realloc(m_ptStack, size + 512 * sizeof(POINT));
		if(!m_ptStack){
			return 0;
		}
	}
	return 1;
}// CheckStackSize

#endif