// Y
// l^FDirectX9 Tv
#ifndef _LENS_H_
#define _LENS_H_

#include <d3dx9.h>

class CLens
{
public:
	void	Init(float fPowerX, float fPowerY);
	HRESULT Render(LPDIRECT3DDEVICE9 pD3DDev);
	virtual HRESULT RenderMesh(LPDIRECT3DDEVICE9 pD3DDev) = 0;
	
private:
	D3DXMATRIX m_matTex;
};

// 
// fPowerX,fPowerY : [IN] Y̓x
void CLens::Init(float fPowerX, float fPowerY)
{
	// Generate texture coords depending on objects camera space position
	m_matTex._11 = fPowerX; m_matTex._12 = 0.0f;
	m_matTex._21 = 0.0f;	m_matTex._22 =-fPowerX;
	m_matTex._31 = 0.0f;	m_matTex._32 = 0.0f;
	m_matTex._41 = fPowerY; m_matTex._42 = fPowerY;
}

// _O
// pD3DDev : [IN] IDirect3DDevice9 IuWFNg
HRESULT CLens::Render(LPDIRECT3DDEVICE9 pD3DDev)
{
	HRESULT 	hr;
	DWORD		dwTex0Index_pre,dwTex0Frag_pre;
	D3DXMATRIX	matTex0_pre;
	
	// ȑȌԂێ
	hr = pD3DDev->GetTransform( D3DTS_TEXTURE0, &matTex0_pre );
	hr = pD3DDev->GetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, &dwTex0Frag_pre );
	hr = pD3DDev->GetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, &dwTex0Index_pre);
	
	hr = pD3DDev->SetTransform( D3DTS_TEXTURE0, &m_matTex );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEPOSITION | 1);
	
	hr = RenderMesh(pD3DDev);
	
	// ɖ߂
	hr = pD3DDev->SetTransform( D3DTS_TEXTURE0, &matTex0_pre );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, dwTex0Frag_pre );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, dwTex0Index_pre);
	
	return hr;
}

#endif