// Ɩݒ
#ifndef _LIGHT_H_
#define _LIGHT_H_

#include <d3dx9.h>

struct LIGHT_DIRECTIONAL {
	D3DCOLORVALUE	Color;
	D3DVECTOR		Direction;
};

struct LIGHT_POINT {
	D3DCOLORVALUE	Color;
	D3DVECTOR		Position;
	float			Range;
	float			Falloff;
	float			Attenuation0;
	float			Attenuation1;
	float			Attenuation2;
};

struct LIGHT_SPOT {
	D3DCOLORVALUE	Color;
	D3DVECTOR		Position;
	D3DVECTOR		Direction;
	float			Range;
	float			Falloff;
	float			Attenuation0;
	float			Attenuation1;
	float			Attenuation2;
	float			Theta;
	float			Phi;
};

class CLight
{
public:
	void SetFlagLighting(LPDIRECT3DDEVICE9 pD3DDev, BOOL flag) { if(pD3DDev){pD3DDev->SetRenderState(D3DRS_LIGHTING, flag);} }
	BOOL GetFlagLighting(LPDIRECT3DDEVICE9 pD3DDev);
	void SetFlagLight(LPDIRECT3DDEVICE9 pD3DDev, int index, BOOL flag) { if(pD3DDev){pD3DDev->LightEnable(index, flag);} }
	BOOL GetFlagLight(LPDIRECT3DDEVICE9 pD3DDev, int index);
	void SetFlagSpecular(LPDIRECT3DDEVICE9 pD3DDev, BOOL flag);
	BOOL GetFlagSpecular(LPDIRECT3DDEVICE9 pD3DDev);
	void SetAmbient(LPDIRECT3DDEVICE9 pD3DDev, D3DCOLOR color) { if(pD3DDev){pD3DDev->SetRenderState(D3DRS_AMBIENT, color);} }
	D3DCOLOR GetAmbient(LPDIRECT3DDEVICE9 pD3DDev);
	void SetLightDirectional(LPDIRECT3DDEVICE9 pD3DDev, int index, LIGHT_DIRECTIONAL inf);
	void SetLightPoint(LPDIRECT3DDEVICE9 pD3DDev, int index, LIGHT_POINT inf);
	void SetLightSpot(LPDIRECT3DDEVICE9 pD3DDev, int index, LIGHT_SPOT inf);
};

// ƖLtO擾iTRUE or FALSEj
BOOL CLight::GetFlagLighting(LPDIRECT3DDEVICE9 pD3DDev)
{
	DWORD flag = FALSE;
	if(pD3DDev)
		pD3DDev->GetRenderState(D3DRS_LIGHTING, &flag);
	return flag;
}

// wԍ̏Ɩ̗LtO擾iTRUE or FALSEj
BOOL CLight::GetFlagLight(LPDIRECT3DDEVICE9 pD3DDev, int index)
{
	BOOL flag = FALSE;
	if(pD3DDev)
		pD3DDev->GetLightEnable(index, &flag);
	return flag;
}

// XyL˗LtOݒiTRUE or FALSEj
void CLight::SetFlagSpecular(LPDIRECT3DDEVICE9 pD3DDev, BOOL flag)
{
	if(pD3DDev){
		pD3DDev->SetRenderState(D3DRS_SPECULARENABLE, flag);
		pD3DDev->SetRenderState(D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL);
	}
}

// XyL˗LtO擾iTRUE or FALSEj
BOOL CLight::GetFlagSpecular(LPDIRECT3DDEVICE9 pD3DDev)
{
	DWORD flag = FALSE;
	if(pD3DDev)
		pD3DDev->GetRenderState(D3DRS_SPECULARENABLE, &flag);
	return flag;
}

// ݂̃ArGgF擾
D3DCOLOR CLight::GetAmbient(LPDIRECT3DDEVICE9 pD3DDev)
{
	D3DCOLOR color = 0;
	if(pD3DDev)
		pD3DDev->GetRenderState(D3DRS_AMBIENT, &color);
	return color;
}

// fBNVi Cgݒ
// index : [IN] Ɩԍ
// inf	 : [IN] Ɩ
void CLight::SetLightDirectional(LPDIRECT3DDEVICE9 pD3DDev, int index, LIGHT_DIRECTIONAL inf)
{
	if(pD3DDev){
		D3DLIGHT9 light;
		ZeroMemory(&light, sizeof(D3DLIGHT9));
		light.Type		= D3DLIGHT_DIRECTIONAL;
		light.Diffuse	= light.Specular = inf.Color;
		light.Direction = inf.Direction;
		pD3DDev->SetLight(index, &light);
	}
}

// |Cg Cgݒ
// index : [IN] Ɩԍ
// inf	 : [IN] Ɩ
void CLight::SetLightPoint(LPDIRECT3DDEVICE9 pD3DDev, int index, LIGHT_POINT inf)
{
	if(pD3DDev){
		D3DLIGHT9 light;
		ZeroMemory(&light, sizeof(D3DLIGHT9));
		light.Type		   = D3DLIGHT_POINT;
		light.Diffuse	   = light.Specular = light.Ambient = inf.Color;
		light.Position	   = inf.Position;
		light.Range 	   = inf.Range;
		light.Falloff	   = inf.Falloff;
		light.Attenuation0 = inf.Attenuation0;
		light.Attenuation1 = inf.Attenuation1;
		light.Attenuation2 = inf.Attenuation2;
		pD3DDev->SetLight(index, &light);
	}
}

// X|bg Cgݒ
// index : [IN] Ɩԍ
// inf	 : [IN] Ɩ
void CLight::SetLightSpot(LPDIRECT3DDEVICE9 pD3DDev, int index, LIGHT_SPOT inf)
{
	if(pD3DDev){
		D3DLIGHT9 light;
		ZeroMemory(&light, sizeof(D3DLIGHT9));
		light.Type		   = D3DLIGHT_SPOT;
		light.Diffuse	   = light.Specular = inf.Color;
		light.Direction    = inf.Direction;
		light.Position	   = inf.Position;
		light.Range 	   = inf.Range;
		light.Falloff	   = inf.Falloff;
		light.Attenuation0 = inf.Attenuation0;
		light.Attenuation1 = inf.Attenuation1;
		light.Attenuation2 = inf.Attenuation2;
		light.Theta 	   = inf.Theta;
		light.Phi		   = inf.Phi;
		pD3DDev->SetLight(index, &light);
	}
}

#endif