// `揇擾
// s͎_߂A͉Ƀ\[g
#ifndef _ORDER_H_
#define _ORDER_H_

#include <d3dx9.h>
#include "macro.h"

typedef struct	// f
{
	int 		index;	// fԍ
	D3DXVECTOR3 pos;	// W
	float		fLen;	// _̋
}ORDER,*LPORDER;

// \[g֐ij
int CmpOrderRise(const void *a, const void *b);
// \[g֐i~j
int CmpOrderFall(const void *a, const void *b);

class COrder
{
public:
	COrder();
	~COrder() { Free(); }
	// 
	void		Init(int iNum);
	// I
	void		Free();
	// fԂ
	int 		GetCount() { return m_iOrderNum; }
	// _Wݒ
	void		SetEyePos(D3DXVECTOR3 pos) { m_posEye = pos; }
	// fݒ
	void		SetData(int index, D3DXVECTOR3 pos, bool bAlpha);
	// w`揇̃fԍ擾
	int 		GetIndex(int index) { return m_orderX[index].index; }
	// w`揇̃fW擾
	D3DXVECTOR3 GetPos(int index) { return m_orderX[index].pos; }
	// ёւ
	void	Sort();
	
private:
	D3DXVECTOR3 m_posEye;		// _W
	LPORDER 	m_orderX;		// ёւf[^z
	LPORDER 	m_orderA;		// ёւf[^z
	int 		m_iOrderNumMax; // m_order ̗vf̍ő吔
	int 		m_iOrderNum;	// m_order ̎ۂ̗vf
	int 		m_iOrderXCount; // m_orderX ɒlĂ鐔
	int 		m_iOrderACount; // m_orderA ɒlĂ鐔
};

COrder::COrder()
{
	m_orderX = NULL;
	m_orderA = NULL;
	m_iOrderNum    = 0;
	m_iOrderNumMax = 0;
	m_iOrderXCount = 0;
	m_iOrderACount = 0;
}

// 
// iNum : [IN] `悷郂f̍ő吔
void COrder::Init(int iNum)
{
	Free();
	
	m_iOrderNum    = 0;
	m_iOrderXCount = 0;
	m_iOrderACount = 0;
	m_iOrderNumMax = iNum;
	m_orderX = new ORDER [iNum];
	m_orderA = new ORDER [iNum];
}

// I
void COrder::Free()
{
	SAFE_DELETE_ARRAY(m_orderX);
	SAFE_DELETE_ARRAY(m_orderA);
}

// fݒ
// index  : [IN] fԍ
// pos	  : [IN] fʒu
// bAlpha : [IN] }eAɔ܂܂Ă true
void COrder::SetData(int index, D3DXVECTOR3 pos, bool bAlpha)
{
	float sub_x = pos.x - m_posEye.x;
	float sub_y = pos.y - m_posEye.y;
	float sub_z = pos.z - m_posEye.z;
	float dist	= sub_x * sub_x + sub_y * sub_y + sub_z * sub_z;
	if(!bAlpha){
		if(m_iOrderXCount < 0)
			m_iOrderXCount = 0;
		else if(m_iOrderXCount >= m_iOrderNumMax)
			m_iOrderXCount = m_iOrderNumMax - 1;
		m_orderX[m_iOrderXCount].index = index;
		m_orderX[m_iOrderXCount].pos   = pos;
		m_orderX[m_iOrderXCount].fLen  = dist;
		m_iOrderXCount ++;
	}
	else{
		if(m_iOrderACount < 0)
			m_iOrderACount = 0;
		else if(m_iOrderACount >= m_iOrderNumMax)
			m_iOrderACount = m_iOrderNumMax - 1;
		m_orderA[m_iOrderACount].index = index;
		m_orderA[m_iOrderACount].pos   = pos;
		m_orderA[m_iOrderACount].fLen  = dist;
		m_iOrderACount ++;
	}
}

// ёւ
void COrder::Sort()
{
	if(m_iOrderXCount > 0){
		qsort(m_orderX, m_iOrderXCount, sizeof(ORDER), CmpOrderRise);
	}
	if(m_iOrderACount > 0){
		qsort(m_orderA, m_iOrderACount, sizeof(ORDER), CmpOrderFall);
	}
	int i,index;
	m_iOrderNum = m_iOrderXCount;
	for(i=0; i<m_iOrderACount; i++){
		index = m_iOrderXCount + i;
		if(index < m_iOrderNumMax){
			m_orderX[index] = m_orderA[i];
			m_iOrderNum ++;
		}
	}
	m_iOrderXCount = 0;
	m_iOrderACount = 0;
}

// NCbN\[g̔r֐ij
int CmpOrderRise(const void *a, const void *b)
{
	LPORDER a2 = (LPORDER) a;
	LPORDER b2 = (LPORDER) b;
	int res = 0;
	float val = a2->fLen - b2->fLen;
	if(val > 0) 		res = 1;
	else if(val < 0)	res = -1;
	return res;
}

// NCbN\[g̔r֐i~j
int CmpOrderFall(const void *a, const void *b)
{
	LPORDER a2 = (LPORDER) a;
	LPORDER b2 = (LPORDER) b;
	int res = 0;
	float val = b2->fLen - a2->fLen;;
	if(val > 0) 		res = 1;
	else if(val < 0)	res = -1;
	return res;
}

#endif