// 
#ifndef _PARABOLA_H_
#define _PARABOLA_H_

#include <d3dx9.h>
#include "fvf.h"
#include "rand.h"

typedef struct	// 
{
	char	*strTextureFilename;	// eNX`t@C
	float	fBulletSize;			// eۃTCY
	int 	iBulletNum; 			// eې
	int 	iBulletLength;			// eے
	int 	iPaddingNum;			// eۊԂ𖄂߂鐔 + 1
	BYTE	r,g,b;					// eېF
	float	x,y;					// ˈʒu
	float	fInitialVelocity;		// 
	int 	iWide;					// px̍Li1 ` 900j
	int 	iUpward;				// xi0 ` 899j
	bool	bBothSides; 			// tOi0:БA1:j
}PARABOLA,*LPPARABOLA;

struct BULLET	// eۏ
{
	bool		bShow;			// \tO
	BYTE		r,g,b;			// F
	float		fSpeed; 		// x
	D3DXVECTOR2 v;				// xNg X,Y 
	D3DXVECTOR2 *pPos;			// ʒuieۂƔj
	D3DXVECTOR3 **ppPosPadding; // ʒuĩpfBOj
};

class CParabola
{
public:
	CParabola();
	~CParabola();
	void	Free();
	void	Load(LPDIRECT3DDEVICE9 pD3DDev, PARABOLA *inf);
	HRESULT Render(LPDIRECT3DDEVICE9 pD3DDev);
	
private:
	float				m_fBulletSize;		// eۃTCY
	int 				m_iBulletNum;		// eې
	int 				m_iBulletLength;	// eے
	int 				m_iPaddingNum;		// eۊԂ𖄂߂鐔 + 1
	D3DXVECTOR2 		m_posStart; 		// ˈʒu
	float				m_init_y;			// YW
	float				m_fInitialVelocity; // 
	int 				m_iWide;			// px̍Li1 ` 900APʁF100~xj
	int 				m_iUpward;			// xi0 ` 899APʁF100~xj
	bool				m_bBothSides;		// tOi0:БA1:j
	VERTEX_C*			m_pPtcl;			// eە`
	BULLET* 			m_pBullet;			// eۏ
	BYTE*				m_pbAlpha;			// eۓx
	int*				m_piIndex;			// pfBO̔ԍ
	LPDIRECT3DTEXTURE9	m_pTex; 			// eۃeNX`
	
private:
	HRESULT Draw_Bullet(LPDIRECT3DDEVICE9 pD3DDev);
};

CParabola::CParabola()
{
	m_pPtcl 	= NULL;
	m_pBullet	= NULL;
	m_pbAlpha	= NULL;
	m_pTex		= NULL;
}

CParabola::~CParabola()
{
	Free();
}

void CParabola::Free()
{
	int i,j;
	for(i=0; i<m_iBulletNum; i++){
		for(j=0; j<m_iBulletLength; j++){
			SAFE_DELETE_ARRAY(m_pBullet[i].ppPosPadding[j]);
		}
		SAFE_DELETE_ARRAY(m_pBullet[i].pPos);
		SAFE_DELETE_ARRAY(m_pBullet[i].ppPosPadding);
	}
	SAFE_DELETE_ARRAY(m_pBullet);
	SAFE_DELETE_ARRAY(m_pPtcl);
	SAFE_DELETE_ARRAY(m_pbAlpha);
	SAFE_DELETE_ARRAY(m_piIndex);
	SAFE_RELEASE(m_pTex);
}

// 
// pD3DDev : [IN] IDirect3DDevice9 IuWFNg
// inf	   : [IN] 
void CParabola::Load(LPDIRECT3DDEVICE9 pD3DDev, PARABOLA *inf)
{
	if(FAILED(D3DXCreateTextureFromFile(pD3DDev, inf->strTextureFilename, &m_pTex))){
		m_pTex = NULL;
	}
	
	int i,j,k;
	
	m_fBulletSize		= inf->fBulletSize;
	m_iBulletNum		= inf->iBulletNum;
	m_iBulletLength 	= inf->iBulletLength;
	m_iPaddingNum		= inf->iPaddingNum;
	m_posStart			= D3DXVECTOR2(inf->x, inf->y);
	m_init_y			= -1000.0f;
	m_fInitialVelocity	= inf->fInitialVelocity;
	m_iWide 			= inf->iWide;
	if(m_iWide < 1)
		m_iWide = 1;
	else if(m_iWide > 899)
		m_iWide = 899;
	m_iUpward			= inf->iUpward;
	if(m_iUpward < 0)
		m_iUpward = 0;
	else if(m_iWide + m_iUpward > 900)
		m_iUpward = 900 - m_iWide;
	m_bBothSides		= inf->bBothSides;
	m_pPtcl 	= new VERTEX_C [m_iBulletLength * m_iPaddingNum];
	m_pbAlpha	= new BYTE	   [m_iBulletLength * m_iPaddingNum];
	m_piIndex	= new int	   [m_iPaddingNum + 1];
	m_pBullet	= new BULLET   [m_iBulletNum];
	ZeroMemory(m_pPtcl, sizeof(VERTEX_C) * m_iBulletLength * m_iPaddingNum);
	if(m_pBullet){
		for(i=0; i<m_iBulletNum; i++){
			m_pBullet[i].pPos			= new D3DXVECTOR2  [m_iBulletLength];
			m_pBullet[i].ppPosPadding	= new D3DXVECTOR3* [m_iBulletLength];
			if(m_pBullet[i].ppPosPadding){
				for(j=0; j<m_iBulletLength; j++){
					m_pBullet[i].ppPosPadding[j] = new D3DXVECTOR3 [m_iPaddingNum - 1];
				}
			}
		}
	}
	for(i=0; i<m_iBulletNum; i++){
		for(j=0; j<m_iBulletLength; j++){
			for(k=0; k<m_iPaddingNum-1; k++){
				m_pBullet[i].ppPosPadding[j][k].y = m_init_y;
				m_pBullet[i].ppPosPadding[j][k].z = 0;
			}
			m_pBullet[i].pPos[j].y = m_init_y;
		}
		m_pBullet[i].r = inf->r;
		m_pBullet[i].g = inf->g;
		m_pBullet[i].b = inf->b;
	}
	if(m_pbAlpha){
		for(i=0;i<m_iBulletLength * m_iPaddingNum;i++){
			m_pbAlpha[i] = (BYTE)(255 - 255 * i / (m_iBulletLength * m_iPaddingNum));
		}
	}
}

// _O
// pD3DDev : [IN] IDirect3DDevice9 IuWFNg
HRESULT CParabola::Render(LPDIRECT3DDEVICE9 pD3DDev)
{
	HRESULT hr;
	DWORD	dwLighting_pre,dwShadeMode_pre;
	DWORD	dwEnableAlpha_pre,dwSrcAlpha_pre,dwDestAlpha_pre;
	DWORD	dwPtEnable_pre,dwPtScaleEnable_pre,dwPtSize_pre;
	DWORD	dwPtScaleA_pre,dwPtScaleB_pre,dwPtScaleC_pre;
	
	// ȑȌԂێ
	hr = pD3DDev->GetRenderState(D3DRS_LIGHTING,		  &dwLighting_pre);
	hr = pD3DDev->GetRenderState(D3DRS_SHADEMODE,		  &dwShadeMode_pre);
	hr = pD3DDev->GetRenderState(D3DRS_ALPHABLENDENABLE,  &dwEnableAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_SRCBLEND,		  &dwSrcAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_DESTBLEND,		  &dwDestAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSPRITEENABLE, &dwPtEnable_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSCALEENABLE,  &dwPtScaleEnable_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSIZE,		  &dwPtSize_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSCALE_A,	  &dwPtScaleA_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSCALE_B,	  &dwPtScaleB_pre);
	hr = pD3DDev->GetRenderState(D3DRS_POINTSCALE_C,	  &dwPtScaleC_pre);
	
	hr = pD3DDev->SetRenderState(D3DRS_LIGHTING,		 FALSE);
	hr = pD3DDev->SetRenderState(D3DRS_SHADEMODE,		 D3DSHADE_FLAT);
	hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	hr = pD3DDev->SetRenderState(D3DRS_SRCBLEND,		 D3DBLEND_ONE);
	hr = pD3DDev->SetRenderState(D3DRS_DESTBLEND,		 D3DBLEND_ONE);
	
	hr = Draw_Bullet(pD3DDev);
	
	// ɖ߂
	hr = pD3DDev->SetRenderState(D3DRS_LIGHTING,		  dwLighting_pre);
	hr = pD3DDev->SetRenderState(D3DRS_SHADEMODE,		  dwShadeMode_pre);
	hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE,  dwEnableAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_SRCBLEND,		  dwSrcAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_DESTBLEND,		  dwDestAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSPRITEENABLE, dwPtEnable_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALEENABLE,  dwPtScaleEnable_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSIZE,		  dwPtSize_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_A,	  dwPtScaleA_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_B,	  dwPtScaleB_pre);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_C,	  dwPtScaleC_pre);
	
	return hr;
}

// eۂ̕`
HRESULT CParabola::Draw_Bullet(LPDIRECT3DDEVICE9 pD3DDev)
{
	HRESULT 	hr;
	int 		i,j,k;
	BYTE		alpha;			// x
	float		theta;			// ˊpx
	const float speed = 0.01f;	// x
	const float precalc_theta	= 0.1f * 3.14f / 180.0f;
	const float precalc_gravity = 0.5f * 9.8f;
	static int	count = 1;
	
	// |CgXvCgݒ
	hr = pD3DDev->SetRenderState(D3DRS_POINTSPRITEENABLE, TRUE);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALEENABLE,  TRUE);
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_A, F2DW(0.00f));
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_B, F2DW(0.00f));
	hr = pD3DDev->SetRenderState(D3DRS_POINTSCALE_C, F2DW(1.00f));
	// eۂ̑傫
	hr = pD3DDev->SetRenderState(D3DRS_POINTSIZE, F2DW(m_fBulletSize));
	
	// _^ݒ
	hr = pD3DDev->SetFVF(FVF_VERTEX_C);
	// eNX`ݒ
	hr = pD3DDev->SetTexture(0, m_pTex);
	// `
	for(i=0;i<count;i++){
		if(!m_pBullet[i].bShow){
			m_pBullet[i].fSpeed = 0;
			theta = ((float)GetRand(m_iWide) + m_iUpward) * precalc_theta;
			m_pBullet[i].v.x = m_fInitialVelocity * (float)cos(theta);
			m_pBullet[i].v.y = m_fInitialVelocity * (float)sin(theta);
			if(m_bBothSides && GetRand(2) == 1){
				m_pBullet[i].v.x = - m_pBullet[i].v.x;
			}
			m_pBullet[i].bShow = 1;
		}
		for(j=m_iBulletLength-1;j>=0;j--){
			// eۂƔ̏ݒ
			m_piIndex[0] = j * m_iPaddingNum;
			if(j > 0){	// eۂ̔̍Wݒ
				m_pPtcl[m_piIndex[0]].v.x = m_pBullet[i].pPos[j].x = m_pBullet[i].pPos[j-1].x;
				m_pPtcl[m_piIndex[0]].v.y = m_pBullet[i].pPos[j].y = m_pBullet[i].pPos[j-1].y;
			}
			else{		// eۂ̍WvZ
				m_pPtcl[0].v.x = m_pBullet[i].pPos[0].x = m_posStart.x + m_pBullet[i].v.x * m_pBullet[i].fSpeed;
				m_pPtcl[0].v.y = m_pBullet[i].pPos[0].y = m_posStart.y + m_pBullet[i].v.y * m_pBullet[i].fSpeed - precalc_gravity * m_pBullet[i].fSpeed * m_pBullet[i].fSpeed;
			}
			alpha = m_pbAlpha[m_piIndex[0]];
			m_pPtcl[m_piIndex[0]].c = D3DCOLOR_XRGB(alpha & m_pBullet[i].r, alpha & m_pBullet[i].g, alpha & m_pBullet[i].b);
			// ̌Ԃ𖄂߂
			for(k=0;k<m_iPaddingNum;k++){
				m_piIndex[k+1] = m_piIndex[k] + 1;
			}
			if(m_pPtcl[m_piIndex[0]].v.y > m_posStart.y || (m_pPtcl[m_piIndex[m_iPaddingNum]].v.y - m_pPtcl[m_piIndex[0]].v.y > 0)){
				if(j > 0){
					for(k=0;k<m_iPaddingNum-1;k++){
						m_pPtcl[m_piIndex[k+1]].v = m_pBullet[i].ppPosPadding[j][k] = m_pBullet[i].ppPosPadding[j-1][k];
					}
				}
				else{
					D3DXVECTOR3 len,v_sum;
					len.x = (m_pPtcl[m_piIndex[m_iPaddingNum]].v.x - m_pPtcl[m_piIndex[0]].v.x) / m_iPaddingNum;
					len.y = (m_pPtcl[m_piIndex[m_iPaddingNum]].v.y - m_pPtcl[m_piIndex[0]].v.y) / m_iPaddingNum;
					v_sum = m_pPtcl[m_piIndex[0]].v;
					for(k=0;k<m_iPaddingNum-1;k++){
						v_sum += len;
						m_pPtcl[m_piIndex[k+1]].v = m_pBullet[i].ppPosPadding[j][k] = v_sum;
					}
				}
				for(k=0;k<m_iPaddingNum-1;k++){
					alpha = m_pbAlpha[m_piIndex[k+1]];
					m_pPtcl[m_piIndex[k+1]].c = D3DCOLOR_XRGB(alpha & m_pBullet[i].r, alpha & m_pBullet[i].g, alpha & m_pBullet[i].b);
				}
			}
			else{
				for(k=0;k<m_iPaddingNum-1;k++){
					m_pPtcl[m_piIndex[k+1]].v.x = 0;
					m_pPtcl[m_piIndex[k+1]].v.y = m_init_y;
					m_pPtcl[m_piIndex[k+1]].c	= 0;
				}
			}
		}
		// _O
		hr = pD3DDev->DrawPrimitiveUP(D3DPT_POINTLIST, m_iBulletLength * m_iPaddingNum, m_pPtcl, sizeof(VERTEX_C));
		m_pBullet[i].fSpeed += speed;
		// nʂɒ珉
		if(m_pBullet[i].pPos[0].y < m_posStart.y){
			m_pBullet[i].bShow = 0;
		}
	}
	if(count < m_iBulletNum){
		count ++;
	}
	
	return hr;
}// Draw_Bullet

#endif