// Vh[{[
// bV́AXt@C`iAj͕sjŁA
// bV̒_tH[}bǵAFVF_MESHVERTEX gpAݒ͈ȉ̂悤ɂ
// d3dpp.AutoDepthStencilFormat = D3DFMT_D24S8;
// pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER | D3DCLEAR_STENCIL,0,1.0f,0);
// l^FDirectX9 Tv
#ifndef _SHADOW_VOLUME_H_
#define _SHADOW_VOLUME_H_

#include <d3dx9.h>
#include "macro.h"

struct MESHVERTEX		// bV̒_tH[}bg
{
	D3DXVECTOR3 v;		// W
	D3DXVECTOR3 n;		// @xNg
	float		tu,tv;	// eNX`W
};
#define FVF_MESHVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)

struct VERTEX_SHADOW	// Vh[{[̒_tH[}bg
{
	D3DXVECTOR4 v;		// W
	D3DCOLOR	c;		// F
};
#define FVF_VERTEX_SHADOW (D3DFVF_XYZRHW | D3DFVF_DIFFUSE)

class CShadowVolume
{
public:
	CShadowVolume();
	~CShadowVolume();
	HRESULT Init( LPDIRECT3DDEVICE9 pD3DDev, D3DCOLOR shadow_color );
	VOID	Free();
	HRESULT Render( LPDIRECT3DDEVICE9 pD3DDev, LPD3DXMESH pObject );
	
private:
	D3DXVECTOR3 m_pVertices[32000]; // Vertex data for rendering shadow volume
	DWORD		m_dwNumVertices;
	D3DCAPS9	m_d3dCaps;			// foCX
	LPDIRECT3DVERTEXBUFFER9 m_pBigSquareVB;
	
private:
	HRESULT RenderShadowVolume( LPDIRECT3DDEVICE9 pD3DDev );
	VOID	AddEdge( WORD* pEdges, DWORD& dwNumEdges, WORD v0, WORD v1 );
	VOID	Reset() { m_dwNumVertices = 0L; }
	HRESULT BuildFromMesh( LPD3DXMESH pObject, D3DXVECTOR3 vLight );
	HRESULT RenderShadow( LPDIRECT3DDEVICE9 pD3DDev );
	HRESULT DrawShadow( LPDIRECT3DDEVICE9 pD3DDev );
};

CShadowVolume::CShadowVolume()
{
	ZeroMemory(&m_d3dCaps, sizeof(m_d3dCaps));
	m_pBigSquareVB = NULL;
}

CShadowVolume::~CShadowVolume()
{
	Free();
}

// CShadowVolume IuWFNg
// shadow_color : [IN] e̐F
HRESULT CShadowVolume::Init( LPDIRECT3DDEVICE9 pD3DDev, D3DCOLOR shadow_color )
{
	Free();
	
	// Create a big square for rendering the stencilbuffer contents
	if( FAILED( pD3DDev->CreateVertexBuffer( 4*sizeof(VERTEX_SHADOW),
									   D3DUSAGE_WRITEONLY, FVF_VERTEX_SHADOW,
									   D3DPOOL_MANAGED, &m_pBigSquareVB, NULL ) ) )
		return E_FAIL;

	pD3DDev->GetDeviceCaps(&m_d3dCaps); // foCX
	D3DSURFACE_DESC 	dscBackBuffer;	// obNobt@
	LPDIRECT3DSURFACE9	pBackBuffer = NULL;
	pD3DDev->GetBackBuffer( 0, 0, D3DBACKBUFFER_TYPE_MONO, &pBackBuffer );
	pBackBuffer->GetDesc( &dscBackBuffer );
	pBackBuffer->Release();

	// Set the size of the big square shadow
	VERTEX_SHADOW* v;
	FLOAT sx = (FLOAT)dscBackBuffer.Width;
	FLOAT sy = (FLOAT)dscBackBuffer.Height;
	m_pBigSquareVB->Lock( 0, 0, (void**)&v, 0 );
	v[0].v = D3DXVECTOR4(  0, sy, 0.0f, 1.0f );
	v[1].v = D3DXVECTOR4(  0,  0, 0.0f, 1.0f );
	v[2].v = D3DXVECTOR4( sx, sy, 0.0f, 1.0f );
	v[3].v = D3DXVECTOR4( sx,  0, 0.0f, 1.0f );
	v[0].c = shadow_color;
	v[1].c = shadow_color;
	v[2].c = shadow_color;
	v[3].c = shadow_color;
	m_pBigSquareVB->Unlock();

	return S_OK;
}

VOID CShadowVolume::Free()
{
	SAFE_RELEASE( m_pBigSquareVB );
}

// e̕`
HRESULT CShadowVolume::Render( LPDIRECT3DDEVICE9 pD3DDev, LPD3DXMESH pObject )
{
	if(!pD3DDev || !pObject){
		return E_FAIL;
	}
	
	HRESULT 	hr;
	D3DLIGHT9	light;
	
	hr = pD3DDev->GetLight(0, &light);
	D3DXVECTOR3 vLightDir = (D3DXVECTOR3) light.Direction;
	D3DXMATRIX	matDst,matWorld;
	hr = pD3DDev->GetTransform(D3DTS_WORLD, &matWorld);
	D3DXMatrixInverse(&matDst, NULL, &matWorld);
	D3DXVec3TransformCoord(&vLightDir, (LPD3DXVECTOR3) &(-vLightDir), &matDst);
	Reset();
	hr = BuildFromMesh(pObject, vLightDir);
	if(hr == S_OK){
		hr = RenderShadow(pD3DDev);
		hr = DrawShadow(pD3DDev);
	}
	
	return hr;
}

HRESULT CShadowVolume::RenderShadowVolume( LPDIRECT3DDEVICE9 pD3DDev )
{
	pD3DDev->SetFVF( D3DFVF_XYZ );

	return pD3DDev->DrawPrimitiveUP( D3DPT_TRIANGLELIST, m_dwNumVertices/3,
									m_pVertices, sizeof(D3DXVECTOR3) );
}

// GbWXgɃGbWǉ
// GbWƂ́Afɓ镔̗֊ŝƂł
VOID CShadowVolume::AddEdge( WORD* pEdges, DWORD& dwNumEdges, WORD v0, WORD v1 )
{
	// w肳ꂽXgɊɑ݂ꍇ́A
	// ֊sȊO̐Ȃ̂ŃXg폜
	DWORD i;
	for( i=0; i < dwNumEdges; i++ )
	{
		if( ( pEdges[2*i+0] == v0 && pEdges[2*i+1] == v1 ) ||
			( pEdges[2*i+0] == v1 && pEdges[2*i+1] == v0 ) )
		{
			if( dwNumEdges > 1 )
			{
				pEdges[2*i+0] = pEdges[2*(dwNumEdges-1)+0];
				pEdges[2*i+1] = pEdges[2*(dwNumEdges-1)+1];
			}
			dwNumEdges--;
			return;
		}
	}
	// w肳ꂽ_ŗ֊s̏ꍇ́AXg̍Ōɒǉ
	pEdges[2*dwNumEdges+0] = v0;
	pEdges[2*dwNumEdges+1] = v1;
	dwNumEdges++;
}

// Vh[{[쐬
// pMesh : bVf[^
// vLight: Ɩ̋txNg
HRESULT CShadowVolume::BuildFromMesh( LPD3DXMESH pMesh, D3DXVECTOR3 vLight )
{
	if(FVF_MESHVERTEX != pMesh->GetFVF()){
		return E_FAIL;
	}

	MESHVERTEX* pVertices;
	WORD*		pIndices;

	// Lock the geometry buffers
	pMesh->LockVertexBuffer( 0L, (LPVOID*)&pVertices );
	pMesh->LockIndexBuffer( 0L, (LPVOID*)&pIndices );
	DWORD dwNumFaces	= pMesh->GetNumFaces();

	// Allocate a temporary edge list
	WORD* pEdges = new WORD[dwNumFaces*6];
	if( pEdges == NULL )
	{
		pMesh->UnlockVertexBuffer();
		pMesh->UnlockIndexBuffer();
		return E_OUTOFMEMORY;
	}
	DWORD i,dwNumEdges = 0;

	// For each face
	for( i=0; i<dwNumFaces; i++ )
	{
		WORD wFace0 = pIndices[3*i+0];
		WORD wFace1 = pIndices[3*i+1];
		WORD wFace2 = pIndices[3*i+2];

		D3DXVECTOR3 v0 = pVertices[wFace0].v;
		D3DXVECTOR3 v1 = pVertices[wFace1].v;
		D3DXVECTOR3 v2 = pVertices[wFace2].v;

		// ʂ̖@xNg߂
		D3DXVECTOR3 vCross1(v2-v1);
		D3DXVECTOR3 vCross2(v1-v0);
		D3DXVECTOR3 vNormal;
		D3DXVec3Cross( &vNormal, &vCross1, &vCross2 );

		// ̋txNgƖ@xNg̐pxA݊pi90xȏj̏ꍇA
		// ܂Aʂ3̐GbW̌Ƃ
		if( D3DXVec3Dot( &vNormal, &vLight ) >= 0.0f )
		{
			AddEdge( pEdges, dwNumEdges, wFace0, wFace1 );
			AddEdge( pEdges, dwNumEdges, wFace1, wFace2 );
			AddEdge( pEdges, dwNumEdges, wFace2, wFace0 );
		}
	}

	// GbWƁÃGbWxNg̕10{̈ʒuɈړ
	// \lp`̖ʂ̒_WVh[{[̒_WƂ
	for( i=0; i<dwNumEdges; i++ )
	{
		D3DXVECTOR3 v1 = pVertices[pEdges[2*i+0]].v;
		D3DXVECTOR3 v2 = pVertices[pEdges[2*i+1]].v;
		D3DXVECTOR3 v3 = v1 - vLight*10;
		D3DXVECTOR3 v4 = v2 - vLight*10;

		// Add a quad (two triangles) to the vertex list
		m_pVertices[m_dwNumVertices++] = v1;
		m_pVertices[m_dwNumVertices++] = v2;
		m_pVertices[m_dwNumVertices++] = v3;

		m_pVertices[m_dwNumVertices++] = v2;
		m_pVertices[m_dwNumVertices++] = v4;
		m_pVertices[m_dwNumVertices++] = v3;
	}
	// Delete the temporary edge list
	delete[] pEdges;

	// Unlock the geometry buffers
	pMesh->UnlockVertexBuffer();
	pMesh->UnlockIndexBuffer();

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: RenderShadow()
// Desc:
//-----------------------------------------------------------------------------
HRESULT CShadowVolume::RenderShadow( LPDIRECT3DDEVICE9 pD3DDev )
{
	HRESULT hr;
	DWORD	dwZWrite_pre,dwStencil_pre,dwShadeMode_pre;
	DWORD	dwStcFunc_pre,dwStcZFail_pre,dwStcFail_pre;
	DWORD	dwStcRef_pre,dwStcMask_pre,dwStcWriteMask_pre;
	DWORD	dwStcPass_pre,dwTwoSideStc_pre,dwCullMode_pre;
	DWORD	dwEnableAlpha_pre,dwSrcAlpha_pre,dwDestAlpha_pre;
	
	hr = pD3DDev->GetRenderState(D3DRS_ZWRITEENABLE,  &dwZWrite_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILENABLE, &dwStencil_pre);
	hr = pD3DDev->GetRenderState(D3DRS_SHADEMODE,	  &dwShadeMode_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILFUNC,   &dwStcFunc_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILZFAIL,  &dwStcZFail_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILFAIL,   &dwStcFail_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILREF,	  &dwStcRef_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILMASK,   &dwStcMask_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILWRITEMASK, &dwStcWriteMask_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILPASS, 	 &dwStcPass_pre);
	hr = pD3DDev->GetRenderState(D3DRS_CULLMODE,		 &dwCullMode_pre);
	hr = pD3DDev->GetRenderState(D3DRS_TWOSIDEDSTENCILMODE, &dwTwoSideStc_pre);
	hr = pD3DDev->GetRenderState(D3DRS_ALPHABLENDENABLE,	&dwEnableAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_SRCBLEND,  &dwSrcAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_DESTBLEND, &dwDestAlpha_pre);
	
	// Disable z-buffer writes (note: z-testing still occurs), and enable the
	// stencil-buffer
	hr = pD3DDev->SetRenderState( D3DRS_ZWRITEENABLE,  FALSE );
	hr = pD3DDev->SetRenderState( D3DRS_STENCILENABLE, TRUE );

	// Dont bother with interpolating color
	hr = pD3DDev->SetRenderState( D3DRS_SHADEMODE,	  D3DSHADE_FLAT );

	// Set up stencil compare fuction, reference value, and masks.
	// Stencil test passes if ((ref & mask) cmpfn (stencil & mask)) is true.
	// Note: since we set up the stencil-test to always pass, the STENCILFAIL
	// renderstate is really not needed.
	hr = pD3DDev->SetRenderState( D3DRS_STENCILFUNC,  D3DCMP_ALWAYS );
	hr = pD3DDev->SetRenderState( D3DRS_STENCILZFAIL, D3DSTENCILOP_KEEP );
	hr = pD3DDev->SetRenderState( D3DRS_STENCILFAIL,  D3DSTENCILOP_KEEP );

	// If ztest passes, inc/decrement stencil buffer value
	hr = pD3DDev->SetRenderState( D3DRS_STENCILREF, 	 0x1 );
	hr = pD3DDev->SetRenderState( D3DRS_STENCILMASK,	 0xffffffff );
	hr = pD3DDev->SetRenderState( D3DRS_STENCILWRITEMASK, 0xffffffff );
	hr = pD3DDev->SetRenderState( D3DRS_STENCILPASS,	 D3DSTENCILOP_INCR );

	// Vh[{[̃bV͕\ȂiXeVobt@ɂ̂ݏށj
	hr = pD3DDev->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
	hr = pD3DDev->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_ZERO );
	hr = pD3DDev->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );

	if( ( m_d3dCaps.StencilCaps & D3DSTENCILCAPS_TWOSIDED ) != 0 )	// ʃXeVɑΉĂꍇ
	{
		// With 2-sided stencil, we can avoid rendering twice:
		hr = pD3DDev->SetRenderState( D3DRS_TWOSIDEDSTENCILMODE, TRUE );
		hr = pD3DDev->SetRenderState( D3DRS_CCW_STENCILFUNC,  D3DCMP_ALWAYS );
		hr = pD3DDev->SetRenderState( D3DRS_CCW_STENCILZFAIL, D3DSTENCILOP_KEEP );
		hr = pD3DDev->SetRenderState( D3DRS_CCW_STENCILFAIL,  D3DSTENCILOP_KEEP );
		hr = pD3DDev->SetRenderState( D3DRS_CCW_STENCILPASS,  D3DSTENCILOP_DECR );

		hr = pD3DDev->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

		// Draw both sides of shadow volume in stencil/z only
		hr = RenderShadowVolume( pD3DDev );

		hr = pD3DDev->SetRenderState(D3DRS_TWOSIDEDSTENCILMODE, dwTwoSideStc_pre);
	}
	else
	{
		// Draw front-side of shadow volume in stencil/z only
		hr = RenderShadowVolume( pD3DDev );

		// Now reverse cull order so back sides of shadow volume are written.
		hr = pD3DDev->SetRenderState( D3DRS_CULLMODE,	D3DCULL_CW );

		// Decrement stencil buffer value
		hr = pD3DDev->SetRenderState( D3DRS_STENCILPASS, D3DSTENCILOP_DECR );

		// Draw back-side of shadow volume in stencil/z only
		hr = RenderShadowVolume( pD3DDev );
	}

	// Restore render states
	hr = pD3DDev->SetRenderState(D3DRS_ZWRITEENABLE,  dwZWrite_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILENABLE, dwStencil_pre);
	hr = pD3DDev->SetRenderState(D3DRS_SHADEMODE,	  dwShadeMode_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILFUNC,   dwStcFunc_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILZFAIL,  dwStcZFail_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILFAIL,   dwStcFail_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILREF,	  dwStcRef_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILMASK,   dwStcMask_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILWRITEMASK, dwStcWriteMask_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILPASS, dwStcPass_pre);
	hr = pD3DDev->SetRenderState(D3DRS_CULLMODE,	dwCullMode_pre);
	hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, dwEnableAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_SRCBLEND,  dwSrcAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_DESTBLEND, dwDestAlpha_pre);

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: DrawShadow()
// Desc: Draws a big gray polygon over scene according to the mask in the
//		 stencil buffer. (Any pixel with stencil==1 is in the shadow.)
//-----------------------------------------------------------------------------
HRESULT CShadowVolume::DrawShadow( LPDIRECT3DDEVICE9 pD3DDev )
{
	HRESULT hr;
	DWORD	dwZ_pre,dwStencil_pre,dwFog_pre;
	DWORD	dwStcFunc_pre,dwStcRef_pre,dwStcPass_pre;
	DWORD	dwEnableAlpha_pre,dwSrcAlpha_pre,dwDestAlpha_pre;
	DWORD	dwClrArg1_pre,dwClrArg2_pre,dwClrRop_pre;
	DWORD	dwAlpArg1_pre,dwAlpArg2_pre,dwAlpRop_pre;
	
	hr = pD3DDev->GetRenderState(D3DRS_ZENABLE, 	  &dwZ_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILENABLE, &dwStencil_pre);
	hr = pD3DDev->GetRenderState(D3DRS_FOGENABLE,	  &dwFog_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILFUNC,   &dwStcFunc_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILREF,	  &dwStcRef_pre);
	hr = pD3DDev->GetRenderState(D3DRS_STENCILPASS,   &dwStcPass_pre);
	hr = pD3DDev->GetRenderState(D3DRS_ALPHABLENDENABLE, &dwEnableAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_SRCBLEND,  &dwSrcAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_DESTBLEND, &dwDestAlpha_pre);
	hr = pD3DDev->GetTextureStageState( 0, D3DTSS_COLORARG1, &dwClrArg1_pre );
	hr = pD3DDev->GetTextureStageState( 0, D3DTSS_COLORARG2, &dwClrArg2_pre );
	hr = pD3DDev->GetTextureStageState( 0, D3DTSS_COLOROP,	 &dwClrRop_pre );
	hr = pD3DDev->GetTextureStageState( 0, D3DTSS_ALPHAARG1, &dwAlpArg1_pre );
	hr = pD3DDev->GetTextureStageState( 0, D3DTSS_ALPHAARG2, &dwAlpArg2_pre );
	hr = pD3DDev->GetTextureStageState( 0, D3DTSS_ALPHAOP,	 &dwAlpRop_pre );

	// Set renderstates (disable z-buffering, enable stencil, disable fog, and
	// turn on alphablending)
	hr = pD3DDev->SetRenderState( D3DRS_ZENABLE,		  FALSE );
	hr = pD3DDev->SetRenderState( D3DRS_STENCILENABLE,	  TRUE );
	hr = pD3DDev->SetRenderState( D3DRS_FOGENABLE,		  FALSE );
	hr = pD3DDev->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
	hr = pD3DDev->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );
	hr = pD3DDev->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );

	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_COLOROP,	 D3DTOP_MODULATE );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_ALPHAOP,	 D3DTOP_MODULATE );

	// Only write where stencil val >= 1 (count indicates # of shadows that
	// overlap that pixel)
	hr = pD3DDev->SetRenderState( D3DRS_STENCILREF,  0x1 );
	hr = pD3DDev->SetRenderState( D3DRS_STENCILFUNC, D3DCMP_LESSEQUAL );
	hr = pD3DDev->SetRenderState( D3DRS_STENCILPASS, D3DSTENCILOP_KEEP );

	// Draw a big, gray square
	hr = pD3DDev->SetFVF( FVF_VERTEX_SHADOW );
	hr = pD3DDev->SetStreamSource( 0, m_pBigSquareVB, 0, sizeof(VERTEX_SHADOW) );
	hr = pD3DDev->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );

	// Restore render states
	hr = pD3DDev->SetRenderState(D3DRS_ZENABLE, 	  dwZ_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILENABLE, dwStencil_pre);
	hr = pD3DDev->SetRenderState(D3DRS_FOGENABLE,	  dwFog_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILFUNC,   dwStcFunc_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILREF,	  dwStcRef_pre);
	hr = pD3DDev->SetRenderState(D3DRS_STENCILPASS,   dwStcPass_pre);
	hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, dwEnableAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_SRCBLEND,  dwSrcAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_DESTBLEND, dwDestAlpha_pre);
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_COLORARG1, dwClrArg1_pre );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_COLORARG2, dwClrArg2_pre );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_COLOROP,	 dwClrRop_pre );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_ALPHAARG1, dwAlpArg1_pre );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_ALPHAARG2, dwAlpArg2_pre );
	hr = pD3DDev->SetTextureStageState( 0, D3DTSS_ALPHAOP,	 dwAlpRop_pre );

	return hr;
}

#endif