// b`
#ifndef _TALK_H_
#define _TALK_H_

#include <d3dx9.h>
#include <mbstring.h>
#include "dib_buf.h"
#include "dib_buf2.h"
#include "d_music.h"
#include "macro.h"

typedef struct
{
	WORD	idxChar;	// ԍi[z
	POINT	posDst; 	// o͈ʒui[z
	BYTE	byteFont;	// oCgHi1:PoCg, 2:QoCgj
	short	idxWave;	// ʉԍi[s
	short	idxBGM; 	// BGM ԍi[s
	short	index;		// Cxgԍi[s
	short	idxSpeed;	// xi[s
	int 	wait;		// ҂Ԋi[s
	WORD	cord;		// QoCgR[hi[z
}TALKINF,*LPTALKINF;

class CTalk
{
public:
	CTalk();
	~CTalk() { Free(); }
	// ieNX`j
	HRESULT Init(LPDIRECT3DDEVICE9 pD3DDev, int iWidth, int iHeight, LOGFONT lFont);
	// it@Cǂݍ݁j
	HRESULT Init(LPDIRECT3DDEVICE9 pD3DDev, char *strFilenameTexture, LOGFONT lFont);
	// I
	void	Free();
	// eNX`֕`
	int 	DrawToTexture(unsigned char *words, RECT *rc, int font_size,
							BYTE red, BYTE green, BYTE blue, int letter_speed,
							bool *flag_next, int *letter_ct,
							BYTE back_red = 0, BYTE back_green = 0, BYTE back_blue = 0);
	// eNX`擾
	LPDIRECT3DTEXTURE9	GetTexture() { return m_pTex; }
	// eNX`擾
	int 				GetWidth() { return m_iWidth; }
	// eNX`擾
	int 				GetHeight() { return m_iHeight; }
	// Cxgԍ擾
	int 				GetIndex() { return m_index; }
	
private:
	CDib*				m_bmDst;
	CDib*				m_bmWork;
	LPDIRECT3DTEXTURE9	m_pTex;
	LPDIRECT3DSURFACE9	m_pSurface;
	LPTALKINF			m_pInf;
	int 				m_iWidth;
	int 				m_iHeight;
	bool				m_bTalkWait;			// \~tO
	long				m_iTickCountTalkWait;	// b҂ԃJEg
	int 				m_iTalkWait;			// bR}h̑҂
	int 				m_index;				// Cxgԍ
	WORD				m_wColorBackground; 	// wiF
	bool				m_bFile;				// t@Cǂݍ݂̏ꍇ true
	LOGFONT 			m_lFont;
	char				m_strFilenameTexture[MAX_PATH];
	
private:
	void	Talk_Sub(CDib *buf, RECT rc, bool *flag_all_put_out, bool *flag_end_page,
					bool *flag_end_all, int next_idx, int *next_idx2, int numLineMax,
					int *letter_ct, int font_size, BYTE r, BYTE g, BYTE b, int letter_speed,
					unsigned char *words);
	int 	Get_FontWidthMax(HDC hDC, int size);
	void	TalkWait();
	bool	GetTiming(UINT anim_speed, long *TickCount);
};

CTalk::CTalk()
{
	m_bmDst = NULL;
	m_bmWork = NULL;
	m_pTex = NULL;
	m_pSurface = NULL;
	m_pInf = NULL;
	m_iWidth = 0;
	m_iHeight = 0;
	m_bTalkWait = false;
	m_iTickCountTalkWait = 0;
	m_iTalkWait = 0;
	m_index = -2;
	m_wColorBackground = 0;
	m_bFile = false;
	ZeroMemory(&m_lFont, sizeof(m_lFont));
	ZeroMemory(m_strFilenameTexture, sizeof(m_strFilenameTexture));
}

// ieNX`j
// pD3DDev		: [IN] IDirect3DDevice9 IuWFNg
// iWidth		: [IN] 
// iHeight		: [IN] 
// lFont		: [IN] tHg
HRESULT CTalk::Init(LPDIRECT3DDEVICE9 pD3DDev, int iWidth, int iHeight, LOGFONT lFont)
{
	HRESULT hr = E_FAIL;
	if(!pD3DDev)	return hr;
	Free();
	m_lFont 	= lFont;
	m_iWidth	= iWidth;
	m_iHeight	= iHeight;
	hr = D3DXCreateTexture(pD3DDev, iWidth, iHeight, 1, D3DUSAGE_DYNAMIC, D3DFMT_R5G6B5, D3DPOOL_DEFAULT, &m_pTex);
	if(m_pTex){
		hr = m_pTex->GetSurfaceLevel(0, &m_pSurface);
	}
	m_bmDst = new CDib(iWidth, iHeight);
	m_bFile = false;
	return hr;
}

// it@Cǂݍ݁j
// pD3DDev				: [IN] IDirect3DDevice9 IuWFNg
// strFilenameTexture	: [IN] eNX` t@C
// lFont				: [IN] tHg
HRESULT CTalk::Init(LPDIRECT3DDEVICE9 pD3DDev, char *strFilenameTexture, LOGFONT lFont)
{
	HRESULT hr = E_FAIL;
	if(!pD3DDev)	return hr;
	Free();
	strncpy(m_strFilenameTexture, strFilenameTexture, sizeof(m_strFilenameTexture));
	m_bmDst 	= new CDib(m_strFilenameTexture);
	m_lFont 	= lFont;
	m_iWidth	= m_bmDst->GetWidth();
	m_iHeight	= m_bmDst->GetHeight();
	hr = D3DXCreateTexture(pD3DDev, m_iWidth, m_iHeight, 1, D3DUSAGE_DYNAMIC, D3DFMT_R5G6B5, D3DPOOL_DEFAULT, &m_pTex);
	if(m_pTex){
		hr = m_pTex->GetSurfaceLevel(0, &m_pSurface);
	}
	m_bFile = true;
	return hr;
}

// I
void CTalk::Free()
{
	SAFE_DELETE(m_bmDst);
	SAFE_DELETE(m_bmWork);
	SAFE_DELETE_ARRAY(m_pInf);
	SAFE_RELEASE(m_pSurface);
	SAFE_RELEASE(m_pTex);
}

// eNX`֕`
// words			: [IN]		\镶
// rc				: [IN]		\`
// font_size		: [IN]		TCY
// red,green,blue	: [IN]		F
// letter_speed 	: [IN]		̕\x
// flag_next		: [IN][OUT] true  ̕\, false  ͖̕\
// letter_ct		: [IN][OUT] ݕ\̕iÓIϐB{Iɂ͏pj
// back_red 		: [IN]		wiFiԁj
// back_green		: [IN]		wiFi΁j
// back_blue		: [IN]		wiFij
// ߂l			:			2  Sďo͊, 1  y[W̏o͊, 0  ̑
int CTalk::DrawToTexture(unsigned char *words, RECT *rc, int font_size,
						BYTE red, BYTE green, BYTE blue, int letter_speed,
						bool *flag_next, int *letter_ct,
						BYTE back_red, BYTE back_green, BYTE back_blue)
{
	if(!words || !flag_next){
		return 1;
	}
	
	// gƕ̕`
	static bool flag_end_all = false;		// Sďo͊tO
	static bool flag_end_page = false;		// y[W̏o͊tO
	static bool flag_all_put_out = false;	// S\tO
	static int	next_idx = 0;				// y[W̍ŏ̕ԍ
	static int	next_idx2 = 0;				// y[W̍ŏ̕ԍ
	static int	numLineMax = 0; 			// ő\\s
	static RECT rc2 = {0 ,0, 0, 0}; 		// `
	int 		ret;						// ߂l
	
	if(*letter_ct == -1){	// s
		if(rc){
			rc2 = *rc;
		}
		else{
			SetRect(&rc2, 0, 0, m_iWidth, m_iHeight);
		}
		numLineMax = (rc2.bottom - rc2.top) / font_size;
		next_idx = 0;
		flag_end_all = false;
		flag_end_page = false;
		flag_all_put_out = false;
		*letter_ct = 0;
		m_wColorBackground = DIB_RGB_MAKE(back_red, back_green, back_blue);
		if(!m_bFile){
			DIB_DrawBackCls(m_bmDst, m_wColorBackground);
		}
	}
	
	if(!flag_end_all || *letter_ct == -1){
		if(*flag_next){
			// ꎚ\ɃXy[XL[ꂽƂ͑S\
			if(!flag_end_page && words){
				flag_all_put_out = true;
				*flag_next = false;
			}
		}
		// y[Wɐi
		if(*flag_next && words){
			*flag_next = false;
			flag_end_page = false;
			next_idx = next_idx2;
		}
		// ̕\
		if(words){
			Talk_Sub(m_bmDst, rc2, &flag_all_put_out, &flag_end_page, &flag_end_all,
					next_idx, &next_idx2, numLineMax, letter_ct, font_size,
					red, green, blue, letter_speed, words);
			// eNX`ɕ`
			static int letter_ct_pre = -2;
			if(m_pSurface && m_bmDst && (letter_ct_pre != *letter_ct)){
				letter_ct_pre = *letter_ct;
				HRESULT hr;
				HDC 	hDC;
				hr = m_pSurface->GetDC(&hDC);
				BitBlt(hDC, 0, 0, m_iWidth, m_iHeight, m_bmDst->GetHDC(), 0, 0, SRCCOPY);
				m_pSurface->ReleaseDC(hDC);
			}
		}
	}
	if(flag_end_all){
		ret = 2;
	}
	else if(flag_end_page){
		ret = 1;
	}
	else{
		ret = 0;
	}
	if(ret > 0){
		if(m_bFile){
			DIB_ReLoadFile(m_bmDst, 0, 0, m_strFilenameTexture, 0, 0, m_iWidth, m_iHeight);
		}
		else{
			DIB_DrawBackCls(m_bmDst, m_wColorBackground);
		}
	}
	return ret;
}// DrawToTexture

void CTalk::Talk_Sub(CDib *buf, RECT rc, bool *flag_all_put_out, bool *flag_end_page,
					bool *flag_end_all, int next_idx, int *next_idx2, int numLineMax,
					int *letter_ct, int font_size, BYTE r, BYTE g, BYTE b, int letter_speed,
					unsigned char *words)
{
	if(!buf || !flag_end_page || !flag_end_all || !letter_ct){
		return;
	}
	
	static RECT rcTalk; 			// \`
	static int	letter_speed2 = 0;
	static int	widthFont = 0;		// P̕
	static int	idxChar_ct = 0;
	static int	inf_size = 0;
	int 		i;
	
	if(*letter_ct == 0){
		int len = strlen((char*) words);
		inf_size = len + 1;
		SAFE_DELETE_ARRAY(m_pInf);
		m_pInf = new TALKINF [inf_size];
		for(i=0;i<inf_size;i++){
			m_pInf[i].idxChar	= 0;
			m_pInf[i].posDst.x	= 0;
			m_pInf[i].posDst.y	= 0;
			m_pInf[i].byteFont	= 0;
			m_pInf[i].cord		= 0;
			m_pInf[i].idxWave	= -2;
			m_pInf[i].idxBGM	= -2;
			m_pInf[i].index 	= -2;
			m_pInf[i].idxSpeed	= -2;
			m_pInf[i].wait		= -2;
		}
		
		HDC hDC = CreateCompatibleDC(NULL);
		widthFont = Get_FontWidthMax(hDC, font_size);
		DeleteDC(hDC);
		rcTalk = rc;
		int width_ct = 0;	// Ps̕񕝂̘a
		int font_y = 0; 	// ̕\YW
		int word_ct = 0;
		int cord_ct = 0;
		idxChar_ct = 0;
		while(word_ct < len){
			int 	clen = _mbclen(words + word_ct);
			WORD	wc = 0;
			if(clen == 2){
				wc = words[word_ct] << 8 | words[word_ct + 1];
			}
			else{
				wc = words[word_ct] << 8;
			}
			word_ct += clen;
			if(wc != 0){	// kł͂Ȃꍇ
				bool flag1 = false;
				for(int i=0;i<cord_ct;i++){
					if(wc == m_pInf[i].cord){
						flag1 = true;
						m_pInf[idxChar_ct].idxChar = i;
						int widthFont2 = widthFont * m_pInf[i].byteFont / 2;
						if(width_ct + widthFont2 > rcTalk.right - rcTalk.left){ // s̏ꍇ
							width_ct = 0;
							font_y += font_size;
							if((font_y / font_size) >= numLineMax){ // y[W̍Ō܂ŗꍇ
								font_y = 0;
							}
						}
						m_pInf[idxChar_ct].posDst.x = width_ct;
						m_pInf[idxChar_ct].posDst.y = font_y;
						width_ct += widthFont2;
						idxChar_ct ++;
						break;
					}
				}
				if(!flag1){ // o^̏ꍇ
					if((char)(wc >> 8) == '<'){ // < ̏ꍇ͉bR}h
						char strCmd[256] = "";
						char strCmd2[256] = "";
						char *p = strchr((char*) &words[word_ct], '>');
						int len = p - (char*) &words[word_ct] + 1;	// 
						strncpy(strCmd, (char*) &words[word_ct], len - 1);
						int idxCmd = -1;
						int idxCmd2 = -1;
						int idxCmd3 = -1;
						int idxCmd4 = -1;
						int idxCmd5 = -1;
						sscanf(strCmd, "%s", strCmd2);
						if(!stricmp(strCmd2, "wave")){			// ʉĐ
							sscanf(strCmd, "%s %d", strCmd2, &idxCmd);
							m_pInf[idxChar_ct].idxWave = idxCmd;
						}
						else if(!stricmp(strCmd2, "midi")){ 	// BGM Đ
							sscanf(strCmd, "%s %d", strCmd2, &idxCmd);
							m_pInf[idxChar_ct].idxBGM = idxCmd;
						}
						else if(!stricmp(strCmd2, "index")){	// ݒ
							sscanf(strCmd, "%s %d", strCmd2, &idxCmd);
							m_pInf[idxChar_ct].index = idxCmd;
						}
						else if(!stricmp(strCmd2, "speed")){	// xݒ
							sscanf(strCmd, "%s %d", strCmd2, &idxCmd);
							m_pInf[idxChar_ct].idxSpeed = idxCmd;
						}
						else if(!stricmp(strCmd2, "wait")){ 	// ҂
							sscanf(strCmd, "%s %d", strCmd2, &idxCmd);
							m_pInf[idxChar_ct].wait = idxCmd;
						}
						word_ct += len;
					}
					else if((char)(wc >> 8) == '*'){	// AX^XN̏ꍇ͉y[W
						width_ct = 0;
						font_y = 0;
					}
					else if((char)(wc >> 8) == '\n'){	// s̏ꍇ
						width_ct = 0;
						font_y += font_size;
						if((font_y / font_size) >= numLineMax){ // y[W̍Ō܂ŗꍇ
							font_y = 0;
						}
					}
					else{
						m_pInf[cord_ct].cord = wc;
						m_pInf[idxChar_ct].idxChar = cord_ct;
						m_pInf[cord_ct].byteFont = clen;
						cord_ct ++;
						int widthFont2 = widthFont * clen / 2;
						if(width_ct + widthFont2 > rcTalk.right - rcTalk.left){ // s̏ꍇ
							width_ct = 0;
							font_y += font_size;
							if((font_y / font_size) >= numLineMax){ // y[W̍Ō܂ŗꍇ
								font_y = 0;
							}
						}
						m_pInf[idxChar_ct].posDst.x = width_ct;
						m_pInf[idxChar_ct].posDst.y = font_y;
						width_ct += widthFont2;
						idxChar_ct ++;
					}
				}
			}
		}
		// DIB ɕ`
		SAFE_DELETE(m_bmWork);
		m_bmWork = new CDib(widthFont * cord_ct, font_size);
		DIB_DrawBackCls(m_bmWork, m_wColorBackground);
		if(m_bFile){
			m_bmWork->SetColKey(m_wColorBackground);
		}
		char str[3] = "";
		for(i=0;i<cord_ct;i++){
			switch(m_pInf[i].byteFont)
			{
			case 1: // PoCg̏ꍇ
				str[0] = (char)(m_pInf[i].cord >> 8);
				str[1] = '\0';
				str[2] = '\0';
				break;
			case 2: // QoCg̏ꍇ
				str[0] = (char)(m_pInf[i].cord >> 8);
				str[1] = (char)m_pInf[i].cord;
				str[2] = '\0';
				break;
			}
			DIB_DrawFont(m_bmWork, str, font_size, widthFont * i, 0, r, g, b);
		}
		// x̏
		letter_speed2 = letter_speed;
	}
	if(letter_speed2 > 0){
		static long TickCountLetter = GetTickCount();
		bool		flag_letter = GetTiming(letter_speed2, &TickCountLetter);
		if((flag_letter || *flag_all_put_out) && !m_bTalkWait){
			if(*letter_ct < idxChar_ct - 1 && !(*flag_end_page)){
				(*letter_ct) ++;
			}
			if(*letter_ct >= inf_size - 1){
				(*letter_ct) --;
				*flag_end_all = true;
			}
		}
		for(i=next_idx;i<=*letter_ct;i++){
			DIB_DrawRect(buf, rcTalk.left + m_pInf[i].posDst.x, rcTalk.top + m_pInf[i].posDst.y, m_bmWork, widthFont * m_pInf[i].idxChar, 0, widthFont * m_pInf[i].idxChar + (widthFont * m_pInf[m_pInf[i].idxChar].byteFont / 2), font_size);
		}
		if(m_pInf[(*letter_ct) + 1].idxWave > -2){
			PlaySND(m_pInf[(*letter_ct) + 1].idxWave);
			m_pInf[(*letter_ct) + 1].idxWave = -2;
		}
		if(m_pInf[(*letter_ct) + 1].idxBGM > -2){
			PlayBGM(m_pInf[(*letter_ct) + 1].idxBGM);
			m_pInf[(*letter_ct) + 1].idxBGM = -2;
		}
		if(m_pInf[(*letter_ct) + 1].index > -2){
			m_index = m_pInf[(*letter_ct) + 1].index;
			m_pInf[(*letter_ct) + 1].index = -2;
		}
		if(m_pInf[(*letter_ct) + 1].idxSpeed > -2){
			if(m_pInf[(*letter_ct) + 1].idxSpeed > 0){
				letter_speed2 = m_pInf[(*letter_ct) + 1].idxSpeed;
			}
			else{
				letter_speed2 = letter_speed;
			}
			m_pInf[(*letter_ct) + 1].idxSpeed = -2;
		}
		if(m_pInf[(*letter_ct) + 1].wait > -2){
			m_iTickCountTalkWait = GetTickCount();
			m_iTalkWait = m_pInf[(*letter_ct) + 1].wait;
			m_bTalkWait = true;
			m_pInf[(*letter_ct) + 1].wait = -2;
		}
		if(flag_letter || *flag_all_put_out){
			// Sďo͂Iׂ
			if(*letter_ct >= idxChar_ct - 1){
				*flag_end_all = true;
				*flag_all_put_out = false;
			}
			// y[W̍ŌɗƂ
			if((m_pInf[*letter_ct].posDst.y > 0 || m_pInf[(*letter_ct) + 1].posDst.x == 0) && m_pInf[(*letter_ct) + 1].posDst.y == 0 && !(*flag_end_page) && !(*flag_end_all)){
				*flag_end_page = true;
				*flag_all_put_out = false;
				*next_idx2 = (*letter_ct) + 1;
			}
		}
	}
	// o͏I
	if(*flag_end_all){
	}
}// Talk_Sub

// tHgP̍ő啝擾
// size 	: [IN]	tHgTCY
// ߂l	:		tHgP̍ő啝
int CTalk::Get_FontWidthMax(HDC hDC, int size)
{
	int width = 0;
	
	if(!hDC){
		return width;
	}
	
	static HFONT	NewFont,OldFont;
	
	m_lFont.lfHeight	= size;
	
	NewFont = CreateFontIndirect(&m_lFont);
	OldFont = (HFONT)SelectObject(hDC, NewFont);
	
	TEXTMETRIC tm = {0};
	GetTextMetrics(hDC, &tm);
	width = tm.tmMaxCharWidth;
	
	SelectObject(hDC, OldFont);
	DeleteObject(NewFont);
	
	return width;
}// Get_FontWidthMax

// ҂
void CTalk::TalkWait()
{
	if(m_bTalkWait && m_iTalkWait > 0){
		if(GetTiming(m_iTalkWait, &m_iTickCountTalkWait)){
			m_bTalkWait = false;
		}
	}
	else{
		m_bTalkWait = false;
	}
}// TalkWait

// `̃^C~O
// anim_speed	: [IN]		`摬x
// TickCount	: [IN][OUT] ȑO̎
// ߂l		: true  , false  ܂
bool CTalk::GetTiming(UINT anim_speed, long *TickCount)
{
	bool flag_go;
	
	if(GetTickCount() - *TickCount >= anim_speed){
		flag_go = true;
		*TickCount = GetTickCount();
	}
	else{
		flag_go = false;
	}
	
	return flag_go;
}// GetTiming

#endif