// eNX`ɕ`
#ifndef _TEXT_H_
#define _TEXT_H_

#include <d3dx9.h>
#include <mbstring.h>
#include "macro.h"

class CText
{
public:
	CText();
	~CText() { Free(); }
	// ieNX`j
	HRESULT Init(LPDIRECT3DDEVICE9 pD3DDev, int iWidth, int iHeight, LOGFONT lFont, D3DCOLOR colorBack = 0);
	// it@Cǂݍ݁j
	HRESULT Init(LPDIRECT3DDEVICE9 pD3DDev, char *strFilenameTexture, LOGFONT lFont);
	// I
	void	Free();
	// eNX`֕`
	HRESULT RenderToTexture(LPDIRECT3DDEVICE9 pD3DDev, char *words, RECT *rc,
							int font_size, D3DCOLOR font_color = 0xffffffff);
	// eNX`擾
	LPDIRECT3DTEXTURE9	GetTexture() { return m_pTex; }
	// eNX`擾
	int 				GetWidth() { return m_iWidth; }
	// eNX`擾
	int 				GetHeight() { return m_iHeight; }
	// tHg IuWFNg擾
	LPD3DXFONT			GetFont() { return m_pFont; }
	
private:
	LPDIRECT3DTEXTURE9	m_pTex;
	LPDIRECT3DSURFACE9	m_pSurface;
	LPDIRECT3DSURFACE9	m_pSurfaceCopy;
	LPD3DXFONT			m_pFont;
	int 				m_iWidth;
	int 				m_iHeight;
	RECT				m_rect;
	bool				m_bFile;	// t@Cǂݍ݂̏ꍇ true
	LOGFONT 			m_lFont;
};

CText::CText()
{
	m_pTex = NULL;
	m_pSurface = NULL;
	m_pSurfaceCopy = NULL;
	m_pFont = NULL;
	m_iWidth = 0;
	m_iHeight = 0;
	m_bFile = false;
	ZeroMemory(&m_rect, sizeof(m_rect));
	ZeroMemory(&m_lFont, sizeof(m_lFont));
}

// ieNX`j
// pD3DDev		: [IN] IDirect3DDevice9 IuWFNg
// iWidth		: [IN] 
// iHeight		: [IN] 
// lFont		: [IN] tHg
// colorBack	: [IN] wiF
HRESULT CText::Init(LPDIRECT3DDEVICE9 pD3DDev, int iWidth, int iHeight, LOGFONT lFont, D3DCOLOR colorBack)
{
	HRESULT hr = E_FAIL;
	if(!pD3DDev)	return hr;
	Free();
	hr = D3DXCreateTexture(pD3DDev, iWidth, iHeight, 1, D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, &m_pTex);
	if(m_pTex){
		hr = m_pTex->GetSurfaceLevel(0, &m_pSurface);
		LPDIRECT3DSURFACE9	pRenderTargetPre;
		hr = pD3DDev->GetRenderTarget(0, &pRenderTargetPre);
		hr = pD3DDev->SetRenderTarget(0, m_pSurface);
		hr = pD3DDev->Clear(0, NULL, D3DCLEAR_TARGET, colorBack, 0, 0);
		hr = pD3DDev->SetRenderTarget(0, pRenderTargetPre);
		D3DXLoadSurfaceFromSurface(m_pSurfaceCopy, NULL, NULL,
									m_pSurface, NULL, NULL, D3DX_FILTER_NONE, 0);
	}
	m_iWidth	= iWidth;
	m_iHeight	= iHeight;
	m_lFont 	= lFont;
	m_bFile 	= false;
	return hr;
}

// it@Cǂݍ݁j
// pD3DDev				: [IN] IDirect3DDevice9 IuWFNg
// strFilenameTexture	: [IN] eNX` t@C
// lFont				: [IN] tHg
HRESULT CText::Init(LPDIRECT3DDEVICE9 pD3DDev, char *strFilenameTexture, LOGFONT lFont)
{
	HRESULT 		hr = E_FAIL;
	D3DSURFACE_DESC desc;
	if(!pD3DDev)	return hr;
	Free();
	D3DXCreateTextureFromFileEx(pD3DDev, strFilenameTexture, 
				D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, 
				D3DPOOL_DEFAULT, D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 
				D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 0, NULL, NULL, &m_pTex);
	if(m_pTex){
		hr = m_pTex->GetSurfaceLevel(0, &m_pSurface);
		D3DXLoadSurfaceFromSurface(m_pSurfaceCopy, NULL, NULL,
									m_pSurface, NULL, NULL, D3DX_FILTER_NONE, 0);
		hr = m_pTex->GetLevelDesc(0, &desc);
	}
	m_iWidth	= desc.Width;
	m_iHeight	= desc.Height;
	m_lFont 	= lFont;
	m_bFile 	= true;
	return hr;
}

// I
void CText::Free()
{
	SAFE_RELEASE(m_pSurface);
	SAFE_RELEASE(m_pSurfaceCopy);
	SAFE_RELEASE(m_pTex);
	SAFE_RELEASE(m_pFont);
}

// eNX`֕`
// pD3DDev			: [IN] IDirect3DDevice9 IuWFNg
// words			: [IN] \镶
// rc				: [IN] \`
// font_size		: [IN] TCY
// font_color		: [IN] F
HRESULT CText::RenderToTexture(LPDIRECT3DDEVICE9 pD3DDev, char *words, RECT *rc,
							int font_size, D3DCOLOR font_color)
{
	if(!words){
		return E_FAIL;
	}
	
	HRESULT 	hr = E_FAIL;
	static char *words_pre = "";
	
	if(strcmp(words, words_pre)){	// 񂪕ς
		words_pre = words;
		SAFE_RELEASE(m_pFont);
		m_lFont.lfHeight = font_size;
		D3DXCreateFontIndirect(pD3DDev, &m_lFont, &m_pFont);
		if(rc){
			m_rect = *rc;
		}
		else{
			SetRect(&m_rect, 0, 0, m_iWidth, m_iHeight);
		}
		// ȑO̐ݒ擾
		LPDIRECT3DSURFACE9	pRenderTargetPre;
		hr = pD3DDev->GetRenderTarget(0, &pRenderTargetPre);
		if(FAILED(hr))
			return hr;
		// _O ^[Qbgݒ
		hr = pD3DDev->SetRenderTarget(0, m_pSurface);
		// eNX`_O
		if(SUCCEEDED(pD3DDev->BeginScene()))
		{
			hr = m_pFont->DrawText(words, -1, &m_rect, DT_EDITCONTROL, font_color);
			hr = pD3DDev->EndScene();
			D3DXLoadSurfaceFromSurface(m_pSurface, NULL, NULL,
									m_pSurfaceCopy, NULL, NULL, D3DX_FILTER_NONE, 0);
		}
		// ɖ߂
		hr = pD3DDev->SetRenderTarget(0, pRenderTargetPre);
	}
	return hr;
}// RenderToTexture

#endif