// eNX` _O
// l^FDirectX8 Tv
#ifndef _TEXTURE_RENDERING_H_
#define _TEXTURE_RENDERING_H_

#include <d3dx9.h>
#include "macro.h"

class CTexRend
{
public:
	CTexRend();
	virtual ~CTexRend();
	HRESULT Init(LPDIRECT3DDEVICE9 pD3DDev, DWORD width, DWORD height);
	HRESULT RenderToTexture(LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX *matView = NULL,
							D3DXMATRIX *matProj = NULL, D3DVIEWPORT9 *vp = NULL);
	virtual HRESULT RenderMesh(LPDIRECT3DDEVICE9 pD3DDev) = 0;
	LPDIRECT3DTEXTURE9	GetTexture() { return m_pTex; };
	void Free();
	
private:
	LPDIRECT3DTEXTURE9	m_pTex;
	LPDIRECT3DSURFACE9	m_pRenderTarget,m_pZBuf;
	LPDIRECT3DSURFACE9	m_pRenderTargetPre,m_pZBufPre;
	D3DVIEWPORT9		m_ViewPortPre;
	D3DXMATRIX			m_matViewPre,m_matProjPre;
};

CTexRend::CTexRend()
{
	m_pTex = NULL;
	m_pRenderTarget = NULL;
	m_pZBuf = NULL;
	m_pRenderTargetPre = NULL;
	m_pZBufPre = NULL;
}

CTexRend::~CTexRend()
{
	Free();
}

// _OeNX`쐬
// pTex    : [IN][OUT] 쐬eNX` IuWFNg
// pD3DDev : [IN]	   IDirect3DDevice9 IuWFNg
// width   : [IN]	   eNX`̕
// height  : [IN]	   eNX`̍
HRESULT CTexRend::Init(LPDIRECT3DDEVICE9 pD3DDev, DWORD width, DWORD height)
{
	if(!pD3DDev)
		return E_FAIL;
	
	Free();
	
	HRESULT  hr;
	hr = pD3DDev->CreateTexture(width, height, 0, 
								D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8,
								D3DPOOL_DEFAULT, &m_pTex, NULL);
	if(FAILED(hr))
		return hr;
	
	hr = m_pTex->GetSurfaceLevel(0, &m_pRenderTarget);
	if(FAILED(hr))
		return hr;
	
	hr = pD3DDev->CreateDepthStencilSurface(width, height, D3DFMT_D16,
								D3DMULTISAMPLE_NONE, 0, FALSE, &m_pZBuf, NULL);
	if(FAILED(hr))
		return hr;
	
	return hr;
}

// eNX`Ƀ_O
// pD3DDev	  : [IN] IDirect3DDevice9 IuWFNg
// matView	  : [IN] r[s
// matProj	  : [IN] vWFNVs
// vp		  : [IN] r[|[g
HRESULT CTexRend::RenderToTexture(LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX *matView,
									D3DXMATRIX *matProj, D3DVIEWPORT9 *vp)
{
	if(!pD3DDev)
		return E_FAIL;
	
	HRESULT hr;
	
	// ȑO̐ݒ擾
	hr = pD3DDev->GetTransform(D3DTS_VIEW, &m_matViewPre);
	hr = pD3DDev->GetTransform(D3DTS_PROJECTION, &m_matProjPre);
	hr = pD3DDev->GetRenderTarget(0, &m_pRenderTargetPre);
	hr = pD3DDev->GetDepthStencilSurface(&m_pZBufPre);
	hr = pD3DDev->GetViewport(&m_ViewPortPre);
	if(FAILED(hr))
		return hr;
	// r[sݒ
	if(matView)
		hr = pD3DDev->SetTransform(D3DTS_VIEW, matView);
	// vWFNVsݒ
	if(matProj)
		hr = pD3DDev->SetTransform(D3DTS_PROJECTION, matProj);
	// _O ^[Qbgݒ
	hr = pD3DDev->SetRenderTarget(0, m_pRenderTarget);
	hr = pD3DDev->SetDepthStencilSurface(m_pZBuf);
	// r[|[gݒ
	if(vp)
		pD3DDev->SetViewport(vp);
	// bV`
	hr = RenderMesh(pD3DDev);
	// ɖ߂
	hr = pD3DDev->SetRenderTarget(0, m_pRenderTargetPre);
	hr = pD3DDev->SetDepthStencilSurface(m_pZBufPre);
	hr = pD3DDev->SetTransform(D3DTS_VIEW, &m_matViewPre);
	hr = pD3DDev->SetTransform(D3DTS_PROJECTION, &m_matProjPre);
	hr = pD3DDev->SetViewport(&m_ViewPortPre);
	
	return hr;
}

void CTexRend::Free()
{
	SAFE_RELEASE(m_pTex);
	SAFE_RELEASE(m_pRenderTarget);
	SAFE_RELEASE(m_pZBuf);
	SAFE_RELEASE(m_pRenderTargetPre);
	SAFE_RELEASE(m_pZBufPre);
}

#endif