// Xt@C\ivO}v VF[_j
// l^FDirectX9 Tv d3dfile.cpp
#ifndef _FILE_X_SH_H_
#define _FILE_X_SH_H_

#include <d3dx9.h>
#include "macro.h"
#include "effect_sh.h"

class CFileXPS
{
public:
	CFileXPS();
	~CFileXPS();
	// Creation/destruction
	HRESULT Load( LPDIRECT3DDEVICE9 pD3DDev, char* strFilename, float fDepthBump = 1.0f );
	void	Free();
	// Rendering
	HRESULT Render( LPDIRECT3DDEVICE9 pD3DDev, LPEFFECTDATA data, CEffect *effect,
					bool bMaterial = TRUE, bool bTexture = TRUE );
	// Mesh access
	LPD3DXMESH GetMesh() { return m_pMesh; }
	// ڐxNgǉ
	HRESULT AddTangent( LPDIRECT3DDEVICE9 pD3DDev );
	// tO擾
	bool	GetFlagAlpha() { return m_bAlpha; };
	// ovtO擾
	bool	GetFlagBump() { return m_bBump; };

private:
	bool							m_bAlpha;
	bool							m_bBump;
	LPD3DXMESH						m_pMesh;
	DWORD							m_dwNumMaterials;
	D3DMATERIAL9*					m_pMaterials;
	LPDIRECT3DTEXTURE9* 			m_pTextures;
	LPDIRECT3DTEXTURE9* 			m_pTexturesBump;
};

CFileXPS::CFileXPS()
{
	m_bAlpha         = false;
	m_bBump          = false;
	m_pMesh          = NULL;
	m_dwNumMaterials = 0L;
	m_pMaterials     = NULL;
	m_pTextures      = NULL;
	m_pTexturesBump	 = NULL;
}

CFileXPS::~CFileXPS()
{
	Free();
}

// Xt@Cǂݍ
// strFilename : [IN] t@C
// fDepthBump  : [IN] ov̐[
HRESULT CFileXPS::Load( LPDIRECT3DDEVICE9 pD3DDev, char* strFilename, float fDepthBump )
{
	if(!pD3DDev)
		return E_FAIL;

	Free();

	LPD3DXBUFFER pAdjBuf = NULL;
	LPD3DXBUFFER pD3DXBuf = NULL;
	char		 *p,path[MAX_PATH],path2[MAX_PATH];
	DWORD		 i;
	HRESULT 	 hr;

	m_bAlpha = false;
	m_bBump  = false;

	// Load the mesh
	strcpy(path, strFilename);
	p = strrchr(path, '\\');
	if(p)
		strcpy(p, "\\");
	else
		strcpy(path, ".\\");
	if( FAILED( hr = D3DXLoadMeshFromX( strFilename, D3DXMESH_MANAGED, pD3DDev,
										&pAdjBuf, &pD3DXBuf, NULL,
										&m_dwNumMaterials, &m_pMesh ) ) )
	{
		return hr;
	}

	// @Ȃǉ
	if (!(m_pMesh->GetFVF() & D3DFVF_NORMAL))
	{
		LPD3DXMESH pTempMesh  = NULL;
		hr = m_pMesh->CloneMeshFVF(m_pMesh->GetOptions(), 
								m_pMesh->GetFVF() | D3DFVF_NORMAL, 
								pD3DDev, &pTempMesh);
		if (FAILED(hr))
			goto End;
		SAFE_RELEASE( m_pMesh );
		m_pMesh = pTempMesh;
		D3DXComputeNormals( m_pMesh, NULL );
	}

	// Optimize the mesh for performance
	if( FAILED( hr = m_pMesh->OptimizeInplace(
						D3DXMESHOPT_COMPACT | D3DXMESHOPT_ATTRSORT |
						D3DXMESHOPT_VERTEXCACHE | D3DXMESHOPT_DEVICEINDEPENDENT,
						(DWORD*)pAdjBuf->GetBufferPointer(), NULL, NULL, NULL ) ) )
	{
		goto End;
	}

	// Get material info for the mesh
	// Get the array of materials out of the buffer
	if( pD3DXBuf && m_dwNumMaterials > 0 )
	{
		// Allocate memory for the materials and textures
		D3DXMATERIAL* D3DXMtrls = (D3DXMATERIAL*)pD3DXBuf->GetBufferPointer();
		m_pMaterials = new D3DMATERIAL9[m_dwNumMaterials];
		if( m_pMaterials == NULL ){
			hr = E_OUTOFMEMORY;
			goto End;
		}
		m_pTextures  = new LPDIRECT3DTEXTURE9[m_dwNumMaterials];
		if( m_pTextures == NULL ){
			hr = E_OUTOFMEMORY;
			goto End;
		}
		m_pTexturesBump  = new LPDIRECT3DTEXTURE9[m_dwNumMaterials];
		if( m_pTexturesBump == NULL ){
			hr = E_OUTOFMEMORY;
			goto End;
		}

		// Copy each material and create its texture
		for( i=0; i<m_dwNumMaterials; i++ ){
			// Copy the material
			m_pMaterials[i] = D3DXMtrls[i].MatD3D;
			m_pMaterials[i].Ambient = m_pMaterials[i].Diffuse;
			m_pTextures[i]		= NULL;
			m_pTexturesBump[i]	= NULL;
			if(m_pMaterials[i].Diffuse.a < 1.0f){
				m_bAlpha = true;
			}

			// Create a texture
			if( D3DXMtrls[i].pTextureFilename ){
				strcpy(path2, path);
				strcat(path2, D3DXMtrls[i].pTextureFilename);
				if( FAILED( D3DXCreateTextureFromFile( pD3DDev, path2, &m_pTextures[i] ) ) )
				{
					m_pTextures[i] = NULL;
				}
				// Create a bump texture
				char *p2 = strrchr(path2, '.');
				if(p2){
					LPDIRECT3DTEXTURE9	pTex = NULL;
					D3DSURFACE_DESC		desc;
					strcpy(p2, "bump.png");
					if( FAILED( D3DXCreateTextureFromFile( pD3DDev, path2, &pTex ) ) )
					{
						pTex = NULL;
					}
					else{
						pTex->GetLevelDesc(0, &desc);
						D3DXCreateTexture(pD3DDev, desc.Width, desc.Height, 0, 0, D3DFMT_X8R8G8B8,
										D3DPOOL_MANAGED, &m_pTexturesBump[i]);
						if(m_pTexturesBump[i]){
							D3DXComputeNormalMap(m_pTexturesBump[i], pTex, NULL, 0,
												D3DX_CHANNEL_RED, fDepthBump);
						}
						m_bBump = true;
					}
					SAFE_RELEASE(pTex);
				}
			}
		}
	}
	if(m_bBump){
		AddTangent(pD3DDev);
	}
	hr = S_OK;

End:
	SAFE_RELEASE( pAdjBuf );
	SAFE_RELEASE( pD3DXBuf );

	return hr;
}// Load

// 
void CFileXPS::Free()
{
	UINT i;
	for( i=0; i<m_dwNumMaterials; i++ ){
		SAFE_RELEASE( m_pTextures[i] );
		SAFE_RELEASE( m_pTexturesBump[i] );
	}
	SAFE_DELETE_ARRAY( m_pTextures );
	SAFE_DELETE_ARRAY( m_pTexturesBump );
	SAFE_DELETE_ARRAY( m_pMaterials );
	SAFE_RELEASE( m_pMesh );
	m_dwNumMaterials = 0L;
	m_bAlpha		 = false;
}// Free

// bV`
// pD3DDev	 : [IN] IDirect3DDevice9 IuWFNg
// data		 : [IN] GtFNgɑf[^
// effect	 : [IN] GtFNg IuWFNg
// bMaterial : [IN] }eAKptO
// bTexture  : [IN] eLX`KptO
HRESULT CFileXPS::Render( LPDIRECT3DDEVICE9 pD3DDev, LPEFFECTDATA data, CEffect *effect,
						bool bMaterial, bool bTexture )
{
	if( !pD3DDev || !m_pMesh || !effect)
		return E_FAIL;
	// eNjbNI
	LPD3DXEFFECT pEffect = effect->GetEffectNoSkin();
	if(data->bBump){
		pEffect->SetTechnique("tecBumpDirectionalLight");
	}
	else{
		pEffect->SetTechnique("tecDirectionalLight");
	}
	// VF[_񑗐M
	effect->SetDataCommon(data);
	effect->SetDataNoSkin(data);
	// `
	UINT iPassCount;
	if(SUCCEEDED(pEffect->Begin(&iPassCount, 0))){
		if(SUCCEEDED(pEffect->Pass(0))){
			// Frist, draw the subsets without alpha
			DWORD i;
			for( i=0; i<m_dwNumMaterials; i++ ){
				if( m_pMaterials[i].Diffuse.a < 1.0f )
					continue;
				if( bMaterial ){
					pEffect->SetVector("v4Diffuse", (LPD3DXVECTOR4) &(m_pMaterials[i].Diffuse));
					pEffect->SetVector("v3Specular", (LPD3DXVECTOR4) &(m_pMaterials[i].Specular));
					pEffect->SetFloat("fSpecularPower", m_pMaterials[i].Power);
				}
				if( bTexture ){
					if(m_pTextures[i]){
						pEffect->SetBool("bTexture", true);
						pEffect->SetTexture("texMain", m_pTextures[i]);
					}
					else{
						pEffect->SetBool("bTexture", false);
					}
					pEffect->SetTexture("texBump", m_pTexturesBump[i]);
				}
				m_pMesh->DrawSubset( i );
			}
			// Then, draw the subsets with alpha
			for( i=0; i<m_dwNumMaterials; i++ ){
				if( m_pMaterials[i].Diffuse.a == 1.0f )
					continue;
				if( bMaterial ){
					pEffect->SetVector("v4Diffuse", (LPD3DXVECTOR4) &(m_pMaterials[i].Diffuse));
					pEffect->SetVector("v3Specular", (LPD3DXVECTOR4) &(m_pMaterials[i].Specular));
					pEffect->SetFloat("fSpecularPower", m_pMaterials[i].Power);
				}
				if( bTexture ){
					if(m_pTextures[i]){
						pEffect->SetBool("bTexture", true);
						pEffect->SetTexture("texMain", m_pTextures[i]);
					}
					else{
						pEffect->SetBool("bTexture", false);
					}
					pEffect->SetTexture("texBump", m_pTexturesBump[i]);
				}
				m_pMesh->DrawSubset( i );
			}
		}
		pEffect->End();
	}
	return S_OK;
}// Render

// ڐxNgǉ
HRESULT CFileXPS::AddTangent( LPDIRECT3DDEVICE9 pD3DDev )
{
	const D3DVERTEXELEMENT9 declBump[] =
	{
		{0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0},
		{0, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL,	  0},
		{0, 24, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TANGENT,  0},
		{0, 36, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BINORMAL, 0},
		{0, 48, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0},
		D3DDECL_END()
	};

	LPD3DXMESH pTempMesh  = NULL;

	if( m_pMesh ){
		if( FAILED( m_pMesh->CloneMesh( NULL, declBump, pD3DDev, &pTempMesh ) ) ){
			return E_FAIL;
		}
	}
	SAFE_RELEASE( m_pMesh );
	if( pTempMesh )  m_pMesh  = pTempMesh;
	if( m_pMesh ){
		// _錾ɐڐZo
		D3DXComputeTangent( m_pMesh, 0, 0, D3DX_DEFAULT, TRUE, NULL );
		// _錾ɏ]@Zo
		D3DXComputeTangent( m_pMesh, 0, D3DX_DEFAULT, 0, TRUE, NULL );
	}

	return S_OK;
}// AddTangent

#endif