// Xt@C Aj\ivO}v VF[_j
// l^FDirectX9 Tv
#ifndef _FILE_XANIM_SH_H_
#define _FILE_XANIM_SH_H_

#include <d3dx9.h>
#include "macro.h"
#include "meshcontainer_sh.h"
#include "effect_sh.h"

#pragma comment(lib,"winmm.lib")

class CFileXAnimPS
{
public:
	CFileXAnimPS();
	~CFileXAnimPS();

	// Creation/destruction
	HRESULT Load( LPDIRECT3DDEVICE9 pD3DDev, char* strFilename, float fDepthBump = 1.0f );
	void	Free();

	// Rendering
	HRESULT Render(LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX mtxWorld,
					LPEFFECTDATA data, CEffect *effect,
					bool bMaterial = true, bool bTexture = true);

	// Data access
	LPD3DXANIMATIONCONTROLLER GetAnimController() { return m_pAnimController; }
	int 					  GetNumAnimSet()	  { return m_numAnimSet; }
	int 					  GetIndexAnimeSet()  { return m_idxAnimeSet; }
	bool					  GetFlagAlpha()	  { return m_bAlpha; }
	bool					  GetFlagBump()		  { return m_bBump; }
	DWORD					  GetAnimIndexFromName(char *strAnimname);

private:
	D3DCAPS9					m_d3dCaps;
	CAllocateHierarchy* 		m_pAlloc;
	LPD3DXFRAME 				m_pFrameRoot;
	LPD3DXANIMATIONCONTROLLER	m_pAnimController;
	int 						m_numAnimSet;		// Aj[VZbg
	int 						m_idxAnimeSet;		// ݑIĂAj[VZbgԍ
	bool						m_bAlpha;			// tO
	bool						m_bBump;			// ov tO
	D3DXMATRIX					m_mtxWorld;			// [hs

private:
	HRESULT SetupBoneMatrixPointers(LPD3DXFRAME pFrame);
	HRESULT SetupBoneMatrixPointersOnMesh(LPD3DXMESHCONTAINER pMeshContainerBase);
	HRESULT DrawFrame(LPDIRECT3DDEVICE9 pD3DDev, LPD3DXFRAME pFrame,
						LPEFFECTDATA data, CEffect *effect,
						bool bMaterial, bool bTexture);
	void	DrawMeshContainer(LPDIRECT3DDEVICE9 pD3DDev,
								LPD3DXMESHCONTAINER pMeshContainerBase,
								LPD3DXFRAME pFrameBase,
								LPEFFECTDATA data, CEffect *effect,
								bool bMaterial, bool bTexture);
	HRESULT FrameMove(LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX mtxWorld);
	void	UpdateFrameMatrices(LPD3DXFRAME pFrameBase, LPD3DXMATRIX pParentMatrix);
};

CFileXAnimPS::CFileXAnimPS()
{
	ZeroMemory(&m_d3dCaps, sizeof(m_d3dCaps));
	m_pAlloc			= NULL;
	m_pFrameRoot		= NULL;
	m_pAnimController	= NULL;
	m_numAnimSet		= 0;
	m_idxAnimeSet		= 0;
	m_bAlpha			= false;
	m_bBump				= false;
}

CFileXAnimPS::~CFileXAnimPS()
{
	Free();
}

// Xt@Cǂݍ
// strFilename : [IN] t@C
HRESULT CFileXAnimPS::Load( LPDIRECT3DDEVICE9 pD3DDev, char* strFilename, float fDepthBump )
{
	if(!pD3DDev)
		return E_FAIL;
	
	Free();
	
	UINT i;
	
	pD3DDev->GetDeviceCaps(&m_d3dCaps);
	
	m_pAlloc = new CAllocateHierarchy;
	
	char *p,path[MAX_PATH];
	strcpy(path, strFilename);
	p = strrchr(path, '\\');
	if(p)
		strcpy(p, "\\");
	m_pAlloc->SetPath(path);
	m_pAlloc->SetDepthBump(fDepthBump);
	
	// X t@Cǂݍ
	if(FAILED(D3DXLoadMeshHierarchyFromX(strFilename, D3DXMESH_MANAGED, pD3DDev, m_pAlloc, NULL, &m_pFrameRoot, &m_pAnimController)))
		return E_FAIL;
	
	// {[sݒ
	if(FAILED(SetupBoneMatrixPointers(m_pFrameRoot)))
		return E_FAIL;
	
	// gbNɃAj[VZbg
	LPD3DXANIMATIONSET	pAnimSet = NULL;
	D3DXTRACK_DESC		Desc;
	ZeroMemory(&Desc, sizeof(Desc));
	Desc.Weight = 1;
	Desc.Speed	= 1;
	Desc.Enable = FALSE;
	m_numAnimSet = m_pAnimController->GetNumAnimationSets();
	for(i=1; i<(UINT)m_numAnimSet; i++){
		m_pAnimController->GetAnimationSet(i, &pAnimSet);
		m_pAnimController->SetTrackAnimationSet(i, pAnimSet);
		m_pAnimController->SetTrackDesc(i, &Desc);
		SAFE_RELEASE(pAnimSet);
	}
	m_pAnimController->SetTrackEnable(m_idxAnimeSet, TRUE);
	
	// tO擾
	m_bAlpha = m_pAlloc->GetFlagAlpha();
	
	// ov tO擾
	m_bBump = m_pAlloc->GetFlagBump();
	
	return S_OK;
}

// Ȃ
void CFileXAnimPS::Free()
{
	SAFE_RELEASE(m_pAnimController);
	D3DXFrameDestroy(m_pFrameRoot, m_pAlloc);
	SAFE_DELETE(m_pAlloc);
	m_numAnimSet	= 0;
	m_idxAnimeSet	= 0;
	m_bAlpha		= false;
	m_bBump			= false;
}

// bV`
HRESULT CFileXAnimPS::Render(LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX mtxWorld,
							LPEFFECTDATA data, CEffect *effect,
							bool bMaterial, bool bTexture)
{
	HRESULT 				hr;
	
	hr = FrameMove(pD3DDev, mtxWorld);
	if(SUCCEEDED(hr)){
		m_mtxWorld = mtxWorld;
		hr = DrawFrame(pD3DDev, m_pFrameRoot, data, effect, bMaterial, bTexture);
	}
	
	return hr;
}

// AjAjԍ擾
DWORD CFileXAnimPS::GetAnimIndexFromName(char *strAnimname)
{
    LPD3DXANIMATIONSET	pAS;
    DWORD				i,index = -1;

    for(i=0; i<m_pAnimController->GetNumAnimationSets(); ++i)
    {
        if(FAILED(m_pAnimController->GetAnimationSet(i, &pAS)))
            continue;

        if(pAS->GetName() &&
			!strnicmp(pAS->GetName(), strAnimname, strlen(pAS->GetName())))
        {
            index = i;
            pAS->Release();
            break;
        }
        pAS->Release();
    }

    return index;
}

HRESULT CFileXAnimPS::SetupBoneMatrixPointers(LPD3DXFRAME pFrame)
{
	HRESULT hr;

	if (pFrame->pMeshContainer != NULL)
	{
		hr = SetupBoneMatrixPointersOnMesh(pFrame->pMeshContainer);
		if (FAILED(hr))
			return hr;
	}

	if (pFrame->pFrameSibling != NULL)
	{
		hr = SetupBoneMatrixPointers(pFrame->pFrameSibling);
		if (FAILED(hr))
			return hr;
	}

	if (pFrame->pFrameFirstChild != NULL)
	{
		hr = SetupBoneMatrixPointers(pFrame->pFrameFirstChild);
		if (FAILED(hr))
			return hr;
	}

	return S_OK;
}// SetupBoneMatrixPointers

HRESULT CFileXAnimPS::SetupBoneMatrixPointersOnMesh(LPD3DXMESHCONTAINER pMeshContainerBase)
{
	UINT iBone, cBones;
	D3DXFRAME_DERIVED *pFrame;

	D3DXMESHCONTAINER_DERIVED *pMeshContainer = (D3DXMESHCONTAINER_DERIVED*)pMeshContainerBase;

	// if there is a skinmesh, then setup the bone matrices
	if (pMeshContainer->pSkinInfo != NULL)
	{
		cBones = pMeshContainer->pSkinInfo->GetNumBones();

		pMeshContainer->ppBoneMatrixPtrs = new D3DXMATRIX*[cBones];
		if (pMeshContainer->ppBoneMatrixPtrs == NULL)
			return E_OUTOFMEMORY;

		for (iBone = 0; iBone < cBones; iBone++)
		{
			pFrame = (D3DXFRAME_DERIVED*)D3DXFrameFind(m_pFrameRoot, pMeshContainer->pSkinInfo->GetBoneName(iBone));
			if (pFrame == NULL)
				return E_FAIL;

			pMeshContainer->ppBoneMatrixPtrs[iBone] = &pFrame->CombinedTransformationMatrix;
		}

		// VertexShader p{[si[m
		pMeshContainer->pBoneMatricesVS = new D3DXMATRIX[pMeshContainer->pSkinInfo->GetNumBones()];
		if( pMeshContainer->pBoneMatricesVS == NULL ){
			return  E_OUTOFMEMORY;
		}
	}

	return S_OK;
}// SetupBoneMatrixPointersOnMesh

HRESULT CFileXAnimPS::DrawFrame(LPDIRECT3DDEVICE9 pD3DDev, LPD3DXFRAME pFrame,
								LPEFFECTDATA data, CEffect *effect,
								bool bMaterial, bool bTexture)
{
	if(!pD3DDev || !pFrame)
		return E_FAIL;

	LPD3DXMESHCONTAINER pMeshContainer;

	pMeshContainer = pFrame->pMeshContainer;
	while (pMeshContainer != NULL)
	{
		DrawMeshContainer(pD3DDev, pMeshContainer, pFrame, data, effect, bMaterial, bTexture);

		pMeshContainer = pMeshContainer->pNextMeshContainer;
	}

	if (pFrame->pFrameSibling != NULL)
	{
		DrawFrame(pD3DDev, pFrame->pFrameSibling, data, effect, bMaterial, bTexture);
	}

	if (pFrame->pFrameFirstChild != NULL)
	{
		DrawFrame(pD3DDev, pFrame->pFrameFirstChild, data, effect, bMaterial, bTexture);
	}

	return S_OK;
}// DrawFrame

void CFileXAnimPS::DrawMeshContainer(LPDIRECT3DDEVICE9 pD3DDev,
									LPD3DXMESHCONTAINER pMeshContainerBase,
									LPD3DXFRAME pFrameBase,
									LPEFFECTDATA data, CEffect *effect,
									bool bMaterial, bool bTexture)
{
	D3DXMESHCONTAINER_DERIVED	*pMeshContainer = (D3DXMESHCONTAINER_DERIVED*)pMeshContainerBase;
	D3DXFRAME_DERIVED			*pFrame = (D3DXFRAME_DERIVED*)pFrameBase;
	LPD3DXBONECOMBINATION		pBoneComb;
	UINT						iMaterial;
	UINT						iAttrib;
	UINT						iMatrixIndex;
	UINT						iPaletteEntry;
	D3DXMATRIX					matTemp;

	if(pMeshContainer->pSkinInfo != NULL){	// XL̏ꍇ
		LPD3DXEFFECT pEffectSkin = effect->GetEffectSkin();
		if(data->bBump){
			pEffectSkin->SetTechnique("tecSkinBumpDirectionalLight");
		}
		else{
			pEffectSkin->SetTechnique("tecSkinDirectionalLight");
		}
		pEffectSkin->SetMatrix("mtxViewProj", &(data->mtxView * data->mtxProjection));
	}
	else{
		LPD3DXEFFECT pEffectNoSkin = effect->GetEffectNoSkin();
		if(data->bBump){
			pEffectNoSkin->SetTechnique("tecBumpDirectionalLight");
		}
		else{
			pEffectNoSkin->SetTechnique("tecDirectionalLight");
		}
	}
	effect->SetDataCommon(data);
	if (pMeshContainer->pSkinInfo != NULL)
	{
		LPD3DXEFFECT pEffectSkin = effect->GetEffectSkin();
		pBoneComb = reinterpret_cast<LPD3DXBONECOMBINATION>( pMeshContainer->pBoneCombinationBuf->GetBufferPointer() );
		for( iAttrib = 0; iAttrib < pMeshContainer->NumAttributeGroups; iAttrib++ )
		{
			// first calculate all the world matrices
			for( iPaletteEntry = 0; iPaletteEntry < pMeshContainer->NumPaletteEntries; ++iPaletteEntry )
			{
				iMatrixIndex = pBoneComb[iAttrib].BoneId[iPaletteEntry];
				if( iMatrixIndex != UINT_MAX )
				{
					D3DXMatrixMultiply( &pMeshContainer->pBoneMatricesVS[iPaletteEntry],
										&pMeshContainer->pBoneOffsetMatrices[iMatrixIndex],
										pMeshContainer->ppBoneMatrixPtrs[iMatrixIndex] );
				}
			}
			pEffectSkin->SetMatrixArray( "mtxWorlds", pMeshContainer->pBoneMatricesVS,
									  pMeshContainer->NumPaletteEntries );

			// set material color properties 
			pEffectSkin->SetVector("v4Diffuse", (LPD3DXVECTOR4) &(pMeshContainer->pMaterials[pBoneComb[iAttrib].AttribId].MatD3D.Diffuse));
			pEffectSkin->SetVector("v3Specular", (LPD3DXVECTOR4) &(pMeshContainer->pMaterials[pBoneComb[iAttrib].AttribId].MatD3D.Specular));
			pEffectSkin->SetVector("fSpecularPower", (LPD3DXVECTOR4) &(pMeshContainer->pMaterials[pBoneComb[iAttrib].AttribId].MatD3D.Power));

			// setup the material of the mesh subset - REMEMBER to use the original pre-skinning attribute id to get the correct material id
			LPDIRECT3DTEXTURE9 pTex = pMeshContainer->ppTextures[pBoneComb[iAttrib].AttribId];
			if(pTex){
				pEffectSkin->SetBool("bTexture", true);
				pEffectSkin->SetTexture("texMain", pTex);
			}
			else{
				pEffectSkin->SetBool("bTexture", false);
			}
			LPDIRECT3DTEXTURE9 pTexBump = pMeshContainer->ppTexturesBump[pBoneComb[iAttrib].AttribId];
			pEffectSkin->SetTexture("texBump", pTexBump);

			// Set CurNumBones to select the correct vertex shader for the number of bones
			pEffectSkin->SetInt("CurNumBones", pMeshContainer->NumInfl - 1);

			// Start the effect now all parameters have been updated
			UINT numPasses;
			pEffectSkin->Begin( &numPasses, D3DXFX_DONOTSAVESTATE );
			for( UINT iPass = 0; iPass < numPasses; iPass++ )
			{
				if(SUCCEEDED(pEffectSkin->Pass(iPass)))
				{
					// draw the subset with the current world matrix palette and material state
					pMeshContainer->MeshData.pMesh->DrawSubset( iAttrib );
				}
			}
			pEffectSkin->End();
		}
	}
	else  // standard mesh, just draw it after setting material properties
	{
		data->mtxWorld = pFrame->CombinedTransformationMatrix * m_mtxWorld;
		effect->SetDataNoSkin(data);
		LPD3DXEFFECT pEffectNoSkin = effect->GetEffectNoSkin();
		UINT numPasses;
		pEffectNoSkin->Begin( &numPasses, D3DXFX_DONOTSAVESTATE );
		for( UINT iPass = 0; iPass < numPasses; iPass++ )
		{
			if(SUCCEEDED(pEffectNoSkin->Pass(iPass)))
			{
				for (iMaterial = 0; iMaterial < pMeshContainer->NumMaterials; iMaterial++)
				{
					if(bMaterial){
						pEffectNoSkin->SetVector("v4Diffuse",
						(LPD3DXVECTOR4) &(pMeshContainer->pMaterials[iMaterial].MatD3D.Diffuse));
						pEffectNoSkin->SetVector("v3Specular",
						(LPD3DXVECTOR4) &(pMeshContainer->pMaterials[iMaterial].MatD3D.Specular));
						pEffectNoSkin->SetVector("fSpecularPower",
						(LPD3DXVECTOR4) &(pMeshContainer->pMaterials[iMaterial].MatD3D.Power));
					}
					if(bTexture){
						LPDIRECT3DTEXTURE9 pTex = pMeshContainer->ppTextures[iMaterial];
						if(pTex){
							pEffectNoSkin->SetBool("bTexture", true);
							pEffectNoSkin->SetTexture("texMain", pTex);
						}
						else{
							pEffectNoSkin->SetBool("bTexture", false);
						}
						LPDIRECT3DTEXTURE9 pTexBump = pMeshContainer->ppTexturesBump[iMaterial];
						pEffectNoSkin->SetTexture("texBump", pTexBump);
					}
					pMeshContainer->MeshData.pMesh->DrawSubset(iMaterial);
				}
			}
		}
		pEffectNoSkin->End();
	}
}// DrawMeshContainer

HRESULT CFileXAnimPS::FrameMove(LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX mtxWorld)
{
	if(!pD3DDev || !m_pAnimController || !m_pFrameRoot)
		return E_FAIL;

	if (m_pAnimController != NULL){
		float			pass_seconds = 0;
		DWORD			now_time;
		static DWORD	pre_time = 0;

		now_time = timeGetTime();
		if(pre_time)
			pass_seconds = (float)(now_time - pre_time) / 1000.0f;
		pre_time = now_time;
		m_pAnimController->SetTime(m_pAnimController->GetTime() + pass_seconds);
	}

	UpdateFrameMatrices(m_pFrameRoot, &mtxWorld);

	return S_OK;
}// FrameMove

void CFileXAnimPS::UpdateFrameMatrices(LPD3DXFRAME pFrameBase, LPD3DXMATRIX pParentMatrix)
{
	D3DXFRAME_DERIVED *pFrame = (D3DXFRAME_DERIVED*)pFrameBase;

	if (pParentMatrix != NULL)
		D3DXMatrixMultiply(&pFrame->CombinedTransformationMatrix, &pFrame->TransformationMatrix, pParentMatrix);
	else
		pFrame->CombinedTransformationMatrix = pFrame->TransformationMatrix;

	if (pFrame->pFrameSibling != NULL)
	{
		UpdateFrameMatrices(pFrame->pFrameSibling, pParentMatrix);
	}

	if (pFrame->pFrameFirstChild != NULL)
	{
		UpdateFrameMatrices(pFrame->pFrameFirstChild, &pFrame->CombinedTransformationMatrix);
	}
}// UpdateFrameMatrices

#endif