// file_xanim.h pXt@Cǂݍ݃NXivO}v VF[_j
// l^FDirectX9 Tv
#ifndef _MESHCONTAINER_SH_H_
#define _MESHCONTAINER_SH_H_

#include <d3dx9.h>

struct D3DXFRAME_DERIVED: public D3DXFRAME
{
	D3DXMATRIXA16		 CombinedTransformationMatrix;
};

struct D3DXMESHCONTAINER_DERIVED: public D3DXMESHCONTAINER
{
	LPDIRECT3DTEXTURE9*  ppTextures;
	LPDIRECT3DTEXTURE9*  ppTexturesBump;
	
	// SkinMesh info
	LPD3DXMESH			 pOrigMesh;
	DWORD				 NumAttributeGroups; 
	DWORD				 NumInfl;
	LPD3DXBUFFER		 pBoneCombinationBuf;
	D3DXMATRIX**		 ppBoneMatrixPtrs;
	D3DXMATRIX* 		 pBoneOffsetMatrices;
	D3DXMATRIX* 		 pBoneMatricesVS;		// {[si_VF[_Ŏgpj
    DWORD				 NumPaletteEntries;
};

class CAllocateHierarchy : public ID3DXAllocateHierarchy
{
public:
	STDMETHOD(CreateFrame)(THIS_ LPCTSTR Name, LPD3DXFRAME *ppNewFrame);
	STDMETHOD(CreateMeshContainer)(THIS_ LPCTSTR Name, LPD3DXMESHDATA pMeshData,
						LPD3DXMATERIAL pMaterials, LPD3DXEFFECTINSTANCE pEffectInstances,
						DWORD NumMaterials, DWORD *pAdjacency, LPD3DXSKININFO pSkinInfo,
						LPD3DXMESHCONTAINER *ppNewMeshContainer);
	STDMETHOD(DestroyFrame)(THIS_ LPD3DXFRAME pFrameToFree);
	STDMETHOD(DestroyMeshContainer)(THIS_ LPD3DXMESHCONTAINER pMeshContainerBase);
	// Xt@C pXݒ
	void	SetPath(char *strPath) { strcpy(m_strPath, strPath); }
	// ov[xݒ
	void	SetDepthBump(float fDepthBump) { m_fDepthBump = fDepthBump; }
	// tO擾
	bool	GetFlagAlpha()	  { return m_bAlpha; }
	// ov tO擾
	bool	GetFlagBump() { return m_bBump; }
	// RXgN^
	CAllocateHierarchy()
	{
		m_fDepthBump = 0.0f;
		m_bAlpha = false;
		m_bBump = false;
	}

private:
	char	m_strPath[MAX_PATH];	// Xt@C pX
	float	m_fDepthBump;			// ov[x
	bool	m_bAlpha;				// tO
	bool	m_bBump;				// ov tO

private:
	HRESULT AllocateName(LPCTSTR Name, LPTSTR *pNewName);
	HRESULT GenerateSkinnedMesh(LPDIRECT3DDEVICE9 pd3dDevice,
								D3DXMESHCONTAINER_DERIVED *pMeshContainer);
	HRESULT AddTangent( LPD3DXMESH *pMesh, LPDIRECT3DDEVICE9 pD3DDev,
						D3DVERTEXELEMENT9 *decl );
};

HRESULT CAllocateHierarchy::CreateFrame(LPCTSTR Name, LPD3DXFRAME *ppNewFrame)
{
	HRESULT hr = S_OK;
	D3DXFRAME_DERIVED *pFrame;

	*ppNewFrame = NULL;

	pFrame = new D3DXFRAME_DERIVED;
	if (pFrame == NULL)
	{
		hr = E_OUTOFMEMORY;
		goto e_Exit;
	}

	hr = AllocateName(Name, &pFrame->Name);
	if (FAILED(hr))
		goto e_Exit;

	// initialize other data members of the frame
	D3DXMatrixIdentity(&pFrame->TransformationMatrix);
	D3DXMatrixIdentity(&pFrame->CombinedTransformationMatrix);

	pFrame->pMeshContainer = NULL;
	pFrame->pFrameSibling = NULL;
	pFrame->pFrameFirstChild = NULL;

	*ppNewFrame = pFrame;
	pFrame = NULL;
e_Exit:
	delete pFrame;
	return hr;
}// CAllocateHierarchy::CreateFrame

HRESULT CAllocateHierarchy::CreateMeshContainer(LPCTSTR Name, LPD3DXMESHDATA pMeshData,
							LPD3DXMATERIAL pMaterials, LPD3DXEFFECTINSTANCE pEffectInstances,
							DWORD NumMaterials, DWORD *pAdjacency, LPD3DXSKININFO pSkinInfo, 
							LPD3DXMESHCONTAINER *ppNewMeshContainer) 
{
	HRESULT hr;
	D3DXMESHCONTAINER_DERIVED *pMeshContainer = NULL;
	UINT NumFaces;
	UINT iMaterial;
	UINT iBone, cBones;
	LPDIRECT3DDEVICE9 pd3dDevice = NULL;

	LPD3DXMESH pMesh = NULL;

	*ppNewMeshContainer = NULL;

	// this sample does not handle patch meshes, so fail when one is found
	if (pMeshData->Type != D3DXMESHTYPE_MESH)
	{
		hr = E_FAIL;
		goto e_Exit;
	}

	// get the pMesh interface pointer out of the mesh data structure
	pMesh = pMeshData->pMesh;

	// this sample does not FVF compatible meshes, so fail when one is found
	if (pMesh->GetFVF() == 0)
	{
		hr = E_FAIL;
		goto e_Exit;
	}

	// allocate the overloaded structure to return as a D3DXMESHCONTAINER
	pMeshContainer = new D3DXMESHCONTAINER_DERIVED;
	if (pMeshContainer == NULL)
	{
		hr = E_OUTOFMEMORY;
		goto e_Exit;
	}
	memset(pMeshContainer, 0, sizeof(D3DXMESHCONTAINER_DERIVED));

	// make sure and copy the name.  All memory as input belongs to caller, interfaces can be addref'd though
	hr = AllocateName(Name, &pMeshContainer->Name);
	if (FAILED(hr))
		goto e_Exit;

	// VF[_ o[W2.0łΏI
	pMesh->GetDevice(&pd3dDevice);
	D3DCAPS9 d3dCaps;
    pd3dDevice->GetDeviceCaps(&d3dCaps);
	if(d3dCaps.VertexShaderVersion < D3DVS_VERSION( 2, 0 )){
		goto e_Exit;
	}
	
	NumFaces = pMesh->GetNumFaces();

	// if no normals are in the mesh, add them
	if (!(pMesh->GetFVF() & D3DFVF_NORMAL))
	{
		pMeshContainer->MeshData.Type = D3DXMESHTYPE_MESH;

		// clone the mesh to make room for the normals
		hr = pMesh->CloneMeshFVF(pMesh->GetOptions(), 
								pMesh->GetFVF() | D3DFVF_NORMAL, 
								pd3dDevice, &pMeshContainer->MeshData.pMesh);
		if (FAILED(hr))
			goto e_Exit;

		// get the new pMesh pointer back out of the mesh container to use
		// NOTE: we do not release pMesh because we do not have a reference to it yet
		pMesh = pMeshContainer->MeshData.pMesh;

		// now generate the normals for the pmesh
		D3DXComputeNormals( pMesh, NULL );
	}
	else  // if no normals, just add a reference to the mesh for the mesh container
	{
		pMeshContainer->MeshData.pMesh = pMesh;
		pMeshContainer->MeshData.Type = D3DXMESHTYPE_MESH;

		pMesh->AddRef();
	}

	// allocate memory to contain the material information.  This sample uses
	//	 the D3D9 materials and texture names instead of the EffectInstance style materials
	pMeshContainer->NumMaterials   = max(1, NumMaterials);
	pMeshContainer->pMaterials     = new D3DXMATERIAL[pMeshContainer->NumMaterials];
	pMeshContainer->ppTextures     = new LPDIRECT3DTEXTURE9[pMeshContainer->NumMaterials];
	pMeshContainer->ppTexturesBump = new LPDIRECT3DTEXTURE9[pMeshContainer->NumMaterials];
	pMeshContainer->pAdjacency     = new DWORD[NumFaces*3];
	if ((pMeshContainer->pAdjacency == NULL) || (pMeshContainer->pMaterials == NULL))
	{
		hr = E_OUTOFMEMORY;
		goto e_Exit;
	}

	memcpy(pMeshContainer->pAdjacency, pAdjacency, sizeof(DWORD) * NumFaces*3);
	memset(pMeshContainer->ppTextures, 0, sizeof(LPDIRECT3DTEXTURE9) * pMeshContainer->NumMaterials);
	memset(pMeshContainer->ppTexturesBump, 0, sizeof(LPDIRECT3DTEXTURE9) * pMeshContainer->NumMaterials);

	// if materials provided, copy them
	if (NumMaterials > 0)
	{
		memcpy(pMeshContainer->pMaterials, pMaterials, sizeof(D3DXMATERIAL) * NumMaterials);

		for (iMaterial = 0; iMaterial < NumMaterials; iMaterial++)
		{
			if (pMeshContainer->pMaterials[iMaterial].pTextureFilename != NULL)
			{
				char strTexturePath[MAX_PATH];
				strcpy(strTexturePath, m_strPath);
				strcat(strTexturePath, pMeshContainer->pMaterials[iMaterial].pTextureFilename);
				if( FAILED( D3DXCreateTextureFromFile( pd3dDevice, strTexturePath,
														&pMeshContainer->ppTextures[iMaterial] ) ) )
					pMeshContainer->ppTextures[iMaterial] = NULL;


				// don't remember a pointer into the dynamic memory, just forget the name after loading
				pMeshContainer->pMaterials[iMaterial].pTextureFilename = NULL;
				// @}bv쐬
				char *p2 = strrchr(strTexturePath, '.');
				if(p2){
					LPDIRECT3DTEXTURE9	pTex = NULL;
					D3DSURFACE_DESC		desc;
					strcpy(p2, "bump.png");
					if(FAILED(D3DXCreateTextureFromFile(pd3dDevice, strTexturePath, &pTex))){
						pTex = NULL;
						pMeshContainer->ppTexturesBump[iMaterial] = NULL;
					}
					else{
						pTex->GetLevelDesc(0, &desc);
						D3DXCreateTexture(pd3dDevice, desc.Width, desc.Height, 0, 0,
										D3DFMT_X8R8G8B8, D3DPOOL_MANAGED,
										&pMeshContainer->ppTexturesBump[iMaterial]);
						if(pMeshContainer->ppTexturesBump[iMaterial]){
							D3DXComputeNormalMap(pMeshContainer->ppTexturesBump[iMaterial],
												pTex, NULL, 0, D3DX_CHANNEL_RED, m_fDepthBump);
						}
						m_bBump = true;
					}
					SAFE_RELEASE(pTex);
				}
			}
			pMeshContainer->pMaterials[iMaterial].MatD3D.Ambient = pMeshContainer->pMaterials[iMaterial].MatD3D.Diffuse;
			// }eA邩H
			if(pMeshContainer->pMaterials[iMaterial].MatD3D.Diffuse.a < 1.0f){
				m_bAlpha = true;
			}
		}
	}
	else // if no materials provided, use a default one
	{
		pMeshContainer->pMaterials[0].pTextureFilename = NULL;
		memset(&pMeshContainer->pMaterials[0].MatD3D, 0, sizeof(D3DMATERIAL9));
		pMeshContainer->pMaterials[0].MatD3D.Diffuse.r = 0.5f;
		pMeshContainer->pMaterials[0].MatD3D.Diffuse.g = 0.5f;
		pMeshContainer->pMaterials[0].MatD3D.Diffuse.b = 0.5f;
		pMeshContainer->pMaterials[0].MatD3D.Specular = pMeshContainer->pMaterials[0].MatD3D.Diffuse;
	}

	// if there is skinning information, save off the required data and then setup for HW skinning
	if (pSkinInfo != NULL)
	{
		// first save off the SkinInfo and original mesh data
		pMeshContainer->pSkinInfo = pSkinInfo;
		pSkinInfo->AddRef();

		pMeshContainer->pOrigMesh = pMesh;
		pMesh->AddRef();

		// Will need an array of offset matrices to move the vertices from the figure space to the bone's space
		cBones = pSkinInfo->GetNumBones();
		pMeshContainer->pBoneOffsetMatrices = new D3DXMATRIX[cBones];
		if (pMeshContainer->pBoneOffsetMatrices == NULL)
		{
			hr = E_OUTOFMEMORY;
			goto e_Exit;
		}

		// get each of the bone offset matrices so that we don't need to get them later
		for (iBone = 0; iBone < cBones; iBone++)
		{
			pMeshContainer->pBoneOffsetMatrices[iBone] = *(pMeshContainer->pSkinInfo->GetBoneOffsetMatrix(iBone));
		}

		// GenerateSkinnedMesh will take the general skinning information and transform it to a HW friendly version
		hr = GenerateSkinnedMesh(pd3dDevice, pMeshContainer);
		if (FAILED(hr))
			goto e_Exit;
	}

	// ڐxNgǉ
	if(m_bBump){
		const D3DVERTEXELEMENT9 declBump[] =
		{
			{ 0, 0,  D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
			{ 0, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL,   0 },
			{ 0, 24, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TANGENT,  0 },
			{ 0, 36, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
			D3DDECL_END()
		};
		const D3DVERTEXELEMENT9 declSkinBump[] =
		{
			{ 0, 0,  D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
			{ 0, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL,   0 },
			{ 0, 24, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TANGENT,  0 },
			{ 0, 36, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
			{ 0, 44, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDWEIGHT, 0 },
			{ 0, 60, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDINDICES, 0 },
			D3DDECL_END()
		};

		D3DVERTEXELEMENT9 *decl = NULL;
		if(!pMeshContainer->pSkinInfo)
			decl = (D3DVERTEXELEMENT9*) declBump;
		else
			decl = (D3DVERTEXELEMENT9*) declSkinBump;
		AddTangent(&(pMeshContainer->MeshData.pMesh), pd3dDevice, decl);
	}

	*ppNewMeshContainer = pMeshContainer;
	pMeshContainer = NULL;
e_Exit:
	SAFE_RELEASE(pd3dDevice);

	// call Destroy function to properly clean up the memory allocated 
	if (pMeshContainer != NULL)
	{
		DestroyMeshContainer(pMeshContainer);
	}
	
	return hr;
}// CAllocateHierarchy::CreateMeshContainer

HRESULT CAllocateHierarchy::DestroyFrame(LPD3DXFRAME pFrameToFree) 
{
	SAFE_DELETE_ARRAY( pFrameToFree->Name );
	SAFE_DELETE( pFrameToFree );
	return S_OK; 
}// CAllocateHierarchy::DestroyFrame

HRESULT CAllocateHierarchy::DestroyMeshContainer(LPD3DXMESHCONTAINER pMeshContainerBase)
{
	UINT iMaterial;
	D3DXMESHCONTAINER_DERIVED *pMeshContainer = (D3DXMESHCONTAINER_DERIVED*)pMeshContainerBase;

	SAFE_DELETE_ARRAY( pMeshContainer->Name );
	SAFE_DELETE_ARRAY( pMeshContainer->pAdjacency );
	SAFE_DELETE_ARRAY( pMeshContainer->pMaterials );
	SAFE_DELETE_ARRAY( pMeshContainer->pBoneOffsetMatrices );

	// release all the allocated textures
	if (pMeshContainer->ppTextures != NULL)
	{
		for (iMaterial = 0; iMaterial < pMeshContainer->NumMaterials; iMaterial++)
		{
			SAFE_RELEASE( pMeshContainer->ppTextures[iMaterial] );
		}
	}
	if (pMeshContainer->ppTexturesBump != NULL)
	{
		for (iMaterial = 0; iMaterial < pMeshContainer->NumMaterials; iMaterial++)
		{
			SAFE_RELEASE( pMeshContainer->ppTexturesBump[iMaterial] );
		}
	}

	SAFE_DELETE_ARRAY( pMeshContainer->ppTextures );
	SAFE_DELETE_ARRAY( pMeshContainer->ppTexturesBump );
	SAFE_DELETE_ARRAY( pMeshContainer->ppBoneMatrixPtrs );
	SAFE_DELETE_ARRAY( pMeshContainer->pBoneMatricesVS );
	SAFE_RELEASE( pMeshContainer->pBoneCombinationBuf );
	SAFE_RELEASE( pMeshContainer->MeshData.pMesh );
	SAFE_RELEASE( pMeshContainer->pSkinInfo );
	SAFE_RELEASE( pMeshContainer->pOrigMesh );
	SAFE_DELETE( pMeshContainer );
	return S_OK;
}// CAllocateHierarchy::DestroyMeshContainer

HRESULT CAllocateHierarchy::AllocateName( LPCTSTR Name, LPTSTR *pNewName )
{
	UINT cbLength;

	if (Name != NULL)
	{
		cbLength = lstrlen(Name) + 1;
		*pNewName = new TCHAR[cbLength];
		if (*pNewName == NULL)
			return E_OUTOFMEMORY;
		memcpy(*pNewName, Name, cbLength*sizeof(TCHAR));
	}
	else
	{
		*pNewName = NULL;
	}

	return S_OK;
}// AllocateName

HRESULT CAllocateHierarchy::GenerateSkinnedMesh(LPDIRECT3DDEVICE9 pd3dDevice,
												D3DXMESHCONTAINER_DERIVED *pMeshContainer)
{
	HRESULT hr = S_OK;

	if (pMeshContainer->pSkinInfo == NULL)
		return hr;

	SAFE_RELEASE( pMeshContainer->MeshData.pMesh );
	SAFE_RELEASE( pMeshContainer->pBoneCombinationBuf );

	UINT MaxMatrices = 26;

	pMeshContainer->NumPaletteEntries = min( MaxMatrices, pMeshContainer->pSkinInfo->GetNumBones() );

	SAFE_RELEASE( pMeshContainer->MeshData.pMesh );

	hr = pMeshContainer->pSkinInfo->ConvertToIndexedBlendedMesh
		(
		pMeshContainer->pOrigMesh,
		D3DXMESHOPT_VERTEXCACHE | D3DXMESH_MANAGED,
		pMeshContainer->NumPaletteEntries,
		pMeshContainer->pAdjacency,
		NULL, NULL, NULL,
		&pMeshContainer->NumInfl,
		&pMeshContainer->NumAttributeGroups,
		&pMeshContainer->pBoneCombinationBuf,
		&pMeshContainer->MeshData.pMesh );
	if( FAILED( hr ) )
		goto e_Exit;

	// FVF has to match our declarator. Vertex shaders are not as forgiving as FF pipeline
	DWORD NewFVF;
	NewFVF = ( pMeshContainer->MeshData.pMesh->GetFVF() & D3DFVF_POSITION_MASK ) | D3DFVF_NORMAL |
		D3DFVF_TEX1 | D3DFVF_LASTBETA_UBYTE4;
	if( NewFVF != pMeshContainer->MeshData.pMesh->GetFVF() )
	{
		LPD3DXMESH pMesh;
		hr = pMeshContainer->MeshData.pMesh->CloneMeshFVF( pMeshContainer->MeshData.pMesh->GetOptions(), NewFVF,
														   pd3dDevice, &pMesh );
		if( !FAILED( hr ) )
		{
			pMeshContainer->MeshData.pMesh->Release();
			pMeshContainer->MeshData.pMesh = pMesh;
			pMesh = NULL;
		}
	}

	D3DVERTEXELEMENT9 pDecl[MAX_FVF_DECL_SIZE];
	LPD3DVERTEXELEMENT9 pDeclCur;
	hr = pMeshContainer->MeshData.pMesh->GetDeclaration( pDecl );
	if( FAILED( hr ) )
		goto e_Exit;

	// the vertex shader is expecting to interpret the UBYTE4 as a D3DCOLOR, so update the type 
	//	 NOTE: this cannot be done with CloneMesh, that would convert the UBYTE4 data to float and then to D3DCOLOR
	//			this is more of a "cast" operation
	pDeclCur = pDecl;
	while( pDeclCur->Stream != 0xff )
	{
		if( ( pDeclCur->Usage == D3DDECLUSAGE_BLENDINDICES ) && ( pDeclCur->UsageIndex == 0 ) )
			pDeclCur->Type = D3DDECLTYPE_D3DCOLOR;
		pDeclCur++;
	}

	hr = pMeshContainer->MeshData.pMesh->UpdateSemantics( pDecl );
	if( FAILED( hr ) )
		goto e_Exit;

e_Exit:
	return hr;
}// GenerateSkinnedMesh

// ڐxNgǉ
HRESULT CAllocateHierarchy::AddTangent( LPD3DXMESH *pMesh, LPDIRECT3DDEVICE9 pD3DDev,
										D3DVERTEXELEMENT9 *decl )
{
	LPD3DXMESH pTempMesh  = NULL;

	if( *pMesh ){
		if( FAILED( (*pMesh)->CloneMesh( NULL, decl, pD3DDev, &pTempMesh ) ) ){
			return E_FAIL;
		}
	}

	SAFE_RELEASE( *pMesh );

	if( pTempMesh )  *pMesh  = pTempMesh;

	if( pMesh ){
		// _錾ɐڐZo
		D3DXComputeTangent( *pMesh, 0, 0, D3DX_DEFAULT, TRUE, NULL );
	}

	return S_OK;
}// AddTangent

#endif
